# Version 99.0 "Buka" 2026-05-24

## New features and enhancements

* MKVToolNix GUI: the GUI will now remember the last used directory for
  selecting audio files for playback in "play audio file" program runners
  separately from any other "open file"-type situations. This directory will
  also default to `/System/Library/Sounds` on macOS now. Implemented by #6213.
* MKVToolNix GUI: executing actions → running programs: added new variables:
  `MTX_DESTINATION_FILE_BASE_NAME` (the name without the drive letter, path or
  the suffix; e.b. `/movies/A.new.hope.mkv` → `A.new.hope`) and
  `MTX_DESTINATION_FILE_SUFFIX` (only the letters after the last `.`,
  e.g. `/movies/A.new.hope.mkv` → `mkv`). Added examples to all the
  destination file variables in the popup menu when adding variables in the
  preferences. Implements parts of #6220.
* MKVToolNix GUI: executing actions → running programs: the command-line input
  widget will now receive focus again after using the popup menu for adding a
  variable. Implements parts of #6220.
* MKVToolNix GUI: executing actions → running programs: the variables will now
  also be set as environment variables when running a program after a job
  completes.
* MKVToolNix GUI: executing actions → running programs: when using the
  "Execute now" button for testing the `MTX_…` variables will be set to the
  current multiplexer tab's values for easier testing. Implements parts of
  #6220.

## Bug fixes

* mkvmerge: if using legacy font MIME types is off mkvmerge will now remap
  legacy font MIME types present in source files into the current ones. Patch
  by corticalcode via #6249.
* mkvmerge, mkvpropedit, MKVToolNix GUI's multiplexer & header editor: on
  Windows & macOS the MIME type detection will now use the FreeDesktop.org
  MIME database instead of falling back to file extension-based guesses. This
  matches how it works on other operating systems. This fixes e.g. OpenType
  fonts being detected as the legacy type `application/vnd.ms-opentype`
  instead of the current IETF RFC, `font/otf`, no matter what the "use legacy
  font MIME types" settings in the preferences was set to. Fixes #6240 for
  Windows; fixes #6248 for macOS. Implemented by corticalcode for macOS in
  #6250.
* MKVToolNix GUI: update checker: fixed a potential attempt to read from an
  invalid memory address if an error occurred when parsing the XML file
  retrieved from the official MKVToolNix server.
* macOS: GUI: the default audio file for program runners of type "play audio
  file" has been changed to an AIFF file as Qt's Multimedia backend routes
  through Core Audio which doesn't support WebM/VP8/Vorbis/Opus. Existing
  configurations will be updated if they point to the prior default WebM audio
  file. Fixes #6209.

## Build system changes

* macOS: `build.sh`: the Qt installation is now done via `cmake --install`
  instead of using classic `make` as the classic Makefiles produced by Qt's
  build system are incomplete. Patch by corticalcode. Fixes #6205.
* macOS: `build.sh`: the binaries in the DMG are now stripped of debug
  symbols. Patch by corticalcode. Fixes #6206.
* macOS: `build.sh`: enabled release build optimizations for
  dependencies. Patch by corticalcode. Fixes #6207.
* macOS: `build.sh`: disabled use of `pkg-config` for Qt to prevent linking
  against installed non-OS libraries such as from Homebrew. Patch by
  corticalcode. Fixes #6208.
* macOS: added support for notarization of a macOS disk image by an Apple
  developer account. Implementation of #6212 by Touchstone64.
* macOS: patch added to make building Qt 6.11 from source possible on macOS
  26.4. Patch by Touchstone64.
* macOS: additions to DMG package naming including the machine type it targets
  (arm64 or x86_64) and a revision number (to support re-packaging of an
  existing MKVToolnix release). For example, MKVToolNix-98.0-1-arm64.dmg would
  represent the first revision of a DMG package for an Apple Silicon Mac,
  containing MKVToolNix release 98.0. Implementation by Touchstone64.
* macOS: the packaging process now verifies the MKVToolNix source release
  using the author's GPG key before packaging. Implementation by Touchstone64.
* macOS: the app bundle name has been standardised by removing the version
  number, so DMG packages will contain 'MKVToolNix.app'. Implementation by
  Touchstone64.
* macOS: Qt is now built without printing support, reducing the size of the
  resulting DMG slightly. Implementation by Corticalcode. Implements #6230.

# Version 98.0 "Chonks" 2026-04-05

## New features and enhancements

* all: huge update to the Japanese translations which had been not worked on
  for several years. The program translation is now complete again, the man
  page translation has been extended as well. Both were reworked in most
  places. Translations by coolvitto.
* GUI: chapter editor: added an option in the "additional modifications"
  dialog that toggles applying the selected modifications to all currently
  open chapter editor tabs. Implements #6189.
* GUI: macOS: added dock icon progress bar for job queue. Patch by Miklos
  Juhasz.

## Bug fixes

* GUI: chapter editor: when renumbering chapters limiting the number of
  chapters to renumber did not work. Fixes #6199.
* GUI: macOS: fixed refreshing widgets after system switches between dark &
  light modes. Patch by Miklos Juhasz.

## Build system changes

* The bundled `fmt` library was updated to v12.1.0, fixing a build issue on
  FreeBSD. Fixes #6191.


# Version 97.0 "You Don't Have A Clue" 2026-01-02

## New features and enhancements

* mkvmerge: MP4 reader: added support for TrueHD in MP4 with FourCC
  `mlpa`. Implements #6178.
* installer: the Windows installer will request admin permissions again, as it
  did before release 96.0.


# Version 96.0 "It's My Life" 2025-11-08

## New features and enhancements

* all programs: added a command-line parameter `--no-bom` that disables
  writing byte order marks to text files encoded with one of the UTF
  variants. Implements #6166.
* MKVToolNix GUI: multiplexer: added variable `<MTX_CHAPTERS_FILE_NAME>` to
  the "run program after job completion" mechanism containing the absolute
  path to the chapters file name. Implements #6172.

## Bug fixes

* mkvmerge: OBU reader: fixed probing files in which the first frame ends
  after the 1MB mark, which is how big the memory buffer used for probing
  content is. Fixes #6165.
* mkvmerge: VobSub reader: VobSub `.idx` files that start with a byte-order
  mark (BOM) are now read again correctly. Fixes #6162.
* mkvextract: AV1/IVF: fixed inserting a temporal delimiter OBU at the start
  of each frame if there is none. Mostly fixes #6120.
* mkvextract: AV1/IVF: fixed a potential calculation error when deriving frame
  rate numerator & denominator from Matroska's default duration. Part of the
  fix of #6120.
* mkvextract: AV1/IVF: fixed calculation of IVF frame number calculation from
  Matroska's frame timestamps by rounding instead of truncating. Part of the
  fix of #6120.


# Version 95.0 "Goodbye Stranger" 2025-09-14

## New features and enhancements

* mkvmerge, MKVToolNix GUI: new chapter generation feature: a new placeholder
  has been introduced when generating chapters for appended files, \<TITLE\>,
  which will be replaced by the appended file's title metadata. Implements
  #6151. Implementation by Jason Donenfeld.
* mkvmerge: the display matrix from MP4 files are now translated into
  appropriate roll and yaw values for output MKV files. Implements
  #6150. Implementation by Jason Donenfeld.
* mkvmerge: add `--date` argument to set the date metadata. Implements
  #6155. Implementation by Jason Donenfeld.

## Bug fixes

* build system: fixed building with the upcoming Boost v1.89.0 by only
  requiring the header part of the Boost.System library as it's been
  header-only since v1.69.0. Fixes #6143.
* mkvmerge: PCM packetizer: mkvmerge will now always write frames with 40ms of
  samples, no matter how long or short the frames in the source files
  were. Part of the fix of #6149.
* mkvmerge: MP4/QuickTime reader: fix exorbitant memory usage when reading PCM
  audio tracks. Part of the fix of #6149.

## Build system changes

* Boost v1.74.0 or newer is now required.


# Version 94.0 "Initiate" 2025-07-27

## New features and enhancements

* MKVToolNix GUI: multiplexer: the "delete source files after multiplexing"
  job runner will now delete both files of an `.idx`/`.sub` VobSub file
  pair. Implements #6133.

## Bug fixes

* all: fix compilation without FLAC. Fixes #6128.


# Version 93.0 "Goblu" 2025-06-14

## New features and enhancements

* all: updated the various lists that go into IETF/BCP 47 language tags: ISO
  639 languages; ISO 3166 countries; ISO 15924 regions; IANA subtag
  registries.
* translations: added a Hungarian translation of the programs & man pages by
  Viktor György, John Fowler & Attila Zsigus (see `AUTHORS`).
* mkvextract: tags extraction: added an option `--no-track-tags` (short: `-T`)
  for not extracting tags associated with tracks.
* MKVToolNix GUI: multiplexer: the default regular expression for deriving the
  "forced display" track flag from file names for subtitles was extended to
  also match on the term `signs`. Implements #6094.
* MKVToolNix GUI: preferences: the revert buttons for the various "default
  regex for…" will only be enabled when the current text differs from the
  default, in other words: when reverting would actually change the
  text. Part of the implementation of #6099.
* MKVToolNix GUI: preferences: the GUI will now auto-upgrade the "default
  regex for…" to their respective current default values if they're still set
  to one of the previous default values. Part of the implementation of #6099.


# Version 92.0 "Everglow" 2025-04-26

## New features and enhancements

* mkvmerge: FLAC reader: pictures embedded into the FLAC file were already
  handled as attachments, but they were left in the codec initialization data
  as well. They're now removed from the codec initialization data. See #6079.
* mkvmerge: FLAC reader: padding metadata blocks will now be removed from the
  codec initialization data. See #6079.
* mkvmerge: FLAC reader: embedded Vorbis comments will now be converted into
  Matroska comments or track/global header fields when available (e.g. `TITLE`
  will become the segment title & track's name, `LANGUAGE` will become the
  track's language). Copying of Vorbis comments that are converted into actual
  Matroska tags can be prevented with the usual options,
  e.g. `--no-track-tags`. The comments will also be removed from the codec
  initialization data. Implements #6079.
* mkvmerge, MKVToolNix GUI's chapter editor: when reading simple (OGM-style)
  chapter files & no character set is given for the file, mkvmerge will try
  UTF-8 first before falling back to the system's default encoding. Implements
  #6084.
* MKVToolNix GUI: multiplexer: the special drag & drop zones added in v91 are
  now shown by default in new installations.
* MKVToolNix GUI: in new installations the main window will now be sized at
  75% of the screen's resolution initially with a certain minimum initial
  size. This improves initial readability on high DPI screens that use screen
  scaling factors such as 150%.

## Bug fixes

* mkvmerge: Ogg reader: during identification the track tags are now reported
  properly.
* MKVToolNix GUI: multiplexer: within the "additional options", both
  track-specific ones & the global ones on the "Output" tab, it wasn't
  possible to specify empty (zero-length) arguments. With the intended syntax
  of two consecutive single or double quotation marks the empty arguments were
  simply skipped. This was fixed, and it is now possible to specify
  e.g. `--title ""` in the global "Additional options" in order to force no
  title to be written ever. Fixes #6087.

## Build system changes

* Windows build: the `packaging/windows/populate_installer_dir.sh` now expects
  the user to pass the Saxon-HE's JAR file name to be passed with the `-s` or
  `--saxon-jar` parameter instead of the base directory for Saxon-HE. This
  allows newer versions of Saxon-HE to be used.


# Version 91.0 "Signs" 2025-03-16

## Important notes

* The MKVToolNix project's source code repository, bug tracker and wiki have
  been moved to [Codeberg](https://codeberg.org/mbunkus/mkvtoolnix).
* The customized MXE repository used for building the Windows variants has
  been moved from Gitlab to [Codeberg](https://codeberg.org/mbunkus/mxe).

## New features and enhancements

* MKVToolNix GUI: multiplexer: added actions in the "Multiplexer" menu for
  saving all currently open multiplexer tabs to a single `.mtxcfg`
  file. Loading this file later will restore all tabs. Implements #3797.
* MKVToolNix GUI: multiplexer: when adding files the GUI can automatically
  enable the "commentary" flag for audio and subtitle tracks if the file name
  contains the word "comments" or "commentary" delimited by certain characters
  (configurable). This feature is turned on by default. Part of the
  implementation of #3798.
* MKVToolNix GUI: multiplexer: when adding files the GUI can automatically
  enable the "original language" flag for audio and subtitle tracks if the
  track's language matches one configured by the user (configurable). This
  feature is turned off by default. Part of the implementation of #3798.
* MKVToolNix GUI: multiplexer: when adding files the GUI can automatically set
  several track flags based on the file name. It can now look for the same
  patters in the track names, too (configurable). This feature is turned on by
  default. Part of the implementation of #3798.
* MKVToolNix GUI: multiplexer: added special drag & drop zones where users can
  drop files to circumvent the preferences wrt. what to do with multiple
  dropped files. Each drop zone corresponds to one of the three possible
  choices (add all to current settings; create one new settings & add all
  there; add new settings for each file & add one file to each). This feature
  is turned off by default. Implements #3796.
* MKVToolNix GUI: multiplexer: added additional special drag & drop zones
  where users can drop files to add them as attachments. One of the zones will
  automatically set up the dropped file to function as a cover
  image. Implements #3794.
* MKVToolNix GUI: multiplexer: when making destination file names unique by
  suffixing them with a running number the GUI will now also consider the
  destination file names of multiplex jobs currently in the queue that are
  currently running or still waiting for execution. Implements #3801.

## Bug fixes

* mkvmerge: timestamps format v3: fixed the parser; it was completely broken
  for the lines containing the duration & an optional number of frames per
  second. Fixes #2285.
* mkvmerge: DTS parser: if the X96 extension is present in a DTS-HD High
  Resolution stream, the sampling frequency will be set to 96kHz. This was
  broken when reading DTS from elementary streams & from Matroska files. Fixes
  #3288.
* mkvpropedit, MKVToolNix GUI's chapter & header editors: fixed a bug leading
  to a segmentation fault when trying to replace an element at the end of the
  file that's followed by only void elements (at least one). Fixes #3802.

## Build system changes

* The bundled `nlohmann-json` library was updated to v3.11.3.


# Version 90.0 "Hanging On" 2025-02-08

## New features and enhancements

* MKVToolNix GUI: header editor: double-clicking on one of the three flag
  indicators ("Default track", "Forced display", "Enabled") for a track in the
  tree view will now toggle the corresponding flag. Implements #3773.

## Bug fixes

* mkvmerge: AAC parser: LOAS/LATM streams: fixed use of uninitialized data
  when the `StreamMuxConfig` element doesn't contain the `audioMuxVersion`
  element; version 0 must be assumed in such a case. The result was that
  sometimes certain valid AAC packets were dropped. Fix by Stefan Pöschel.
* mkvmerge: HEVC/H.265 parser: fixed calculation of picture order count
  calculation that was triggered under rare circumstances. Fixes #3775.
* mkvmerge: Matroska reader: enabled limits for how much data a single
  Matroksa reader instance might buffer when the muxing core looks for packets
  for specific tracks, avoiding huge memory consumption in cases where tracks
  have huge gaps between packets. This might happen when appending files
  containing forced-only subtitle tracks, for example. Fixes #3771.
* mkvmerge: TrueHD reader: increased the probe range for TrueHD sync frames
  from 128 KB to 512 KB to avoid mis-detection with certain files with a lot
  of data between sync frames. Fixes #3783.
* mkvmerge: MP4/QuickTime reader: fixed detection of Big Endian LPCM
  audio. Fixes #3788.

## Build system changes

* The bundled `fmt` library was updated to v11.1.2.
* added a new option to `configure` called `--disable-dbus` to disable looking
  for & using QtDBus even if it's present on the system. Default remains to
  probe for its existence. Patch by Anthony Ryan.


# Version 89.0 "And the Melody Still Lingers On (Night in Tunisia)" 2024-12-27

## New features and enhancements

* mkvmerge: AC-3 writer: mkvmerge will now use the codec ID `A_AC3` even for
  streams with bitstream IDs 9 or 10 instead of the deprecated codec IDs
  `A_AC3/BSID9` & `A_AC3/BSID10`. Fixes #2387.
* MKVToolNix GUI: multiplexer: the mechanism for setting track languages to
  specific values upon adding a file has gotten a new option to always set the
  language, no matter whether or not the source container provided a track
  language or what it was set to.
* all command-line tools: implemented an escape mechanism for when you want to
  use the `@` sign as the first character in an argument to an option such as
  `--title`. To escape it the `@` sign has to be doubled as in `--title
  @@midnight`. Implements #3768.

## Bug fixes

* mkvmerge, mkvpropedit, MKVToolNix GUI's multiplexer & header editor: the
  MIME type for TrueType & OpenType fonts will be set properly to either the
  current MIME types `font/ttf` & `font/otf` or to the legacy MIME types
  `application/x-truetype-font` & `application/vnd.ms-opentype` depending on
  whether the "use legacy font MIME types" option is disabled or enabled, even
  if the MIME database used by Qt returns the wrong one or even other MIME
  types such as `application/x-font-ttf` & `application/x-font-otf`. This was
  the case on Windows due to Qt 6.7.3 switching to a different embedded MIME
  database. Partially fixes #3751.
* MKVToolNix GUI's multiplexer & header editor: ensured that both the legacy &
  the current font MIME types are always present in the MIME type combo boxes
  of attachments, no matter what Qt's MIME type database contains. Partially
  fixes #3751.
* MKVToolNix GUI: the "disable tooltips" option in the preference will now
  disable the tooltip for the status bar, too.


# Version 88.0 "All I Know" 2024-10-19

## New features and enhancements

* mkvmerge, MKVToolNix GUI's chapter editor: added support for reading
  chapters from PotPlayer bookmark files.

## Bug fixes

* configure: fixed setting `HAVE_QTDBUS` properly if the QtDbus module is
  found. Fixes #3744.
* mkvmerge: MP4 reader: mkvmerge will no longer warn when multiple identical
  FourCCs are present within the same track headers. Fixes #3748.
* mkvmerge man page: removed the wrong statement that an attachment's MIME
  type must be set before use of the `--attach-file` & `--attach-file-once`
  options. If not given, mkvmerge auto-detects the MIME type.


# Version 87.0 "Black as the Sky" 2024-09-07

## New features and enhancements

* mkvmerge: chapters: added support for specifying MPLS files with
  `--chapters`, too, not just as regular source files. The documentation
  stated this was possible already, but that wasn't actually the
  case. Implements/fixes #3735.
* MKVToolNix GUI: multiplexer: added a progress dialog that is shown during
  file identification.
* MKVToolNix GUI: jobs: the status bar now differentiates between numbers of
  warnings/errors that occurred in the current session and those that occurred
  before the current session. Implements #3732.

## Bug fixes

* mkvmerge: AAC parser: LOAS/LATM streams: if the first `AudioSpecificConfig`
  element is not found within the first LOAS/LATM frame, `mkvmerge` will no
  longer discard the frames before it but defer parsing them until after it
  has found the `AudioSpecificConfig` element. Fixes #3727.
* MKVToolNix GUI: job queue: fixed the GUI crashing when re-ordering the jobs
  in the job queue. This regression was introduced while fixing #3720. Fixes
  #3729.

## Build system changes

* The bundled `fmt` library was updated to v10.2.1.


# Version 86.0 "Winter" 2024-07-13

## New features and enhancements

* mkvmerge: Matroska reader: track statistics tags are included in the JSON
  identification output just like other tags had already been included: as
  part of the track properties, prefixed with `tag_`. Implements #3714.
* mkvmerge: MPEG TS reader: mkvmerge will now detect teletext subtitle tracks
  even if they're not listed in the PMT as long as it can find teletext pages
  flagged as subtitles in the header within the probed ranged of the
  file. Implements #3650.
* MKVToolNix GUI: multiplexer: the default mode for escaping the arguments in
  the "Show command line" dialog can now be set in the preferences. Partially
  implements #3709.
* MKVToolNix GUI: multiplexer: the "Show command line" dialog now includes the
  command lines for all currently open multiplex settings, switchable with a
  combo box. Partially implements #3709.
* MKVToolNix GUI: multiplexer: some users add the option
  `--regenerate-track-uids` to the "additional options", even though
  `--regenerate-track-uids` is a file-specific option, and you can only use
  global options in the "additional options". However, the GUI currently
  doesn't have an option for specifying additional file-specific options. The
  GUI now detects the use of this option in the "additional options" & adds it
  for each of the source files instead. Implements #3707.
* MKVToolNix GUI: multiplexer: the option `--regenerate-track-uids` has been
  added to the "additional command line options" dialog. See #3703.
* translations: added a Norwegian Bokmål translation of the man pages by Roger
  Knutsen (see `AUTHORS`).

## Bug fixes

* mkvmerge: when using timestamp files for subtitle tracks, mkvmerge will no
  longer set a default duration for the track. Partially fixes #3711.
* mkvmerge: when using timestamp files for subtitle tracks, mkvmerge will no
  longer queue frames longer than necessary, which resulted in the frames
  sometimes being written much later than they should have been according to
  their timestamps. Partially fixes #3711.
* mkvmerge: when using timestamp files for subtitle tracks, mkvmerge will now
  write the packets' duration properly. Partially fixes #3711.
* MKVToolNix GUI: job queue: the shortcut from the "Job queue" menu are now
  enabled correctly whenever the number of jobs in the queue changes (e.g. by
  adding new jobs). Fixes #3720.


# Version 85.0 "Shame For You" 2024-06-02

## Bug fixes

* fixed compilation of `src/common/sorting.h` with certain compilers due to
  the deprecation & removal of `std::result_of<>` in C++20. Fixes #3695.
* fixed compilation with the `gtest` library when `gtest` requires additional
  libraries by querying `pkg-config` for the correct flags & libraries to
  build with. See #3696.
* MKVToolNix GUI: multiplexer: restored the keyboard shortcut for switching to
  the "Attachments" tab (Alt+C for the English interface). Fixes #3702.
* MKVToolNix GUI: multiplexer: fixed several cases when the keyboard shortcuts
  for copying the first source file's name/the destination file's name to the
  title (Ctrl+F & Ctrl+D) and the one for copying the title to the destination
  file name (Ctrl+T) were not enabled. Fixes #3705.


# Version 84.0 "Sleeper" 2024-04-28

## New features and enhancements

* mkvmerge: added a new file-specific option `--regenerate-track-uids`. When
  used for Matroska files, `mkvmerge` will generate new random track UIDs
  instead of keeping existing track UIDs. This is done automatically when a
  Matroska file was created by MakeMKV.
* mkvmerge: MP4 reader: added support for FLAC in MP4. Implements #3692.
* MKVToolNix GUI: multiplexer: the "Attachments" tab's title will now include
  the total number of attachments (both from source files & to newly
  attach). Implements #3693.
* translations: added a Norwegian Bokmål translation of the programs by Roger
  Knutsen (see `AUTHORS`).

## Bug fixes

* configure: when called with `--disable-gui` the build system still ran the
  check for the GUI libraries & failed if they weren't found. This check is
  now skipped when the option is given. Fixes #3680.
* mkvmerge: several color-related track header properties were parsed into &
  stored as a wrong integer type internally. This could result in wrong values
  being copied when very large values were present in source files, or in
  error messages when very large values were used as command-line parameters.
* MKVToolNix GUI: multiplexer: the keyboard shortcuts from the "modify
  selected tracks" sub-menu didn't work right after opening a file. They only
  started working after opening the "multiplexer" menu. Fixes #3681.

## Build system changes

* Release v8.0.0 of the `fmt` library is now required. If not found, the
  bundled copy will be used.
* A C++20 compatible compiler is now required for several but certainly not
  all C++20 features. g++ v10 & clang++ v10 should suffice.


# Version 83.0 "Circle Of Friends" 2024-03-10

## New features and enhancements

* translations: added a Belarusian translation of the programs & the man pages
  by prydespar (see `AUTHORS`).
* mkvmerge, MKVToolNix GUI's chapter editor: added support for reading
  chapters from ffmpeg metadata files. Implements #3676.
* MKVToolNix GUI: added a new action type for execution after jobs or the
  queue finishes: quitting MKVToolNix. Implements #3677.

## Build system changes

* The bundled `fmt` library was updated to v10.2.1.

## Other changes

* Tons of changes were made to support the latest development versions of
  libEBML & libMatroska.


# Version 82.0 "I'm The President" 2024-01-02

## New features and enhancements

* mkvmerge: Matroska reader: the "video alpha mode" track header property will
  be copied to the output file if present. Part of the implementation of
  #3643.
* mkvmerge: Matroska reader: the "video alpha mode" track header property will
  be reported in JSON identification mode as the track property
  `alpha_mode`. Part of the implementation of #3643.
* mkvmerge: Matroska reader: the file's timestamp scaling factor will be
  reported in JSON identification mode as the container property
  `timestamp_scale`.
* mkvmerge: MPEG transport stream reader: teletext subtitles intended for
  hearing impaired people (type 0x05) are now marked as such via the
  appropriate flag in the track headers.
* mkvmerge: file identification: the JSON identification output schema version
  has been bumped to 19.
* mkvmerge: added a new hack `always_write_block_add_ids` that can be used as
  a workaround for players that don't support the handling of missing "Block
  Addition ID" sub-elements of "Block More" elements in block additions
  properly. These are used for e.g. alpha channel data in VP9 with a "Block
  Addition ID" value of 1, which is also its default value. Workaround for the
  player issues listed in #3643.
* mkvinfo: added support for the "video alpha mode" track header element. Part
  of the implementation of #3643.
* mkvpropedit, MKVToolNix GUI's header editor: added support for the "video
  alpha mode" track header property. In `mkvpropedit` it's called
  `alpha-mode`. Part of the implementation of #3643.
* MKVToolNix GUI: multiplexer: when adding files the GUI can automatically
  enable the "hearing impaired" flag for audio and subtitle tracks if the file
  name contains the word "cc" or "sdh" delimited by certain characters
  (configurable). This feature is turned on by default. Implements #3648.
* MKVToolNix GUI: multiplexer: when scanning for Blu-ray playlists the GUI
  will now ignore playlists that are likely meant for menus. Currently the GUI
  considers this to be the case when a playlist contains the same item at
  least five times. This behavior can be turned off in the
  preferences. Implements #3658.

## Bug fixes

* mkvmerge: MPEG transport stream reader: fixed a crash introduced in v81 that
  occurred when there was at least one PCM track that wasn't copied from the
  transport stream file. Fixes #3645.
* mkvmerge: when reading data from Matroska files damaged in a specific way,
  mkvmerge ended up trying to write various types of elements that aren't
  allowed to be written (so-called `EbmlDummy` elements as well as elements
  that don't have a value set) to the output file, which caused the underlying
  `libebml` library to abort. These types of broken elements are now filtered
  out.

## Build system changes

* Qt 5 is no longer supported. Qt 6 is now required for building
  MKVToolNix. This implies that the options to `configure` revolving around
  configuring Qt 5 or choosing between the two have been removed
  (e.g. `--disable-qt6`).
* Qt 6 detection: if detection fails, error messages from `qmake` can now be
  found in `config.log`. See #3649.
* Qt 6 detection: `configure` will only consider Qt 6.2.0 or newer, not 6.0.x
  or 6.1.y anymore, due to the lack of support for the multimedia module.
* Qt 6 detection: `configure` will now fail to detect Qt 6 if the 'multimedia'
  module is not found by `qmake` (e.g. due to development packages not being
  installed). See #3649.
* The bundled `fmt` library was updated to v10.1.1.


# Version 81.0 "Milliontown" 2023-12-02

## New features and enhancements

* mkvmerge: when Dolby Vision comes in two separate tracks (as is the case on
  Blu-rays, for example) mkvmerge will now combine those two into a single
  track properly. This is done automatically. In order not to confuse the
  user, the secondary track carrying solely Dolby Vision information is not
  shown as a separate track by mkvmerge anymore.
* mkvmerge: MPEG transport stream reader: HEVC/H.265: added support for
  reading single-layer Dolby Vision from Annex B type bitstream read from MPEG
  transport streams. Partially implements #3113.
* mkvmerge: MPEG transport stream reader, HEVC/H.265 elementary stream reader:
  added support for reading dual-layer Dolby Vision with both the base &
  enhancement layers in the same track from Annex B type bitstreams in MPEG
  transport files & elementary stream files. Implements #3126.
* mkvmerge: MPEG transport stream reader: HEVC/H.265: implemented combining
  dual-layer Dolby Vision with base & enhancement layers in different
  tracks. Implements #3127.
* MKVToolNix GUI: multiplexer: added a new option in the preferences for
  always enabling 'forced' subtitle tracks. A subtitle track is considered to
  be 'forced' if: the corresponding property is set in the source file; the
  track's name contains the word 'forced' (in English); deriving the 'forced
  display' flag from file names is active & the file name matches the
  corresponding pattern. The option is disabled by default. Implements #3627.
* MKVToolNix GUI: multiplexer: the functionality for detecting file name
  sequences when adding files can now recognize the patterns used by GoPro's
  cameras for chaptered video files. Implements #3633.
* xyzvc_dump: the end position of the current NALU will be output in
  non-portable format as well.
* xyzvc_dump: HEVC: the tool will now also output the inner NALU type of Dolby
  Vision NALUs (`unspec62` and `unspec63`).

## Bug fixes

* mkvmerge: when the user requests processing be stopped after the video ends
  `mkvmerge` will now take appending files into account properly. It won't
  stop processing unconditionally after the first file ends anymore. Fixes
  #3618.
* mkvmerge: AV1 handling in readers: the readers will now provide the pixel
  dimensions to the AV1 packetizer as early as possible, just like for other
  video packetizers. That way the pixel dimensions are available for
  calculating the display dimensions when command-line options such as
  `--aspect-ratio` & `--aspect-ratio-factor` are used. Before the change the
  calculation was done based on initial pixel dimension values of 0x0,
  resulting in display dimensions of 0x0, too. Fixes #3611.
* mkvmerge: HEVC/H.265 packetizer: when reading & appending HEVC/H.265 from
  Matroska, MP4/MOV or FLV files the first frame of all the appended files was
  sometimes dropped, resulting in broken video at the point where video is
  appended. Fixes #3479.
* mkvmerge: MPEG transport stream reader: when reading MPEG transport streams
  from Blu-rays the four-byte long `TP_extra_header` structure in front of the
  transport packets are now skipped properly. Before the fix a stray byte with
  value of `0x47` inside that `TP_extra_header` structure could have thrown
  off the detection of where the transport packets start, leading to mkvmerge
  dropping a few audio and/or video frames at the start of the file. Fixes
  #3632.
* mkvextract: AAC extractor: when an invalid program config element in the
  GA-specific config element is encountered, the program config element will
  be disregarded, which avoids mkvextract aborting with an exception. Fixes
  #3606.
* xyzvc_dump: fixed the tool aborting with an exception when the last NALU in
  an Annex B type file was shorter than four bytes.

## Other changes

* AVC & HEVC dumper development tool: the tool has been renamed from
  `xvc_dump` to `xyzvc_dump` as `xvc` is an abbreviation for an existing video
  codec (Extreme Video Coding), and the tool has nothing to do with that
  codec.


# Version 80.0 "Roundabout" 2023-10-29

## New features and enhancements

* MKVToolNix GUI: if the system's locale uses one of the Han scripts, the GUI
  will force Arabic numerals to be used in spin boxes. This prevents Suzhou
  numerals from being used which seems to be the default on Windows systems
  sold in China. Implements #3624.

## Bug fixes

* build system: fixed detection of Qt6 if `clang` is used for compilation on
  Linux. In that case Qt's `qmake` added a `gcc`-specific option that `clang`
  doesn't understand, `-mno-direct-extern-access`. `configure` will now pass
  the parameter `-spec linux-clang` to `qmake` so that it uses the correct
  compiler flags.
* build system: fixed the use of `mktemp` to be more portable to
  e.g. macOS. Fixes #3608.
* mkvmerge: if a video aspect ratio was given with `--aspect-ratio-factor`,
  the code would apply a second factor based on the pixel resolution,
  resulting in much too large values for the `DisplayWidth` element. For
  example, with a pixel resolution of 720x520 & an aspect ratio factor of 1/1
  the result should be 720x520, but instead it was 900x520. Up until release
  76.0 this has only happened when a track order was given (which
  unfortunately includes all invocations with MKVToolNix GUI as it always
  includes the track order). Starting with release 77.0 this has always
  happened due to the automatic sorting of tracks implicitly creating a track
  order, even if none was given.


# Version 79.0 "Funeral Pyres" 2023-08-20

## New features and enhancements

* mkvmerge: AV1: added support for reading Dolby Vision from AV1 IVF & OBU
  streams. Patches by Quietvoid.
* mkvmerge: MPEG TS reader: added support for colors in teletext
  subtitles. Patch by Angela Schmid.
* MKVToolNix GUI: multiplexer: when adding files the GUI can automatically
  enable the "forced display" flag for subtitle tracks if the file name
  contains the word "forced" delimited by certain characters
  (configurable). This feature is turned on by default. Implements #3586.
* MKVToolNix GUI: multiplexer: added the option `--stop-after-video-ends` to
  the dialog for additional command line options. Implements #3594.
* MKVToolNix GUI: multiplexer: when adding Blu-ray playlists the dialog
  allowing the user to select the playlist to add will now show audio & video
  track properties as well (pixel dimensions for video; sampling frequency,
  channels for audio). Implements #3597.
* MKVToolNix GUI: header editor: in order to reduce confusion with users non
  that versed in Matroska elements, the naming of the two "language" track
  properties has been changed: the old element is now titled "Language
  (obsolete)" & the current, IETF BCP 47 based one is simply called
  "Language".
* MKVToolNix GUI: preferences: you can now use the "delete" key to remove
  entries from simple list widgets for strings (e.g. the list of recently used
  destination directories).

## Bug fixes

* mkvmerge: DTS reader: if a DTS stream doesn't start with a DTS core but a
  sub-stream element (EXSS), the reader will now look for a core. If found,
  it'll start processing from there instead of from the start. This fixes the
  timestamp calculation if the sampling frequency in the core & in the
  extensions are different. Fixes #3602.
* MKVToolNix GUI: multiplexer: the "emphasis" and "stereoscopy" combo-boxes
  now have a much smaller minimum width, allowing to make the whole
  "properties" pane much smaller again. Fixes #3581.
* MKVToolNix GUI: macOS: when you install the application from the DMG it'll
  no longer register itself as an alternate handler for its supported file
  types. It seems like this overrode existing associations, forcing people to
  change them manually to whatever they wanted them to be. Additionally this
  forced the associated file to always be shown with an MKVToolNix icon. The
  GUI's own `.mtxcfg` files will still be registered. Fixes #3588.


# Version 78.0 "Running" 2023-07-02

## New features and enhancements

* MKVToolNix GUI: header editor: for files that only contain legacy track
  language elements but no IETF language elements the header editor will now
  derive the IETF language elements from the legacy elements. See #3557.
* AppImage: the AppImage is now built on AlmaLinux 8 with Qt 6.5.1. This means
  that the minimum glibc version this AppImage is compatible with has also
  been bumped, to v2.28. The oldest Debian coming with this version is Debian
  10 "Buster"; for Ubuntu it's 18.10 "Cosmic Cuttlefish".
* Windows installer: the installer will now remove the file
  `data\portable-app` if it's present in the installation directory as its
  presence would signal to the app to run in portable mode, requiring write
  access to its base directory. This fixes some installation issues that could
  occur when a user extracted a portable app archive into a folder like
  `C:\Program Files\MKVToolNix`. Also added an installation check for the same
  issue. See #3558.

## Bug fixes

* all: Linux: if initializing the locale system based on the system's settings
  fails, e.g. if environment variables such as `LC_ALL` have been set to
  `fr_FR.UTF-8` but the locale for `fr_FR.UTF-8` hasn't been built, MKVToolNix
  will try to fall back to `en_US.UTF-8` first & `C.UTF-8` second. If neither
  of the three succeeds, an error message will be shown, and the program will
  abort. This fixes the programs not catching an exception from the
  `boost::filesystem` library which doesn't cope with mis-configured locale
  systems well. Workaround for #3574.
* mkvmerge: sorting tracks by type did not work properly when some tracks
  weren't copied. Part of the fix of #3567.
* mkvmerge: track numbers in the destination file were assigned out-of-order
  when the track order in the source files differs from the one in the
  destination file. Now they're assigned sequentially in the order the tracks
  appear in the destination file again. Part of the fix of #3567.
* MKVToolNix GUI: under certain circumstances the GUI would try to display
  error messages from a secondary thread, which isn't allowed in Qt, causing
  to program to either hang or outright crash. Part of the fix of #3556 &
  #3561.
* MKVToolNix GUI: the GUI will check for several potential installation issues
  wrt. to having write access to certain directories (system's temporary
  directory, MKVToolNix's file identification cache directory and others) &
  display proper error messages if not. Part of the fix of #3556 & #3561.
* MKVToolNix GUI: header editor: fixed the application crashing whenever you
  change a property below the "segment information" node. This bug was
  introduced in v77. Fixes #3556.
* MKVToolNix GUI: header editor: when reading files that only contain legacy
  track language elements but no IETF track language elements, the header
  editor was showing all tracks as having "English" as the language. This bug
  was introduced in v77. Fixes #3557.
* MKVToolNix GUI: header editor: when a legacy track language element contains
  a country code (e.g. `fr-CA`), the header editor was wrongfully using `und`
  = "undetermined" as the language for that element. Now it'll use the
  language from the language/country pair, which would be `fr` in the earlier
  example. Part of the fix of #3557.
* MKVToolNix GUI: header editor: the keyboard shortcuts from the "modify
  selected track" sub-menu didn't work right after opening a file. They only
  started working after opening the "header editor" menu. Fixes #3573.
* AppImage: fixed the GUI resources (e.g. icons) not being found.
* AppImage: the Qt plugins required for using compose key/dead keys are now
  included. Fixes #3577.

## Build system changes

* The compilation database (`compile_commands.json`) is now always built. The
  variable `BUILD_COMPILATION_DATABASE` is not evaluated anymore.


# Version 77.0 "Elemental" 2023-06-04

## New features and enhancements

* mkvmerge: tracks in the destination file will now be sorted by their type
  automatically unless the track order is specified with the `--track-order`
  option. The order is as follows: video tracks first followed by audio &
  subtitle tracks with other rarely used types of tracks last. Tracks of the
  same type will be sorted in the same order as their source files occur in
  the command-line arguments. Note that this doesn't affect file
  identification. Implements #3545.
* MKVToolNix GUI: multiplexer: the default list colors used for distinguishing
  source files does not include the darkest tier anymore (the ones where one
  or two components are set to the value 0x3f) as they're hard to distinguish
  from each other. Only affects new installations, or when the user presses
  the "reset to default colors" button. Implements #3533.
* MKVToolNix GUI: multiplexer: the GUI will now check the state of the 'track
  enabled' flag of all video, audio & subtitle tracks when starting to
  multiplex or adding a job to the job queue. If there's no track with its
  flag turned on for a type, the GUI will turn on the flag for the first track
  of the type. This behavior can be turned off in the preferences. Implements
  #3535.
* MKVToolNix GUI: header editor: the columns in the tracks/attachments view
  and the values on the "track type" page will now be updated each time a
  corresponding property is changed (e.g. when a track's name is changed)
  instead of showing what's in the file on disk. Implements #3554.
* MKVToolNix GUI: macOS: when you install the application from the DMG it'll
  register itself as an alternate handler for its supported file types. This
  allows the use of the "Open with" context menu action in Finder.
* MKVToolNix GUI: Windows: a new settings in the preferences lets the user
  chose whether to use the light or the dark color palette, or to follow the
  system settings. Part of the fix for #3528.

## Bug fixes

* Fixed compilation with fmt v10.0.0.
* mkvmerge: fixed several instances of wrong format strings for `fmt::format`
  used in debug messages. Fixes #3548.
* mkvmerge: AV1 packetizer: the packetizer did not honor the aspect ratio
  (factor) given on the command-line via the `--aspect-ratio` or
  `--aspect-ratio-factor` options.
* mkvmerge: JSON identification: cropping parameters are reported again even
  if some of the four values are not present in the file or set to 0. Fixes
  #3534.
* mkvmerge: Windows: when writing to a network share connected via SMB1
  `mkvmerge` was aborting with a error about `create_directory() failed` with
  existing directories. This was due to a bug in recent versions of the
  Boost.Filesystem library. The Windows version of MKVToolNix will be built
  with Boost 1.82.0 from now on which includes the fix. Fixes #3547.
* MKVToolNix GUI: the defunct "disable the dark mode" checkbox was removed
  from the preferences.
* MKVToolNix GUI: language dialog: under certain conditions the controls for
  the individual components remained disabled when the dialog is opened even
  though editing of individual components is selected. Part of the fix of
  #3532.
* MKVToolNix GUI: language dialog: the controls for the individual components
  weren't re-initialized properly after opening the dialog for the second &
  all following times, potentially leaving previously selected/entered entries
  intact, primarily when editing multiple tracks at once. Part of the fix of
  #3532.
* MKVToolNix GUI: header editor: using the actions from the "modify selected
  track" context menu only worked if the user right-clicked on the first
  column in the view. They now work for clicks on any of the columns. See also
  #3554.
* MKVToolNix GUI: header editor: some of the actions toggling specific flags
  from the "modify selected track" did not work correctly if the flag wasn't
  currently present in the file, especially if the underlying value has a
  default value in the Matroska specs.
* MKVToolNix GUI: Windows: the GUI will now always use its own implementation
  of light & dark palettes instead of relying on Qt. This circumvents two
  issues with the palette support in Qt 6.5.0:
  1. if Windows 11's dark application mode is active, links were displayed in
     a hard-to-read dark blue.
  2. for unknown reasons the the dark palette was not chosen on some Windows
     11 installations even though Windows 11's color mode was set to "dark".
  This is a workaround for #3528.

## Build system changes

* The bundled `fmt` library was updated to v10.0.0.
* MKVToolNix GUI now uses an external Qt resource file instead of compiling it
  into the executable. The resource file has reached a size at which the C++
  compiler exhausts available virtual memory on some 32-bit architectures. On
  Windows & macOS the GUI will look for the file in
  `<folder_with_executables>/data/qt_resources.rcc`, and in the directory set
  with `configure`'s `--datadir` parameter on other systems (which usually
  means `/usr/share/mkvtoolnix`). The `install` build system commands installs
  it into that folder.


# Version 76.0 "Celebration" 2023-04-30

## Important notes

* mkvmerge: removed the option `--blockadd`. Removing block additional data is
  not possible anymore, as it is often required for proper decoding. Part of
  the implementation of #3511.

## New features and enhancements

* mkvmerge: JSON file identification: added a child element called
  `num_index_entries` to the `properties` track element containing the number
  of index entries found for a track. Currently only implemented for Matroska
  files where it contains the number of cue points. See #3510.
* mkvmerge: the maximum block addition ID track header value is now calculated
  automatically from both the existing mappings & the actually used block
  additions in the block groups. Part of the implementation of #3511.
* mkvmerge: Matroska reader: when reading WebM files that use block additions
  with ID 4 (HDR for VP9) an appropriate block addition mapping will be
  created automatically. Part of the implementation of #3511.
* mkvmerge: MP4 reader: the title/movie name meta data (content of the
  `udta.meta.ilst.©nam` atom) will now be copied over as the segment title
  track header attribute. Part of the implementation of #3475.
* mkvmerge: MP4 reader: the comment & encoder meta data (content of the
  `udta.meta.ilst.©cmt` & `….©too` atoms) will now be copied over as global
  tags `COMMENT` & `ENCODER` respectively. Part of the implementation of
  #3475.
* mkvmerge, MKVToolNix GUI's multiplexer: added an option to stop processing
  after the primary video track ends called `--stop-after-video-ends`. This
  discards any remaining packets of other tracks. Part of the implementation
  #3506.
* MKVToolNix GUI: only on Windows: the GUI now uses Qt's "Fusion" style
  instead of the deprecated "Windows Vista" style. The advantage is that as of
  Qt 6.5 the "Fusion" style properly supports Windows 10's & 11's dark
  application mode. The Windows binaries are now built with said Qt
  version. Therefore the option to disable the dark mode has been
  removed. Fixes #3264 and likely others.
* MKVToolNix GUI: multiplexer: automatically setting the destination file
  name: added an option in the preferences for using the first source file's
  directory name instead of its file name as the basis for the destination
  file name. Implements #3512.
* MKVToolNix GUI: multiplexer: double-clicking on certain columns in the
  "tracks" view will now toggle them directly (columns "Default track" &
  "Forced track") or activate the corresponding control (columns "Language",
  "Name" & "Delay"). Double-clicks on other columns will do what they've done
  before, too: toggling the "Copy item" state. Implements #3513 & others.
* MKVToolNix GUI: the dialog for editing language tags is now created only the
  first time the user wants to edit a language tag & cached afterwards instead
  of creating a new instance each time. This makes subsequent uses instant.

## Bug fixes

* mkvmerge: mkvmerge will now only try to probe for VobSubs if the name of the
  file to identify ends in either `.idx` or `.sub`, preventing
  mis-identification of other file types if VobSubs with the same base name
  exist in the same directory. Fixes #3508.
* mkvmerge: AC-3: mkvmerge will now skip certain types of garbage data (16
  bytes starting with 0x01 0x10) that can occur before each sync frame,
  fixing the file not being identified as AC-3. Fixes #3484.
* mkvmerge: Matroska reader: when reading files that use block additions with
  IDs other than 1 (e.g. 4 for HDR for VP9) the IDs will now be kept & written
  to the output file. Before no ID would be written, effectively using 1 as
  that's the default value for the corresponding element. Part of the
  implementation of #3511.
* mkvmerge: mkvmerge will no longer write block addition mappings or the max
  block addition ID track header elements when creating a WebM file as those
  elements aren't supported there. Part of the implementation of #3511.
* mkvpropedit: fixed replacing chapters & tags in files that don't contain
  tracks. Fixes #3498.


# Version 75.0.0 "Goliath" 2023-03-26

## New features and enhancements

* mkvmerge: MP4 reader: mkvmerge will now read Timed Text (FourCC `tx3g`)
  subtitle tracks & convert them on the fly to Matroska's simple text subtitle
  format (`S_TEXT/UTF8`; text only, no styles). Implements #2208, #2242,
  #2613, #3000, #3243, #3418 and possibly others.

## Bug fixes

* all: switched back to using `boost::filesystem` functions for creating
  directories instead of the ones introduced to work around bugs in
  `std::filesystem`. The latter didn't work correctly with UNC paths after the
  switch to `boost::filesystem::path` in v74. Fixes #3483.
* mkvmerge: VobSub reader: mkvmerge will now probe the `.idx` file during
  VobSub identification even if the `.sub` file is passed as the
  source. Avoids mis-detection of the `.sub` as MPEG program streams. Fixes
  #3489.
* MKVToolNix GUI: the GUI could abort with an exception on startup while
  looking for the `mkvmerge` or `mediainfo` executables due to inaccessible
  folders. Fixes #3481.
* MKVToolNix GUI: preferences: when opening the preferences the first time the
  UI might pre-select the first entry in the list of interface languages if
  the operating system's language is not available for MKVToolNix. This might
  also happen on Linux if e.g. `en_GB` is set, even though `en_US` is
  available. Now English (`en_US`) will be selected instead. Fixes #3486.
* MKVToolNix GUI: multiplexer: when adding files the GUI has special handling
  for chapter/tags/segment info files. This is done by comparing their content
  to certain patterns. This recognition could wrongfully be triggered if any
  such file was embedded in another file verbatim, e.g. with a chapter XML
  file attachment in a Matroska file. When trying to add that Matroska file,
  the GUI would treat it as a chapter file instead of a regular one. This
  content-based detection was fixed. Fixes #3487.

## Other changes

* mkvpropedit, GUI's header editor: removed support for the deprecated
  "minimum cache" & "maximum cache" track header elements.


# Version 74.0.0 "You Oughta Know" 2023-02-12

## New features and enhancements

* mkvmerge: SRT handling: added a hack called `--engage
  keep_whitespaces_in_text_subtitles` which disables stripping whitespaces
  from the start & end of each line of SRT entries during muxing. Part of the
  implementation of #3470.

## Bug fixes

* all: Windows: UNC paths of type `\\?\C:\…` are supported again by switching
  back to Boost's file system library instead of using C++17's file system
  library. Fixes #3058.
* mkvmerge: AVC/H.264 & HEVC/H.265 packetizers: when appending tracks the
  pixel dimensions will be checked & muxing will be aborted if they don't
  match. Fixes #3480.
* mkvmerge: file type detection: file types that can be detected unambiguously
  by their content (e.g. Matroska, MP4, WAV…) will now preferred in the
  detection order over file types based on their extension. Prevents certain
  cases of mis-detection, e.g. DTS in WAV but with a file name extension of
  `.dts` being detected as the wrong type of DTS. Fixes #3462.
* mkvmerge: SRT handling: whitespaces will now be stripped from the start &
  the end of each line of each entry, not just from the end of the last
  line. Part of the fix of #3470.
* mkvextract: SRT extraction: whitespaces will not be stripped from the start
  & end of the whole entry anymore. Part of the fix of #3470.
* MKVToolNix GUI: multiplexer: when adding multiple files that include certain
  file types (chapters, segment info and tag files) and when the choice where
  to add them is "all files to a single new tab", these certain file types
  will now be added in the newly added tab as well instead of the current tab
  that had already been open. Fixes #3469.
* build system: fixed compatibility with Ruby 3.2.0 by using `FileTest.exist?`
  instead of `File.exists?`, `Dir.exists?` & `FileTest.exists?` which were
  removed in that release.

## Build system changes

* MKVToolNix is now using & requiring Boost's "file system" and "system"
  libraries again instead of C++17's file system library. This is due to gcc's
  library not supporting UNC paths of types `\\?\C:\dir\file.ext`.


# Version 73.0.0 "25 or 6 to 4" 2023-01-02

## New features and enhancements

* mkvmerge: greatly enhanced the speed of Base64 decoding which is used used
  e.g. when reading pictures embedded in Ogg or FLAC files or for binary data
  inside XML chapter & tag files. Even small blocks of data could take
  unreasonably long.
* mkvmerge: added support for reading HEVC/H.265 video from FLV
  containers. Implements #3466.

## Bug fixes

* mkvmerge: splitting: fixed a typo in the string output in GUI mode regarding
  the timestamps before which splitting was done. See #3421.
* MKVToolNix GUI: job output: after having run multiple jobs the "Clear
  output" functionality only reset the visible parts. However, using the "save
  output" function would also save the output generated before the user used
  "clear output". Now only the output after the last use of "clear output" is
  saved. Fixes #3438.
* build system: when probing for the FLAC library the Ogg libraries will be
  linked with the compiled test program as well. This fixes detection if the
  `pkg-config` settings for FLAC don't list Ogg & the linker doesn't find the
  library automatically (e.g. for my macOS builds). Fixes #3439.


# Version 72.0.0 "Minuano (Six-eight)" 2022-11-13

## New features and enhancements

* mkvmerge: AV1 parser: the variable-width OBU size field will be re-written
  with minimal length if it's encoded longer than necessary.
* mkvmerge: when splitting is active the program will output the timestamps
  actually used for making the decision when to split. If GUI mode is active,
  a specially formatted line `#GUI#splitting_before_timestamp <timestamp>` is
  output as well. Lines prefixed with`#GUI#` are suitable for machine parsing,
  won't be translated and are guaranteed not to change in format. Implements
  #3421.
* MKVToolNix GUI: multiplexer: when dragging & dropping directories to the
  "attachments" tab, the files contained in those directories will be
  attached. Implements #3410.
* MKVToolNix GUI: info tool: added information about the file (directory,
  size, modification timestamp) at the top of each tab. Implements #3407.

## Bug fixes

* mkvmerge: AV1 parser: fixed the parser completely aborting when parsing the
  OBU size field fails due to there not being enough data to parse. Instead
  the parser will remember the last known-good position & restart from there
  after more data is available. Fixes #3431.
* mkvmerge: HDMV PGS subtitles: reverted the change that implemented a
  heuristic for detecting bogus timestamps & attempting to fix them. This was
  done to fix #3268. Unfortunately this affected valid subtitle files with
  intentional huge gaps in timestamps, e.g. forced subtitle tracks. The
  heuristic has simply been removed, fixing #3392.
* mkvmerge: Matroska reader: fixed reading files with EBML Void elements
  before the Matroska Segment element.
* mkvmerge: fixed reversed attachment selection: `--attachments !4` would not
  copy any attachment instead of all attachments but the one with ID 4. Fixes
  #3427.
* mkvextract: IETF BCP 47/RFC 5646 language tags: mkvextract will now use &
  prefer IETF BCP 47 track language elements if they're present. Only affects
  the VobSub & USF subtitle extraction.
* mkvpropedit, MKVToolNix GUI's chapter & header editors: updated the list of
  deprecated Matroska elements. The applications will no longer try to write
  those elements, even if they're found in the file to be modified. The
  programs will no longer abort with error messages such as `assertion "false"
  failed`. Fixes #3416.
* mkvpropedit, MKVToolNix GUI's chapter & header editors: when the Matroska
  version numbers stored in the EBML Head element are updated, the updated
  EBML Head element might be smaller than the existing one. In that case the
  programs used to shrink the EBML Head & write a small EBML Void element
  between the updated EBML Head & the following element, usually a Matroska
  Segment element. This isn't widely supported by programs including
  MKVToolNix itself, causing them to declare such files as invalid. The
  programs will now create the EBML Void element inside the EBML Head element,
  making them a level 1 element instead of a level 0 element. Fixes #3355.
* mkvpropedit, MKVToolNix GUI's chapter & header editors: often the programs
  have to relocate the Master elements in which the modifications were
  done. In that case the Seek Head elements must also be updated to reflect to
  the Master elements' new positions. If a file contained a Seek Head element
  at the start already and if that Seek Head was too small to contain the
  updated positions, the programs would end up in an endless loop trying to
  write data to the end, creating ever-growing files. This is now handled
  properly by voiding this too-small Seek Head & finding a proper space for a
  new one instead. Fixes #3338.
* MKVToolNix GUI: header editor: fixed pixelated icons on higher display
  scaling values. Fixes #3420.

## Build system changes

* bug fix: libFLAC detection is now done via `pkg-config`, and the
  corresponding compiler flags are honored. Fixes static compilation with
  newer versions of libFLAC with MXE where a compiler definition is required
  to signal that it libFLAC wasn't built as a DLL.


# Version 71.1.0 "Fortitude" 2022-10-09

## Bug fixes

* Chapters DTD: added the new edition & chapter elements from Matroska v5.
* Chapters DTD: fixed EditionUID being mandatory. mkvmerge can auto-generate
  it if it's missing from the XML file.
* Chapters DTD: fixed the `example-chapters-1.xml` not validating against the
  DTD.
* Chapters DTD: corrected the old name `EditionManaged` to
  `EditionFlagOrdered`.
* Chapters DTD: fixed `ChapLanguageIETF` missing its element declaration &
  `ChapterLanguage` being required.
* XML DTDs: fixed elements representing binary data not allowing the `format`
  attribute.

## Build system changes

* bug fix: configure accidentally tested for libEBML ≥ 2.0.0 & libMatroska ≥
  2.0.0, even though the actual requirements are 1.4.4 & 1.7.1 respectively.


# Version 71.0.0 "Altitude" 2022-10-08

## New features and enhancements

* mkvmerge, MKVToolNix GUI's multiplexer: added support for the Emphasis audio
  track header element via the `--audio-emphasis` option. It is also read from
  Matroska files.
* mkvmerge: the options `--list-stereo-modes` and `--list-audio-emphasis` have
  been added to list all support numerical & textual values for the
  `--stereo-mode` & `--audio-emphasis` options.
* mkvpropedit, MKVToolNix GUI's header editor: added support for the Emphasis
  audio track header element via the `emphasis` property.
* MKVToolNix GUI: multiplexer: when the track properties are
  configured to be displayed in a tab widget below the files & tracks
  in the "Input" tab, the "Color information" tab will be laid out in
  two columns. This reduces the minimum height the whole tab widget
  requires. Implements #3401.
* MKVToolNix GUI: greatly sped up closing the preferences dialog by only
  re-running certain initialization functions when their corresponding
  settings have changed. Also fixes issues such as #3406.
* mkvinfo, MKVToolNix GUI's info tool: added support for the following new
  elements from Matroska v5: Emphasis audio track header element; Chapter Skip
  Type; Edition Display; Edition String; Edition Language IETF.
* mkvmerge, mkvpropedit: added support for the following new chapter elements
  from Matroska v5: Chapter Skip Type; Edition Display; Edition String;
  Edition Language IETF. The GUI's chapter editor will receive support for
  them in the next release.

## Bug fixes

* mkvmerge: Ogg/OGM reader: mkvmerge will now correctly skip tracks of
  unsupported types as well as tracks for which all track header pages
  haven't been found. Fixes #3394.

## Build system changes

* libEBML 1.4.4 & libMatroska 1.7.1 are now required.
* The bundled libEBML & libMatroska libraries were updated to v1.4.4 & v1.7.1
  respectively.
* The bundled `fmt` library was updated to v9.1.0.
* The bundled `nlohmann-json` library was updated to v3.11.2.


# Version 70.0.0 "Caught A Lite Sneeze" 2022-08-14

## New features and enhancements

* MKVToolNix GUI: the user can now control where the job queue files & the
  preferences INI file are stored via environment variables. If set, the
  variable `MKVTOOLNIX_GUI_STATE_DIR` can point to a directory where the GUI
  stores both the job queue sub-directory and the preferences INI file. If you
  only want to relocate the preferences INI file, you can store the desired
  file name for the INI file in `MKVTOOLNIX_GUI_CONFIG_FILE`. Implements
  #3382.
* MKVToolNix GUI: when adding directories via drag & drop/copy & paste the GUI
  will now offer the user the option to create one multiplex settings tab per
  directory & adding all files from that directory to the corresponding, newly
  created tab. Implements #3371.

## Bug fixes

* mkvmerge: AV1 OBU parser: fixed identifying files that only contain single
  frame. Fixes #3380.
* MKVToolNix GUI: multiplexer: when reading color parameters from identified
  files that are floating point numbers (minimum/maximum luminance, projection
  pitch/roll/yaw) the numbers will be formatted in floating-point notation
  instead of scientific notation as mkvmerge only supports the former. Fixes
  #3368.
* MKVToolNix GUI: multiplexer: color parameters that are floating point
  numbers (minimum/maximum luminance, projection pitch/roll/yaw) will only be
  set to a value during identification if the identification actually contains
  the property, and not to 0 anymore if it doesn't.

## Build system changes

* Several merge requests where accepted that improve compilation on MSYS2 on
  Windows. Note that this build type isn't supported.


# Version 69.0.0 "Day And Age" 2022-07-09

## Important notes

* all: the spelling of "colour" was changed to "color" throughout all programs
  to match the use of American English spelling in MKVToolNix. This not only
  affects documentation and user interface controls, but also program options
  for mkvmerge & mkvpropedit. Both programs will continue to accept the
  British English spelling of their respective options indefinitely. One
  breaking change is that the property names in mkvmerge's JSON identification
  mode have also been changed to American English spelling. As those
  properties have only been introduced in release v68, this seems like a small
  enough window to make such a change.

## New features and enhancements

* MKVToolNix GUI: the number of recently used entries (e.g. destination
  directories) remembered by the GUI can now be configured in the
  preferences. Implements #3362.
* MKVToolNix GUI: multiplexer: when adding files the track properties
  regarding color information & color mastering meta information will be
  parsed & set in the corresponding GUI controls. Implements #3359.
* MKVToolNix GUI: job queue: the job queue can now be sorted by clicking on
  the column headers. Part of the implementation of #3365.
* MKVToolNix GUI: job queue: when loading jobs from the queue directory that
  weren't previously known to the program those jobs will be sorted by their
  "date added" timestamp instead of using the order the operating system
  returns them in. Part of the implementation of #3365.

## Bug fixes

* build system: fixed compilation with fmt v9. Fixes #3366.
* mkvmerge: HEVC ES parser: the parser will now parse at least the first full
  access unit before reporting that it has found all the required
  headers. Otherwise parsing might stop in the middle of the access unit due
  to the source reader not providing more data in the first call, leading to
  the parser not finding the `unspec62` and `unspec63` NALUs required for
  Dolby Vision. Fixes #3363.
* MKVToolNix GUI: preferences: the default actions added to the "execute
  programs" section on new installations now default to use WebM file names
  instead of Ogg, matching the format of the included audio files.

## Build system changes

* The bundled `fmt` library was updated to v9.0.0.


# Version 68.0.0 "The Curtain" 2022-05-22

## New features and enhancements

* mkvmerge: HDMV PGS subtitles: mkvmerge now tries to detect bogus timestamps
  (where the current timestamp is two hours or more after the previous
  timestamp) & correct them to something more sensible (1s after the previous
  timestamp). That way one bogus timestamp cannot cause the rest of the frames
  to not be interleaved properly with the other audio & video
  packets. Implemented for #3268.
* mkvmerge: added color information, color mastering meta information &
  video projection information properties to the JSON identification
  format. The properties are reported for container types for which mkvmerge
  supports reading them (Matroska & MP4). The JSON identification format
  version number has been bumped to v15.
* MKVToolNix GUI: multiplexer: added controls for all the video color
  information & the video projection information.

## Bug fixes

* mkvmerge: SRT reader: entries with a duration of 0 or less will now be
  skipped. Fixes #3332.
* mkvpropedit, MKVToolNix GUI's chapter & header editors: fixed an invalid
  memory access when trying to update existing Matroska files whose EBML Head
  element had a "size" field length of eight bytes, and where rewriting said
  element would shrink the element by one byte. Files created by gstreamer fit
  the first part whereas the second depends on the changes requested by the
  user. Part of the fix of #3325.
* mkvpropedit, MKVToolNix GUI's chapter & header editors: fixed the programs
  not handling having to remove EBML void elements at the end of the file
  correctly and consequently aborting. Part of the fix of #3325.
* MKVToolNix GUI: the GUI now uses almost all SVG icons, allowing proper
  scaling even for scaling factors such as 125%. Fixes #3335.
* MKVToolNix GUI: when compiled with Qt 5 the character set of INI files is
  forced to UTF-8 in order to fix reading INI files written by a version
  compiled with Qt 6. Fixes #3346.

## Build system changes

* Qt's SVG library is now required.


# Version 67.0.0 "Under Stars" 2022-04-10

## New features and enhancements

* all: IETF BCP 47/RFC 5646 language tags: when deriving the legacy language
  element codes to use a language tag's ISO 639 code is also potentially
  interpreted as an & its prefix is used as the legacy language code. For
  example, "Yue Chinese" = `yue` is not part of ISO 639-2. However, there is
  an extlang subtag `yue` with a valid prefix of `zh` ("Chinese"), and for
  "Chinese" there is an ISO 639-2 language code: `chi`. In this example the
  IETF language element would be set to `yue` and the corresponding legacy
  element to `chi`. Part of the implementation of #3307.
* all: IETF BCP 47/RFC 5646 language tags: grandfathered language tags are now
  supported. Part of the implementation of #3307.
* all: IETF BCP 47/RFC 5646 language tags: all deprecated subtags from the
  IANA language subtag registry are now supported. Part of the implementation
  of #3307.
* all: IETF BCP 47/RFC 5646 language tags: all lists of valid subtags have
  been updated from their respective authoritative sources. Part of the
  implementation of #3307.
* all: IETF BCP 47/RFC 5646 language tags: all in the IANA language subtag
  registry are now supported, even those marked as deprecated and of type
  'grandfathered'. Part of the implementation of #3307.
* all: IETF BCP 47/RFC 5646 language tags: reduced the maximum number of
  extended language subtags that are present in a valid tag from 3 to 1 in
  compliance with RFC 5646 section 2.2.2. Part of the implementation of #3307.
* all: IETF BCP 47/RFC 5646 language tags: all language codes reserved for
  private/local use (`qaa`–`qtz`) are now supported. Part of the
  implementation of #3307.
* all: IETF BCP 47/RFC 5646 language tags: Digital Cinema Naming Convention
  language codes that fall into the IETF BCP 47 range of "private use" tags
  (`qaa`–`qtz`) are now replaced by their IETF BCP 47 equivalents during
  normalization (e.g. `QMS` → `cmn-Hans`). Part of the implementation of
  #3307.
* all: added a new translation to Chinese Simplified (Singapore) by Dian Li.
* mkvmerge, mkvpropedit: added a new command line option called
  `--enable-legacy-font-mime-types`. With this option on the two programs will
  use the same legacy MIME types for fonts whenever new attachments are added
  (both programs), when reading existing attachments (only `mkvmerge`) or when
  replacing existing ones (only `mkvpropedit`).
* mkvmerge, mkvpropedit: IETF BCP 47/RFC 5646 language tags: added a command
  line option `--normalize-language-ietf <mode>` which turns on normalization
  of IETF BCP 47 language tags to either their canonical (mode `canonical`) or
  extended language subtags form (mode `extlang`) or turns it off (mode
  `off`). If the option isn't given, language tags will now be normalized to
  the canonical form. Part of the implementation of #3307.
* MKVToolNix GUI: IETF BCP 47/RFC 5646 language tags: ISO 639-3 and 639-5
  languages will now be used by default. Part of the implementation of #3307.
* MKVToolNix GUI: IETF BCP 47/RFC 5646 language tags: the language editor
  dialog will now show warnings in several cases: when deprecated tags are
  used; when the tag's canonical and/or extlang forms differ from the user
  input. Part of the implementation of #3307.
* MKVToolNix GUI: IETF BCP 47/RFC 5646 language tags: the language editor now
  has a button to replace the current tag with a normalized form (canonical or
  extlang) if those differ from the current tag. Part of the implementation of
  #3307.
* MKVToolNix GUI: IETF BCP 47/RFC 5646 language tags: added an option in the
  preferences to always normalize all language tags to their canonical or
  extlang forms or to turn normalization off. Can also be enabled from the
  language editor dialog. Part of the implementation of #3307.
* MKVToolNix GUI: IETF BCP 47/RFC 5646 language tags: the language dialog now
  shows a warning if a variant is used with a prefix that isn't in the
  variant's list of suitable prefixes. It'll also say if the corresponding
  canonical/extlang forms would have a suitable prefix. Part of the
  implementation of #3307.
* MKVToolNix GUI: IETF BCP 47/RFC 5646 language tags: the language dialog now
  shows a warning if a script is used with a language for which it should be
  suppressed. Part of the implementation of #3307.
* MKVToolNix GUI: multiplexer: the track property group boxes in the
  scrollable pane are now collapsible & expandable, saving their state over
  restarts of the GUI. This is in preparation of adding many more track
  properties in future releases, allowing the user to hide parts they don't
  use all that often.
* MKVToolNix GUI: multiplexer: if the option "use legacy font MIME types" is
  enabled in the preferences, the new command line option
  `--enable-legacy-font-mime-types` will be passed to `mkvmerge` in order to
  have it remap the MIME types of existing attachments, too.

## Bug fixes

* all: IETF BCP 47/RFC 5646 language tags: variants aren't validated wrt. to
  prefixes anymore as BCP 47 doesn't actually pose restrictions on them,
  saying only that prefixes "are suitable sequences" for use with the
  variants. What is now verified, though, is that no variant is used multiple
  times within the same language tag. Part of the implementation/fix of #3307.
* build system & MKVToolNix GUI: fixed detecting the presence of & the
  compilation with the multimedia module of Qt version 6.2.0 and newer.
* build system: fixed compilation on Unices other than Linux & macOS
  (e.g. FreeBSD). Fixes #3316.
* MKVToolNix GUI: job queue: fixed compiling in the audio player code for the
  the "play audio" end-of-job action. Fixes #3303.
* MKVToolNix GUI: multiplexer: recognizing added XML chapter, segment info or
  chapter files required the XML declaration & root node (e.g. `<?xml…?> …
  <Chapters>` for chapters) be located within the first 1 KB, which wasn't
  enough for files that contain a lot of comments at the start like the
  included `example-chapters-2.xml`. The detection range was extended to 10
  KB. Fixes #3302.

## Build system changes

* build system: the provided Windows binaries are now compiled with Qt 6. A
  drawback is that certain audio formats aren't supported anymore by Qt for
  the "end of job" sound notification playback, notably the Ogg file format &
  the Vorbis audio codec. MKVToolNix therefore now ships Opus-in-WebM files
  for the same purpose.
* The bundled `fmt` library was updated to v8.1.1.
* The bundled `nlohmann-json` library was updated to v3.10.5.
* The bundled `pugixml` library was updated to v1.12.1.


# Version 66.0.0 "Josie" 2022-03-13

## New features and enhancements

* mkvpropedit: added a new option `--chapter-charset` allowing the user to
  specify the character set to use when reading the following chapter
  file. Implements #3276.
* MKVToolNix GUI: each language shortcut can now be associated with an
  optional track name that is set along with the language when the shortcut is
  used. This is an alternative to the feature requested in #3283.

## Bug fixes

* mkvmerge: Ogg/OGM reader: mkvmerge will no longer abort with an exception
  when it encounters Vorbis comments that contain data that isn't valid
  UTF-8. Fixes #3290.
* MKVToolNix GUI: multiplexer: fixed several issues with the tab order of
  elements in the "properties" pane and the "output" tab. Also fixed the
  language display widgets (e.g. "track language" in the "properties" pane)
  never receiving tab focus. Fixes #3274.
* MKVToolNix GUI: multiplexer: the chapter name template will now be passed to
  `mkvmerge` if a chapter file is selected on the "output" tab. Fixes #3295.


# Version 65.0.0 "Too Much" 2022-02-06

## New features and enhancements

* mkvmerge: the options `--default-track` and `--forced-track` have been
  renamed to `--default-track-flag` and `--forced-display-flag` respectively
  for improved consistency with other option names & the wording used in the
  GUI. However, the old names will be supported and recognized
  indefinitely. What will remain unchanged is the property names for those
  flags in mkvmerge's identification output. Existing third-party programs
  will continue working as they are.
* mkvmerge: added a new option `--track-enabled-flag` to set or unset the
  "track enabled" track header flag.
* mkvmerge: MP4 reader: `mkvmerge` will now evaluate the `flags` field of the
  track header atom (`tkhd`) and set the track's "enabled" flag
  accordingly. Implements #3272.
* MKVToolNix GUI: multiplexer: added support for the "track enabled" track
  header flag.
* MKVToolNix GUI: multiplexer, header editor: added several menu entries &
  keyboard shortcuts for toggling various track flags of the currently
  selected tracks, e.g. `Ctrl+Alt+F, D` (that's `Ctrl` and `Alt` with `F`
  simultaneously followed by `D` without any other key pressed) for toggling
  the "default track" flag. Part of the implementation of #3253.
* MKVToolNix GUI: multiplexer, header editor: added menu entries & keyboard
  shortcuts for setting the language of the currently selected tracks to one
  from a configurable list of languages. The shortcuts used are `Ctrl+Alt+A,
  1` through `Ctrl+Alt+A, 0` for the first ten entries of that list (that's
  `Ctrl` and `Alt` with `A` simultaneously followed by a digit without any
  other key pressed). Part of the implementation of #3253.
* MKVToolNix GUI: chapter editor: if the user enters commas in start or end
  timestamps they will automatically be changed to points as the decimal
  separator, allowing for easier copy & paste from other
  programs/sources. Implements #3273.
* MKVToolNix: header editor: the selected track or attached file can now be
  moved up & down with the keyboard shortcuts `Ctrl+Up` & `Ctrl+Down`
  respectively. Part of the implementation of #3253.

## Bug fixes

* mkvmerge: Matroska reader: DVB subtitle tracks with a codec private data
  size of more than five bytes are accepted now, too. Fixes #3258.


# Version 64.0.0 "Willows" 2021-12-27

## New features and enhancements

* MKVToolNix GUI: language dialog: when the user switches between the two edit
  modes, the mode's corresponding first control is automatically focussed.

## Bug fixes

* all: language lists: the entries for "Ancient Greek (to 1453)" and "Modern
  Greek (1453-)" have been renamed to "Greek (ancient, -1453)" and "Greek
  (modern, 1453-)" respectively in order to be easier to find.
* mkvmerge: VobSub reader: files containing `id: --` lines to indicate that
  the track language isn't known were rejected by `mkvmerge`. Now they're
  accepted, and `und` (undetermined) is used as the language. Fixes #3246.
* MKVToolNix GUI: chapter editor: the "Save to Matroska or WebM file" function
  was using the wrong standard file dialog (the "open file" one instead of
  "save"), leading to confusing button names. Fixes #3242.
* MKVToolNix GUI: high DPI scaling: fixed the icons in the tool selector
  having the wrong size for scaling factors other than 100% or 200%. Fixes
  #3229.

## Build system changes

* The bundled `fmt` library was updated to v8.0.1.
* The bundled `nlohmann-json` library was updated to v3.9.1.
* The bundled `pugixml` library was updated to v1.11 revision 6a76cac.
* The bundled `utf8-cpp` library was updated to v3.2 revision b85efd6.


# Version 63.0.0 "Everything" 2021-11-14

## New features and enhancements

* mkvmerge: AC-3 parser: E-AC-3 with BSID values > 10 and ≤ 15 are recognized
  now, too. Implements #3211.
* mkvmerge: when using language codes for track selection (e.g. `-a und,en`)
  all tracks that do not have a language property (due to their container not
  providing one, e.g. AVIs) will be treated as if they did have one set to
  `und` ("undetermined") as that is the language the track will have in the
  Matroska file anyway. Before this change it wasn't possible to match such
  tracks via language codes.
* MKVToolNix GUI: only on Windows: when compiled with Qt ≥ 5.14 and < 6 (which
  is the case for the officially provided binaries) fractional screen scaling
  will be enabled. This means that the GUI will be scaled appropriately if
  Windows is set to 125%, 150% or 175% instead of being too small or too
  large. Implements #3043.
* MKVToolNix GUI: the spinner in the bottom right corner will now be hidden
  when no jobs are currently running. Implements #3225.
* MKVToolNix GUI: header editor: a new column has been added to the tree view
  showing the status of the "track enabled" flag. The information is also
  shown on the track overview page on the right. Implements #3228.
* MKVToolNix GUI: header editor: users can now reorder tracks by dragging &
  dropping. Implements #3227.

## Bug fixes

* mkvmerge: AVI reader: fixed reading AVI files that contain `vprp` video
  properties header chunks; reading aborted too early. Fixes #3209.


# Version 62.0.0 "Apollo" 2021-10-10

## New features and enhancements

* all: IETF BCP 47/TFC 5646 language tags: all ISO 639 languages are now
  available, even the ones that aren't of types "Constructed", "Living" or
  "Special".
* mkvmerge, mkvpropedit: chapters: both programs will now write elements set
  to their default value, too (e.g. the legacy language element if it's set to
  `eng`). This is done to be more consistent with how MKVToolNix GUI writes
  chapters. Implements #3210.
* MKVToolNix GUI: multiplexer: when adding new files as attachments the GUI
  checks if there are other attachments with the same name. If so, the GUI
  would ask whether to skip the affected files or add them anyway. There's now
  an option in the preferences to always skip such files, and it's enabled by
  default. Implements #3213.
* MKVToolNix GUI: chapter editor: removed the support for explicitly setting
  the legacy country elements. Instead the legacy country elements are derived
  from the region parts of the IETF BCP 47 languages. Part of the
  implementation of #3193.

## Bug fixes

* mkvmerge: fixed a crash when splitting by chapters is enabled but there are
  no chapters at all. Part of the fix of #3198.
* mkvmerge: the error message when trying to split by a chapter number that
  doesn't exist contained the wrong number of chapters that actually do
  exist. Part of the fix of #3198.
* mkvmerge: AVC ES parser: fixed mkvmerge aborting due to uncaught exception
  when encountering bad SPS data. Part of the fix of #3176.
* mkvmerge: AVC/H.264 parser: re-added the hack `--engage
  all_i_slices_are_key_frames` which was accidentally removed in release v61.
* mkvmerge: AVI reader: fixed a crash trying to allocate too big of a memory
  chunk due to an integer overflows in check conditions. Part of the fix of
  #3176.
* mkvmerge: HEVC ES parser: fixed another issue with frame type
  recognition. Certain frames were marked as B frames/discardable on the
  container level even though they could be reference pictures. Now only SLNR
  pictures (sub-layer non-reference) are marked that way. Fixes #3192.
* mkvmerge: HEVC ES reader: improved file content detection for HEVC ES files
  with wrong file name extensions (e.g. `.mkv`), which fixes them being
  mis-detected as something else, e.g. DTS. Fixes #3201.
* mkvmerge: HEVC ES parser: "end of sequence" NALUs are kept now, and no
  superfluous flushing will be done when one is found. This prevents splitting
  NALUs into two different Matroska blocks when they should really be part of
  a single one, also causing problems with erroneous timestamps. Mostly
  affects DoVi NALUs. Fixes #3202.
* mkvmerge: Matroska reader, TrueHD: mkvmerge will now probe much more TrueHD
  frames trying to find the first sync frame. This fixes track detection in
  situations when a TrueHD doesn't start with a sync frame, e.g. when the
  source file's the result of splitting between sync frames.
* mkvmerge, MKVToolNix GUI's chapter editor: IETF BCP 47/RFC 5646 language
  tags: when reading chapters from MPLS playlist files, the `ChapLanguageIETF`
  element will now be set to the configured default chapter language, not just
  the legacy `ChapterLanguage` element. Part of the fix of #3193.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: IETF BCP 47 elements
  will now always be created before writing chapters unless IETF BCP 47
  elements are disabled. Part of the fix of #3193.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: when a chapter
  display element contains legacy language & country elements but no IETF BCP
  47 elements and IETF BCP 47 elements aren't disabled, the IETF BCP 47
  elements created will contain the region from the legacy element. Part of
  the fix of #3193.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: Legacy country
  elements are now created when IETF BCP 47 elements are present & contain a
  region code allowed in legacy country elements. Part of the fix of #3193.

## Build system changes

* The `tools` sub-directory is now always built. The corresponding `configure`
  option `--with-tools` has been removed. The `install` target still doesn't
  install them, though.


# Version 61.0.0 "So" 2021-08-30

## New features and enhancements

* all: IETF BCP 47/RFC 5646 language tags: implemented support for officially
  registered IANA language tag extensions.
* mkvmerge: track selection: when using language tags for selecting which
  tracks to keep, mkvmerge will now use component-based language tag matching
  instead of comparing them verbatim. This means that only those components
  (language, region etc.) the user specified will be required to exist and be
  equal. For example, if a file contains three subtitle tracks with languages
  `es` (generic Spanish), `es-MX` (Spanish as spoken in Mexico) and `es-ES`
  (Spanish as spoken in Spain), the user can use `--stracks es` to match all
  three tracks or be more specific with e.g. `--stracks es-MX` which would
  only match one track. Similarly inverting the selection with e.g. `--stracks
  !es` would get rid of all three tracks, not just the one for the generic
  Spanish.
* MKVToolNix GUI: multiplexer: deriving track languages from file names: the
  GUI can now detect full BCP 47/RFC 5646 language tags in file names. Part of
  the implementation of #3173.
* MKVToolNix GUI: multiplexer: deriving track languages from file names: the
  default list of boundary characters now includes `-`. Part of the
  implementation of #3173.
* MKVToolNix GUI: multiplexer: the GUI now defaults to the "lower" process
  priority setting for new installations in order to leave more room for other
  applications, especially interactive ones. Up to and including v59 the
  default was the "normal" process priority. v60 changed that to "lowest",
  which turned out to be much slower on Windows for no real gain over
  "lower". The setting will be auto-corrected by the GUI if the settings file
  were saved last with a version between v60.0.0.0 & v60.0.0.17 & "lowest" &
  it is still set to "lowest".
* HEVC dumper development tool: the tool has been renamed to `xvc_dump` and
  extended to be able to dump AVC/H.264 bitstreams, too. It now also detects
  the type of bitstream framing (ISO 14496-15 vs. ITU-T H.264/H.265 Annex B).

## Bug fixes

* all: IETF BCP 47/RFC 5646 language tags: fixed a corner case of wrongfully
  allowing scripts/variants not listed in any of the entries in the prefix
  list when the prefix list contains prefixes restricting scripts/variants and
  a prefix solely with the language at the same time (example: the variant
  `ekavsk` with its prefixes `sr`, `sr-Cyrl` and `sr-Latn` where
  e.g. `sr-ekavsk` and `sr-Cyrl-ekavsk` should be allowed but not
  `sr-Bali-ekavsk`).
* mkvmerge: HEVC/H.265: the frame type of B frames was often wrongfully
  signalled as P frames instead, both with `BlockGroup` (missing second
  references) and `SimpleBlock` ("discardable" flag not set) elements.
* mkvmerge: SSA/ASS packetizer: the frame numbers will now be re-calculated
  when appending SSA/ASS tracks so that frame numbers of appended tracks are
  always strictly higher than frame numbers of the track they're appended to.
* mkvmerge, MKVToolNix GUI's chapter editor: BCP 47/RFC 5646 language tags:
  when BCP 47 language tags are used with a language code that isn't part of
  ISO 639-2, the programs will now write a legacy language element set to
  `und` ("undetermined") instead of not writing such an element at all or
  writing one with an invalid code. Fixes #3174.
* mkvmerge, MKVToolNix GUI's chapter editor: BCP 47/RFC 5646 language tags:
  the programs will ensure that the legacy and IETF language elements written
  will be unique within the scope of the same "chapter display" element.
* mkvinfo, MKVToolNix GUI's info tool: in summary mode the frame type was
  reported wrong for `BlockGroup` elements in which the `ReferenceBlock`
  elements were located behind the `Block` element.

## Build system changes

* all: `std::codecvt_utf8` is now used instead of Boost's
  `utf8_codecvt_facet`. The bundled copy the latter in `lib/boost` has
  therefore been removed.


# Version 60.0.0 "Are We Copies?" 2021-07-31

## New features and enhancements

* all: IETF BCP 47/RFC 5646 language tags: added support for language families
  from ISO 639-5 that aren't part of 639-2.
* all: IETF BCP 47/RFC 5646 language tags: implemented support for Alpha 2
  country codes of the "user-defined" category: `AA`, `QM`–`QZ`, `XA`–`XZ` and
  `ZZ`.
* all: IETF BCP 47/RFC 5646 language tags: updated the various lists of valid
  subtags from the official specs.
* MKVToolNix GUI: multiplexer: pressing the keyboard shortcut for the track's
  "Language" label (Alt+L for English) will now open the language dialog.
* MKVToolNix GUI: multiplexer: added an option in the preferences for turning
  off the colored boxes indicating which file each track belongs to.

## Bug fixes

* all: IETF BCP 47/RFC 5646 language tags: fixed validating extended language
  & variant subtags against their allowed prefixes (e.g. a valid tag with a
  country code as in `de-CH-1996` is recognized as valid while two generally
  known variants that aren't allowed together as in `de-1901-1996` is
  recognized as invalid).
* all: IETF BCP 47/RFC 5646 language tags: when looking up a language for a
  two- or three-letter code, the programs will no longer compare that code
  with language names as that was unintended, ambiguous (e.g. the code "Ga"
  could be interpreted as the 639-2 alpha-2 code for "Irish" or as the name of
  the language called "Ga") and only worked with languages whose name was at
  most three letters long.
* mkvmerge: HEVC/H.265: appending Matroska files with HEVC tracks might lead
  to the loss of the first couple of frames from each of the second and all
  following files. Fixes #3170.
* mkvmerge, mkvextract: HEVC/H.265 parser: fixed the programs aborting when
  parsing VPS or SPS NALUs with invalid content due to unhandled
  exceptions. Fixes #3162.
* MKVToolNix GUI: multiplexer: when the option "use legacy MIME types for font
  attachments" is enabled, the GUI will now use `application/x-truetype-font`
  for font collection files.
* MKVToolNix GUI: multiplexer: fixed escaping the `mkvmerge` argument in the
  "Show command-line options" dialog for the "Windows (cmd.exe)" mode. Fixes
  #3164.
* MKVToolNix GUI: multiplexer: when adding multiple files at once, the GUI
  will sort file names with numbers the way a human would expect it to. For
  example, `1.mp4`, `9.aac`, `10.srt`, `11.srt` are now sorted exactly that
  order instead of `1.mp4`, `10.srt`, `11.srt`, `9.aac`.
* MKVToolNix GUI: header editor: the header editor will now honor the "use
  legacy MIME types when adding font attachments" setting when adding new
  attachments.


# Version 59.0.0 "Shining Star" 2021-07-10

## New features and enhancements

* mkvmerge: WebVTT parser: the parser now follows the specs' rules for parsing
  timestamps more closely by being more lenient: it allows arbitrary number of
  spaces & tabs at the start of the line & around the arrow; it allows any
  number of digits for the hours. Part of #3139.
* MKVToolNix GUI: multiplexer: when adding a Blu-ray playlist without scanning
  for other playlists the GUI will now look for disc library information & let
  the user select which one to use if there's more than one entry. Implements
  #3143.
* MKVToolNix GUI: multiplexer: added an option for sorting files & tracks by
  track types when adding them to multiplex settings. The order is: video
  first followed by audio, subtitles and other types. Files & tracks can still
  be reordered manually later. The option is enabled by default & can be found
  in the preferences → "Multiplexer" page → "Adding files" section. Implements
  #2366.
* MKVToolNix GUI: multiplexer: added an option for recognizing file name
  sequences such as `movie.001.mp4`, `movie.002.mp4`, `movie.003.mp4` when
  adding multiple files at once. If a sequence is detected, the only first
  file will be added while the second and following file names will be
  appended to the first one. The option is enabled by default & can be found
  in the preferences → "Multiplexer" page → "Adding files" section. Implements
  #2866.
* MKVToolNix GUI: multiplexer: added small colored boxes for each file & track
  in order to indicate from which file each track is read. The colors used can
  be configured in the preferences → "Multiplexer" page → "File & track
  colors" section.

## Bug fixes

* build system: fixed compilation with fmt v8. Fixes #3151.
* mkvmerge: SRT subtitle reader: characters that aren't valid according to the
  assumed encoding of the file will now be replaced by the Unicode
  "Replacement Character" U+FFFD instead of keeping the invalid characters,
  potentially violating the Matroska specs.
* mkvmerge: WebVTT parser: the parser now accepts timestamps with hours
  larger than 99. Part of #3139.
* mkvextract: TTA extraction, only on Windows: fixed removing the temporary
  file created during extraction.
* mkvmerge, mkvpropedit, MKVToolNix GUI's multiplexer & header editor: MIME
  type detection is now done using Qt instead of the `magic` library. The main
  impact is the MIME types of TrueType & OpenType fonts are now detected
  correctly. Fixes #3137.
* mkvmerge, mkvinfo, MKVToolNix GUI's info tool: only on Windows: displaying
  dates before 1970-01-01 00:00:00 UTC or after 2038-01-19 03:14:08 UTC was
  broken. Note that the header editor was not affected. Fixes #3148.
* MKVToolNix GUI: only on 64-bit Windows: under certain conditions, the 64-bit
  Windows binaries crashed when opening dialog windows. Even though the
  underlying bug hasn't been identified, the investigation showed that
  building it with newer versions than 10.2.0 of the mingw/gcc cross-compiler
  enabled the crashes, while binaries built with 10.2.0 were fine. This
  affected v57 and v58 which were built with gcc versions 10.3.0 and 11.1.0
  respectively. For the time being I've switched back to building Windows
  binaries with gcc 10.2.0. Fixes #3132 & #3133.
* MKVToolNix GUI: multiplexer: when adding files to the multiplexer by running
  the GUI's executable with file names as command line arguments, the source
  directory will be remembered as the "last open directory" again, causing
  subsequent uses of the "open file" dialog to start in the same directory.
* MKVToolNix GUI: multiplexer: the "default track flag" column in the track
  list was missing its icons. Additionally it contained text even for things
  that aren't regular tracks and therefore do not actually have that flag
  (e.g. chapters or tags). Fixes #3144.
* MKVToolNix GUI: multiplexer: the default for the dialog asking the user what
  to do with dragged & dropped files if they've never seen the dialog is back
  to adding the files to the current multiplex settings instead of "add as
  additional parts" which was an unintentional default.
* MKVToolNix GUI: multiplexer: the "show command line" dialog will now always
  use backward slashes for the "Windows (cmd.exe)" mode and forward slashes
  for the "Linux/Unix shells" mode, regardless of the operating system it's
  currently running on. Fixes #3155.

## Build system changes

* The Qt library is now required for building all applications, even the
  command-line ones, as they use Qt's MIME type detection capabilities. In
  turn this means that you cannot disable the Qt usage anymore; either Qt5 or
  Qt 6 is required.

  You can still chose not to build MKVToolNix GUI, though. A new option has
  been added to `configure` for this purpose: `--disable-gui`.
* The `gmp` library is now required.
* The `magic` library is not used anymore.
* The `PCRE2` & `JPCRE2` libraries are not used anymore. The bundled version
  of `JPCRE2` was removed.
* Boost's "rational" library is not used anymore.
* `configure`: the option `--enable-appimage` has been removed. The location
  of the relevant directories within an AppImage is now detected
  automatically.
* The bundled `fmt` library was updated to v8.0.0.


# Version 58.0.0 "Supper's Ready" 2021-06-13

## New features and enhancements

* mkvmerge, MKVToolNix GUI's multiplexer: the handling of the "default track"
  flag has been changed to match the recent changes to the Matroska
  specifications. The new semantics are that if it is set, it is supposed to
  signal to the player that this track is eligible for being played by
  default, potentially taking other factors such as user preferences regarding
  languages into account.

  This implies that more than one track of each type can have this flag
  set. For example, a Blu-ray disc with three audio tracks might have
  the main audio in both English and Japanese, whereas the third audio
  track contains the director's comments. In such a case the first two
  tracks should have the "default track" flag set, the third one
  shouldn't.

  Earlier `mkvmerge` was enforcing that only one track of each type could have
  the flag set. This restriction has been removed, both in `mkvmerge` and in
  the GUI's multiplexer.

  `mkvpropedit` and the GUI's header editor are unaffected as they've always
  allowed to set the flag on as many tracks as the user wanted.
* mkvmerge: AVC/H.264 & HEVC/H.265 identification: added the stream's pixel
  dimensions (AVC only; were present for HEVC already) & default
  duration. Implements #3116.
* mkvmerge, mkvextract: HEVC/H.265: added support for reading single-layer
  Dolby Vision from Annex B type bitstream files (elementary streams). Patch
  by quietvoid. Partially implements #3113.
* mkvinfo: the option `-X`/`--full-hexdump` now affects all binary elements,
  not just the frame data in `SimpleBlock` and `BlockGroup` elements.
* MKVToolNix GUI: multiplexer: the "delay" and "sync" options can now be used
  for chapters in source files, too. Implements #3129.
* MKVToolNix GUI: when moving list entries up & down with the optional buttons
  or the keyboard shortcuts (instead of using drag & drop), the GUI ensures
  that the top-most selected entry remains visible after the move. Implements
  #3123.
* MKVToolNix GUI: added an option in the preference to use legacy MIME types
  for font attachments instead of the current standard ones
  (e.g. 'application/x-truetype-font' instead of 'font/sfnt' and 'font/ttf').


## Bug fixes

* build system: fixed filtering out optimization options when compiling the
  file `iso639_language_list.cpp` (before only numeric optimization levels
  were filtered out and only if it wasn't the last option in the list of
  flags). See #3105 for context.
* build system: when libmagic was detected via `pkg-config`, MKVToolNix was
  actually compiled without support for libmagic due to a preprocessor symbol
  not being defined.
* mkvmerge: MP4 reader: fixed an issue with timestamps overflowing when the
  file's or the track's time scale is large. Fixes #3124.
* mkvmerge, mkvextract: fixed key frame handling for `BlockGroup` elements
  with a forward reference but no backward references. Patches by Tom Yan.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: the programs will no
  longer omit writing mandatory elements set to their default value if other
  elements of the same type are present in the same master. This affects
  mostly the "chapter language" element which may occur multiple times within
  the same "chapter display" master. If it does occur multiple times and one
  of them is set to "English" (which is that element's default value), that
  element will now be written, too. Part of the fix of #3120.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: when parsing chapter
  files IETF & legacy language elements as well as legacy country elements
  will now be properly generated depending on which exist already, especially
  when there's more than one language and/or country element in a "chapter
  display" element. Part of the fix of #3120.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: fixed reading
  OGM-style chapter files with timestamps that don't have exactly three
  decimal places. Any number of decimal places between one and nine is now
  supported for nanosecond precision. Fixes #3121.
* MKVToolNix GUI: chapter editor: added/fixed support for "chapter display"
  elements with multiple languages or countries. Part of the fix of #3120.

## Build system changes

* Qt 6: added support for building with Qt 6. `configure` will look for Qt 6
  first and only continue looking for Qt 5 if Qt 6 isn't found or disabled via
  `--disable-qt6`.

  Qt 6 detection works by first looking for the `qmake6` binary. Its location
  can be specified with the `--with-qmake6=…` option.

  All other Qt 6 related facts (such as compiler & linker flags or the
  position of the other required tools such as `lconvert`, `moc`, `rcc` and
  `uic`) will be derived from the output generated by `qmake6`.

  Note that at this point Qt 6 is not yet supported for the cross-compilation
  build to Windows, nor is a static Qt 6 build supported yet.

  Note that the command line options `--enable-static-qt`,
  `--with-qt-pkg-config-modules` and `--without-qt-pkg-config` only apply to
  the Qt 5 and have no effect on Qt 6.
* Qt 5: the options for specifying the position of the tools (`--with-moc=…`,
  `--with-rcc=…` and `--with-uic=…`) have been removed. Their position will
  now be derived from the output generated by `qmake`.
* `configure`: completely disabling the GUI now requires passing both
  `--disable-qt6` and `--disable-qt` options.
* Boost's multi-precision library is now required.
* Boost v1.66 or newer is now required.

## Other changes

* The Windows build is now using an updated version of the
  `file`/`magic` library for MIME type detection of attachments. This
  affects fonts whose MIME types will now be the current standard MIME
  types (e.g. `font/sfnt` or `font/ttf` for TrueType fonts). As this
  might pose problematic with older players that only support the
  legacy MIME type (e.g. `application/x-truetype-font`), a new option
  was added in the GUI's preferences to use the legacy MIME types
  instead of the current standard ones. This is off by default.
  Builds for other operating systems have already been using newer
  versions of the `file`/`magic` library for a long time.


# Version 57.0.0 "Till The End" 2021-05-22

## New features and enhancements

* mkvmerge: MP4 reader: added support for reading Dolby Vision from MP4 files
  (FourCCs `dvh1` and `dvhe`; configuration records `dvcC`, `dvvC` and `hvcE`
  will be converted into block addition mappings). Implements #2784.
* mkvmerge: SRT subtitles: mkvmerge now accepts empty text files with the
  extension `.srt` as SRT subtitle files, enabling the creation of empty SRT
  tracks. Implements #3089.
* mkvmerge, mkvextract: HEVC/H.265: access unit delimiter NALUs will no longer
  be discarded, neither during muxing nor during extraction.
* MKVToolNix GUI: preferences: switched the order & wording of controls in the
  "enabling items" panel to make it clearer that certain controls define
  exceptions. Inspired by 3086.

## Bug fixes

* mkvmerge: HEVC/H.265 parser: several NALU types, notably the Dolby
  Vision-specific NALUs ("unspecified 62" and "unspecified 63") and suffix SEI
  NALUs, are now stored with the frame they belong to instead of with the next
  frame. Part of fixing & implementing #2784, #2818, #3093 and #3113.
* mkvmerge: HEVC/H.265 packetizer: fixed setting the track's default duration
  when reading HEVC/H.265 from Matroska files that don't have a default
  duration set.
* mkvmerge: HEVC/H.265 packetizer: fixed the calculation of the duration of
  frames so that `SimpleBlock` elements can be used again instead of
  `BlockGroups` with `BlockDuration` elements. Fixes #3114.
* mkvmerge, mkvextract: HEVC/H.265 parser: fixed issues with ordering &
  duplication of certain NALUs (parameter set & prefix SEI NALUs). Part of
  fixing & implementing of #2784, #2818, #3093 and #3113.
* MKVToolNix GUI: multiplexer: when dragging & dropping files to the
  multiplexer, the source directory will be remembered as the "last open
  directory" again, causing subsequent uses of the "open file" dialog to start
  in the same directory. Fixes #3110.
* mkvinfo: fixed the position of frames in block groups containing "block
  duration" elements in summary mode (e.g. for subtitle tracks).

## Build system changes

* `configure` will now try to detect `libmagic` via `pkg-config` and fall back
  to including & linking directly if it cannot be found via `pkg-config`.


# Version 56.1.0 "My Friend" 2021-04-09

## New features and enhancements

* mkvmerge: AAC: added support for LOAS/LATM files with channel configuration
  indexes 9–21 (e.g. channel count 22.2 for index 13) according to Rec. ITU-R
  BS.1196-7 & ISO/IEC 23008-3:2019. Fixes #3081.

## Bug fixes

* mkvmerge: HEVC/H.265 parser: fixed invalid memory access that could happen
  when reading certain types of HEVC data (e.g. with changing parameter sets
  mid-stream) from certain containers (e.g. Matroska). This bug was introduced
  in release 56.0.0. Fixes #3083.
* mkvextract: AAC: mkvextract will now abort with an useful error message when
  the user tries to extract a track whose 'audio-specific config' element in
  `CodecPrivate` signals a number of channels of 7 or greater than 8 as that
  isn't supported by the ADTS format.

## Build system changes

* configure: the `--enable-ubsan` option hasn't actually enabled anything
  since release 39.0.0.


# Version 56.0.0 "Strasbourg / St. Denis" 2021-04-05

## New features and enhancements

* mkvmerge, mkvpropedit: tags: the programs will no longer write tag elements
  that are mandatory and set to their default value (e.g. "tag language" set
  to `und` = undetermined).
* mkvmerge, mkvpropedit, MKVToolNix GUI chapter editor: chapters: the programs
  will no longer write chapter elements that are mandatory and set to their
  default value (e.g. "chapter language" set to `eng` = English or "Chapter
  flag enabled" = 1).
* mkvextract: chapters: mkvextract will no longer add a `ChapterLanguage`
  element set to `eng` to the generated XML content if the source file doesn't
  contain such an element.
* MKVToolNix GUI: multiplexer: when using the "tab widget below the files &
  tracks" layout option for the track properties the elements in the "general
  options" tab will use six rows à four columns instead of twelve rows à two
  columns, greatly reducing the required height. Implements #3062.

## Bug fixes

* mkvmerge: AAC reader: fixed mkvmerge aborting to read AAC files bigger than
  2 GB with a message about not being able to allocate memory. Fixes #3059.
* mkvmerge: chapters: `ChapLanguageIETF` elements were still created when the
  option `--disable-language-ietf` was given after an option leading to the
  creation of chapters. Now the position doesn't matter anymore. Part of the
  fix of #3069.
* mkvmerge: chapters: when the option `--disable-language-ietf` is used,
  `ChapLanguageIETF` elements won't be written even when sources are read
  (Matroska files or XML chapters files) that do contain those elements. Part
  of the fix of #3069.
* mkvmerge: tags: when the option `--disable-language-ietf` is used,
  `TagLanguageIETF` elements won't be written. Fixes #3070.
* mkvmerge: tags: mkvmerge will no longer write language elements for the
  track statistics tags it creates, making the effective language
  "undetermined" due to `und` being the default value for the legacy tag
  language element. Fixes #3073.
* mkvmerge: tags: the XML tag parser will now validate all `<Simple>` children
  of `<Tag>` elements, not just the first for each `<Tag>`. Part of the fix of
  #3071.
* mkvmerge: tags: the XML tag parser now uses the spec-compliant `und`
  ("undetermined") as the default language for `<Simple>` tags instead of
  `eng`. Part of the fix of #3071.
* mkvmerge, mkvpropedit: tags: mkvmerge will no longer set the "target type"
  for track statistics tags (earlier it used `MOVIE`). The "target type value"
  will still be set to `50`. Fixes #3074.
* mkvmerge, mkvextract: HEVC/H.265: both programs will now normalize the
  placement of VPS, SPS and PPS NALUs. Each key frame is prefixed with exactly
  one copy of the currently active parameter sets. This fixes certain classes
  of bugs related to splitting/appending. Fixes #3034.
* mkvinfo: when compiled with newer versions of the `fmt` library, certain
  numbers were not output correctly (e.g. a track's audio sampling frequency
  of 48000 might be output as 48).
* MKVToolNix GUI: multiplexer: deriving the track language from the file name
  will match languages case insensitively again (like versions prior to
  v55). Fixes #3068.
* MKVToolNix GUI: multiplexer: under certain circumstances keyboard shortcuts
  such as `Ctrl+W` for closing the active tab or `Ctrl+R` for starting to
  multiplex ceased to work until the user did certain other things (such as
  switching to a different tool & back to the multiplexer or opening the
  multiplexer menu). This started with v54. Fixes #3051.
* MKVToolNix GUI: chapter editor: the editor will no longer create empty
  `ChapterCountry` elements when adding a chapter name with no default country
  selected in the preferences. Fixes #3072.

## Build system changes

* The bundled `fmt` library was updated to v7.1.3.


# Version 55.0.0 "Waiting For Space" 2021-03-06

## Bug fixes

* all programs, only on Windows: fixed checking existence of & creating
  directories with UNC paths such as `\\server\share\folder\file.mkv`. Fixes
  #3041.
* all programs, only on Windows: implemented several workarounds for bugs in
  `std::filesystem` wrt. UNC paths. The effect of those bugs was that Blu-rays
  and DVDs couldn't be added from UNC paths. Fixes #3037.
* mkvmerge, only on Windows: fixed non-ASCII characters getting mangled in the
  destination file name when splitting is active.
* MKVToolNix GUI, only on Windows: fixed the GUI hanging when trying to browse
  for files on drives that don't actually exist. Fixes #3046.
* MKVToolNix GUI, only on Windows: the GUI did not remember UNC paths as the
  "most recently used source directory" properly.
* MKVToolNix GUI: only on Windows: when dragging & dropping files from other
  applications to MKVToolNix GUI the GUI will force the drop action to be a
  copy action, no matter which keys were pressed by the users. This prevents
  Windows Explorer from deleting the dragged file when the user presses shift
  while dropping the file onto MKVToolNix GUI.
* MKVToolNix GUI, only on Windows: when using the file dialog for selecting a
  file name to save to (e.g. when browsing for the destination file name in
  the multiplexer or saving an attachment in the header editor) non-ASCII
  characters in the default file name were mangled. Fixes #3049.
* MKVToolNix GUI: multiplexer: the user can now configure what to do when
  using the "Add source files" button independently of the setting for what
  happens when files are dragged & dropped onto the GUI. The same options are
  available, but they're distinct settings, allowing for different use
  cases. Fixes #3035.
* MKVToolNix GUI: multiplexer: deriving the track language from file names
  doesn't use one big regular expression of all enabled languages
  anymore. Instead, the file name is split into parts on a list of characters
  (such as `.` or `(` and `)`; configurable in the preferences). This prevents
  the regular expression becoming too big for the regular expression library
  to handle when many languages are enabled. Fixes #3048.
* MKVToolNix GUI: preferences: the language lists for "deriving track
  languages" and "enabling items by language" always included all the ISO
  639-3 languages, even if those weren't enabled in the "often-used languages"
  pane. Fixes #3047.

## Other changes

* mkvmerge, MKVToolNix GUI multiplexer: the functionality for changing the
  length of the NALU "size" field for AVC/H.264 and HEVC/H.265 tracks has been
  removed. The corresponding command-line option will continue to be
  recognized by mkvmerge as not to break existing third-party applications,
  but it won't actually do anything.


# Version 54.0.0 "F Maj Pixie" 2021-02-26

## New features and enhancements

* mkvmerge: added support for using ISO 639-3 language codes in IETF BF47
  language tags. Part of the implementation of #3007.
* mkvmerge: AC-3 parser: added support for byte-swapped AC-3 data. Implements
  #3022.
* mkvmerge: Matroska reader: for audio tracks that have the bit depth track
  header set mkvmerge will now keep that header even for codecs that don't
  require it for decoding. Implements #3009.
* mkvmerge: MPEG transport stream reader, PCM audio tracks: mkvmerge will now
  re-order the channels for 5.1, 7.0 and 7.1 channel tracks from the Blu-ray
  layout to the WAVEFORMATEXTENSIBLE layout expected in Matroska. Patch by Tom
  Yan. Implements #2988.
* mkvmerge, mkvinfo, mkvpropedit, MKVToolNix GUI: added support for the
  following new track header elements: "hearing impaired" flag, "visual
  impaired" flag, "text descriptions" flag, "original" flag, "commentary"
  flag. Implements #3011.
* MKVToolNix GUI: added support for using ISO 639-3 language codes in IETF
  BF47 language tags. As there are several thousand of them, they're
  deactivated by default and must be activated in the preferences ("GUI" →
  "Often used selections" → "Languages"). Part of the implementation of #3007.
* MKVToolNix GUI: multiplexer: when adding Blu-rays the user can select
  multiple playlists to add simultaneously in the "select playlist to add"
  dialog. Implements #2961.
* MKVToolNix GUI: multiplexer: the file name extensions "eb3" and "ec3" were
  added for Dolby Digital Plus & "mpl" for Dolby TrueHD in the file
  dialogs. Part of the implementation of #3027.
* MKVToolNix GUI: multiplexer: when adding multiple files the dialog asking
  the user what to do with them has gained a new checkbox. If enabled, all
  files containing at least one video track will always be placed in newly
  created multiplex setting. Implements #2966.
* MKVToolNix GUI: multiplexer: added a menu entry in the "Multiplexer" for
  adding all files that are currently in the clipboard. Implements #3006.

## Bug fixes

* all: Windows: fixed compatibility with gettext 0.21 and newer on mingw.
* all: Windows: fixed several of the programs having problems with certain
  Unicode characters (primarily emojis) in file names (e.g. mkvextract
  wrongfully complaining about an "invalid mode" or the GUI not being able to
  find parts of Blu-ray file structures).
* mkvextract: AAC: fixed wrong channel mask field in the ADTS headers for 7.1
  channel layouts. Fix by Tom Yan. Fixes #2636.
* mkvextract: HEVC/H.265 extraction: if the first frame starts with the
  parameter sets (SPS, PPS & VPS), the ones from CodecPrivate aren't written
  and the ones from the first frame are kept. Fixes #3031.
* mkvmerge: fixed the calculation of chapter timestamps read from NTSC
  DVDs. Fix by Tom Yan.
* MKVToolNix GUI: IETF BCP 47 language widget: the language combo box will now
  always contain the language code the user enters in the free-form field,
  even if it isn't in the list of often-used languages the user configured in
  the preferences.
* MKVToolNix GUI: multiplexer: when browsing for the destination file name the
  default directory is now chosen according to the preferences regarding how
  the destination file name should be formed. For example, if the policy is
  set to "fixed output directory" then that output directory will be the one
  initially set when the directory selection dialog is opened. Fixes #3021.
* MKVToolNix GUI: multiplexer: fixed the removal of appended source files if
  the "delete source files" end-of-job action is enabled. Fixes #3029.
* MKVToolNix GUI: chapter editor: when importing chapters from DVDs the IETF
  BCP 47 language elements will be set, too, not just the legacy language
  elements.

## Build system changes

* libEBML v1.4.2 and libMatroska v1.6.3 are now required. The optional,
  bundled copies of both libraries have been updated to those versions. This
  bump in requirements fixes several heap overflow bugs in libEBML.
* MKVToolNix is now using the C++17 library feature "file system library"
  instead of Boost's "file system" and "system" libraries. For the GNU
  Compiler Collection (gcc) libstdc++ this means v8 or newer is required; for
  clang's libc++ it means v7 or newer. For macOS this means that provided disk
  image will only run on 10.15 "Catalina" or newer.


# Version 53.0.0 "Fool's Gold" 2021-01-30

## New features and enhancements

* mkvmerge: AVI reader: added support for reading the video aspect ratio from
  the video properties header (`vprp` chunk) if present and setting the
  display dimensions accordingly. Implements #2993.
* mkvmerge: MP4 reader: for AVC/H.264 tracks that don't have an
  `AVCConfigurationBox` (`avcC` atom) in their sample description (`stsd`)
  atom or whose `avcC` atom contains no content `mkvmerge` will now re-derive
  the `AVCConfigurationBox` from the bitstream. Implements #2995.
* mkvextract: mkvextract will now check if any of the destination file names
  is the same as the source file name and abort with an error if that's the
  case. Implements #3001.
* MKVToolNix GUI: when querying the user for a file name for saving things
  (e.g. multiplexer settings or an attachment in the header editor), the
  automatically suggested file name will now be based on the
  situation-specific file names (e.g. the destination file name for
  multiplexer settings or the attachment's name when saving an attachment in
  the header editor) instead of the directory's name. Implements #3012.
* MKVToolNix GUI: multiplexer: when deriving track languages from file names
  the GUI will now select the right-most match instead of the left-most
  one. For example, "La.vie.en.rose.(fr).srt" will now be detected as French
  (fr) instead of English (en). Implements #3013.
* MKVToolNix GUI: preferences: the items in the "pre-defined …" lists can now
  be renamed by double-clicking with the mouse or pressing the F2 key.
* Windows installer: the `bluray_dump` command-line utility will be installed
  into the `tools` sub-directory. `bluray_dump` can read & dump certain file
  types used on Blu-rays: `.mpls` playlists, `.clpi` clip information
  databases, `.bdmv` index files, `bdmt_….xml` disc library databases and
  `tnmt_….xml` track & chapter name databases.

## Bug fixes

* mkvmerge: stretching chapter timestamps with `--chapter-sync` now works
  correctly with floating point values including fractions of floating point
  numbers (e.g. `12.3/45.67`). The tooltips in the GUI have been adjusted
  accordingly. Fixes #3002.
* mkvmerge: MPEG 1/2 video handling: the "default duration" header field was
  often half the value it actually should be, resulting in all video frames
  having an explicit block duration with the correct value. This has been
  fixed with a patch by Tom Yan.
* mkvmerge: MPEG 1/2 video handling: the data stored in `Codec private` and
  `Codec state` doesn't contain extensions other than sequence & sequence
  display extensions anymore. Fix by Tom Yan.
* mkvmerge: tag handling: when remuxing a Matroska file with the
  `--no-track-tags`, existing `SOURCE_ID` track tags are now skipped, too.
* MKVToolNix GUI: multiplexer: the drop-down boxes with pre-defined track
  names now follow the order set in the preferences instead of sorting the
  entries alphabetically. Fixes #2999.


# Version 52.0.0 "Secret For The Mad" 2021-01-04

## New features and enhancements

* MKVToolNix GUI: job queue: the maximum number of jobs to run concurrently
  can now be increased in the preferences. The default remains
  at 1. Implements #2984.
* MKVToolNix GUI: the GUI will now add a context-specific default extension to
  file names selected for saving on platforms that don't add one itself
  (e.g. GNOME). For example, when saving multiplexer settings the extension
  `.mtxcfg` will be added. Implements #2983.
* MKVToolNix GUI: added an option to the preferences for the window to stay on
  top of other windows. Implements #2967.

## Bug fixes

* mkvextract: HEVC/H.265 extraction: the code for skipping extraction of
  prefix SEI NALUs in the first frame was skipping two bytes too few,
  resulting in broken processing of all following bytes. Patch by Mike Chen.
* libEBML: the optional, bundled version of libEBML was updated to v1.4.1.

## Build system changes

* libEBML v1.4.1 is now required due to a bug in libEBML that caused pointers
  to just-freed memory being returned to the caller under certain invalid data
  constellations, causing use-after-free errors in all of MKVToolNix's
  programs. Fixes #2989.


# Version 51.0.0 "I Wish" 2020-10-04

## New features and enhancements

* mkvmerge, mkvpropedit, MKVToolNix GUI: IETF BCP 47 language tags: added
  missing support for UN M.49 regions for which there are no corresponding ISO
  3166 alpha codes. This enables language tags such as `es-419` = Spanish in
  Latin America and the Caribbean. Implements #2919.
* MKVToolNix GUI: IETF BCP 47 language tags: the text in the widget displaying
  the current language & the corresponding edit button is now displayed like a
  link (depending on the theme: different color & underlined), making it
  clearer that not just the edit button can be clicked but the text, too.

## Bug fixes

* mkvmerge: AV1 parser: fixed mkvmerge crashing after uncaught exceptions due
  to certain data conditions. Found by fuzzying.
* mkvmerge: AV1 packetizer: the duration of frames wasn't set properly. When
  appending AV1 IVF or OBU files this meant that the last frame of the Nth
  file and the first frame of file N+1 had the same timestamp. Fixes #2937.
* mkvmerge: DTS reader: fixed handling of buffers with an odd length when
  byte-swapped DTS is detected so that mkvmerge doesn't abort with a failed
  assertion. Found by fuzzying.
* mkvmerge: AVC/H.264 and HEVC/H.265 elementary stream readers: mkvmerge will
  no longer claim to recognize data that looks like AVC or HEVC but with
  invalid video width/height values as that lead to failed assertions in
  libEBML later. Found by fuzzying.
* mkvmerge: HEVC/H.265 parser: fixed mkvmerge aborting after uncaught
  exceptions due to certain data constellations found by fuzzying.
* mkvmerge: IVF reader: fixed mkvmerge crashing with a "division by zero"
  error due to certain data conditions. Found by fuzzying.
* mkvmerge: fixed mkvmerge aborting with a "division by zero" error due to the
  timestamp scaling factor being 0 after handling certain data constellations
  found by fuzzying.
* mkvmerge: track statistics: fixed a "division by zero" error when the
  content's shorter than 1ms. Found by fuzzying.
* mkvmerge, mkvinfo, mkvextract, mkvpropedit: Matroska access class: fixed an
  invalid memory access under certain data conditions. Found by fuzzying.
* MKVToolNix GIU: IETF BCP 47/RFC 5646 language tags: the GUI will no longer
  open the language dialog when clicking on a disabled language display
  widget.
* MKVToolNix GUI: IETF BCP 47 language tags: the "variants" combo-boxes were
  not populated even when the language tag was valid and contained at a
  variant. Fixes #2923.
* MKVToolNix GUI: IETF BCP 47 language tags: when no language is selected, at
  least one of the other components (extended subtags, region, or variants)
  has something selected and "private use" is not empty, the GUI would claim
  this to be a valid tag, which it isn't. Fixes #2924.
* MKVToolNix GUI: multiplexer: when the tracks/chapters/tags selection changes
  from "at least one entry selected" to "no entry selected", the input
  controls will be reset to their default state and not just disabled. Fixes
  #2927.

## Build system changes

* `configure` now checks for the presence of the a system-wide installed copy
  of the JPCRE2 C++ wrapper library for the PCRE2 library and uses that if
  it's new enough (at least v10.32.1). If not, the bundled version will be
  used as a fallback. Implements #2929.


# Version 50.0.0 "Awakenings" 2020-09-06

## New feature: IETF BCP 47 language tags

* I've written up a [nice FAQ
  entry](https://codeberg.org/mbunkus/mkvtoolnix/wiki/Languages-in-Matroska-and-MKVToolNix)
  about the switch to using IETF BCP 47 language tags, how they interact with
  legacy language elements, how the programs actually behave and how to
  disable their use if necessary.
* mkvmerge: IETF BCP 47/RFC 5646 language tags: mkvmerge will now accept full
  BCP 47 language tags for all options taking a language. mkvmerge will always
  write "LanguageIETF" track header elements. If the language tag contains a
  valid ISO 639-2 language code it will also set the legacy "Language" track
  header element to the included ISO 639-2 code. Part of the implementation of
  #2419.
* mkvmerge: IETF BCP 47/RFC 5646 language tags: if present the "LanguageIETF"
  track header element will be reported as the `language_ietf` property in
  JSON identification mode. Part of the implementation of #2419.
* mkvmerge: IETF BCP 47/RFC 5646 language tags in chapters: mkvmerge will now
  write "ChapLanguageIETF" elements when creating chapter atoms, either when
  reading the simple chapter format or when generating chapters due to the
  `--generate-chapters` command line option. Part of the implementation of
  #2419.
* mkvmerge: IETF BCP 47/RFC 5646 language tags in tags: mkvmerge will now
  write "TagLanguageIETF" elements when creating "simple tag" elements, either
  when reading tag XML files or when generating them. Part of the
  implementation of #2419.
* mkvmerge: IETF BCP 47/RFC 5646 language tags: added an option
  `--disable-language-ietf` that causes mkvmerge to only write the legacy
  language elements.
* mkvmerge, mkvpropedit, MKVToolNix GUI's chapter editor: IETF BCP 47/RFC 5646
  language tags in chapters: when reading XML chapter files the programs will
  now add "ChapLanguageIETF" elements for atoms that don't contain them. The
  values are derived from existing "ChapterLanguage" elements. Part of the
  implementation of #2419.
* mkvpropedit: IETF BCP 47/RFC 5646 language tags: setting/deleting the track
  language now acts on both the old language element as well as the
  "LanguageIETF" track header element. Part of the implementation of #2419.
* mkvpropedit: IETF BCP 47/RFC 5646 language tags: added an option
  `--disable-language-ietf` that causes mkvpropedit to apply changes to the
  `language` track header property only to the legacy language track header
  element.
* mkvinfo: IETF BCP 47/RFC 5646 language tags: added support for the
  "LanguageIETF" track header element. Part of the implementation of #2419.
* MKVToolNix GUI: multiplexer: added full support for IETF BCP 47/RFC 5646
  language tags for both track and chapter languages. Part of the
  implementation of #2419.
* MKVToolNix GUI: chapter: added full support for IETF BCP 47/RFC 5646
  language tags for chapter languages. Part of the implementation of #2419.
* MKVToolNix GUI: header editor: added full support for IETF BCP 47/RFC 5646
  language tags for track header languages. The header editor allows editing
  of the legacy language elements and the IETF BCP 47 language elements
  independent of each other. Part of the implementation of #2419.

## Other new features and enhancements

* mkvmerge: the chapter generation mode `when-appending` now also works with
  the splitting modes `parts:` & `parts-frames:` when using the `…,+…` syntax
  for appending other sections of the source file to the same destination
  file. Implements #2898.
* MKVToolNix GUI: multiplexer: the file selection dialogs now include the
  extension `.dtsma` for DTS files. Implements #2901.
* mkvmerge: MP4 reader: sped up parsing MP4 DASH files with a lot of segments
  (`trun` atoms) quite a bit. Part of the fix of #2900.
* The PCRE2 regular expression library is now used instead of `std::regex` for
  big performance improvements in all places where regular expressions are
  used for parsing big chunks of text, e.g. in the subtitle parsers. Part of
  the fix of #2899.
* all programs: Windows: all programs now support long file names on Windows
  10 release 1604 if they're turned on in the registry. Implements #2916.

## Bug fixes

* MKVToolNix GUI: preferences: under certain conditions changing the selected
  entry in the page tree on the left did not cause the page shown on the right
  to be updated. Fixes #2895.
* mkvmerge: splitting text by a fixed string (e.g. `,`) is now done by using
  `std::string.find()` instead of using a regular-expression-based text
  splitting function, greatly improving its performance. Part of the fix of
  #2899.
* mkvmerge: mkvmerge will now read-buffer file I/O when probing text file
  formats which increases its speed significantly on Windows. Part of the fix
  of #2899.
* mkvmerge: MP4 reader: fixed handling of `tkhd` atoms of version 1. Fixes
  #2900.

## Build system changes

* The PCRE2 library (the 8-bit variant) is now required.


# Version 49.0.0 "Sick Of Losing Soulmates" 2020-08-02

## New features and enhancements

* mkvmerge: added support for copying the new track header elements
  `BlockAddIDName`, `BlockAddIDType`, `BlockAddIDValue` and
  `BlockAddIDExtraData` from Matroska files if they exist. Part of the
  implementation of #2887.
* mkvinfo: added support for the new track header elements
  `BlockAdditionMapping`, `BlockAddIDName`, `BlockAddIDType`,
  `BlockAddIDValue` and `BlockAddIDExtraData`. Part of the implementation of
  #2887.
* MKVToolNix GUI: multiplexer: the list of recent directories can now be
  edited in the preferences → "Multiplexer" → "Destination file
  name". Implements #2861.
* MKVToolNix GUI: preferences: the values in the various "predefined values"
  lists can now be re-ordered freely by dragging & dropping.

## Bug fixes

* mkvmerge: Matroska reader: when reading tracks (e.g. a subtitle track) from
  Matroska files with their `default track` flag set to `yes`, and when
  overwriting those via the command line to `no`, `mkvmerge` would not promote
  additional tracks of the same type from other files (e.g. another subtitle
  track from an SRT file). Fixes #2863.
* mkvmerge: SRT reader: empty lines inside entries were doubled. Fixes #2888.
* mkvmerge: subtitles: when calculating the rounded duration of each entry the
  error from rounding the corresponding timestamp will be taken into
  account. Fixes #2890.
* mkvextract: SSA/ASS extraction: mkvextract is no longer inserting empty
  lines before the `Dialogue:` lines. Fixes #2876.
* mkvextract: USF subtitles: start & end timestamps were too high by a factor
  of 1.000.000. Fixes #2875.
* MKVToolNix: info tool: when saving to a text file the checkbox "Save as
  default for saving output to text files" did nothing. Fixes #2869.
* MKVToolNix: info tool: when saving to a text file in "all elements in a
  tree-like structure" mode, the GUI always stopped at the first cluster
  regardless of the setting of the "verbosity" option.
* MKVToolNix GUI: preferences: when tooltips were disabled the dialogs for
  adding new entries to the various "predefined values" lists were missing
  their texts.
* Windows installer: the images are shown again. Fixes #2868.
* configure: fixed detection of QtDBus. Fixes #2886.

## Build system changes

* libMatroska v1.6.1 is now required. The bundled version has been updated to
  that version.


# Version 48.0.0 "Fortress Around Your Heart" 2020-06-27

## New features and enhancements

* mkvmerge: AC-3: file identification will report AC-3 tracks encoded in Dolby
  Surround EX as codec "AC-3 Dolby Surround EX". Implements #2740.
* MKVToolNix GUI: multiplexer: on new installations the GUI will now recognize
  all known ISO 639-2 language codes in file names by default instead of only
  the top 100 of languages by native speakers.
* MKVToolNix GUI: multiplexer: on new installations the list of "often used
  languages" will by default only contain certain agnostic ones ("multiple
  languages", "no linguistic content", "reserved for local use", "uncoded
  languages"), "English" and the default user interface language. The "list of
  spoken languages by native speaks" isn't used anymore. Also implements #2716.
* MKVToolNix GUI: header editor: added an option to remove all attachments to
  the tree context menu. Implements #2835.
* MKVToolNix GUI: while the GUI is running it will remember the last page that
  was selected when the preferences dialog is closed. Upon re-opening the
  preferences that page will be selected by default. Implements #2852.

## Bug fixes

* mkvmerge: fixed a segmentation fault when exiting prematurely due to write
  errors such as the destination having run out of space. Fixes #2843.
* mkvmerge: DTS: fixed wrong channel count for DTS tracks with XCh
  extensions. Fixes #2715.
* mkvmerge: MPEG TS reader: fixed detecting AVC/H.264 and HEVC/H.265 tracks
  that consist of only a single frame. Part of the fix of #2849.
* mkvmerge: MPEG TS reader: fixed handling of unbounded PES sizes for tracks
  that consist of only a single PES packet. Part of the fix of #2849.
* mkvmerge: MPEG TS reader: PGS subtitle tracks are now exempt from the
  "detect bogus subtitle timestamps" heuristic which could lead to some PGS
  subtitles not being timestamped correctly. Symptoms were that they were
  shown at the wrong time or that they were shown indefinitely. Fixes #2736
  and partially fixes #2824.
* mkvmerge: MPEG TS reader: when reading MPLS playlists the start timestamps
  of a play items were handled wrong: all the timestamps of packets read were
  compared to that start timestamp, dropping those packets whose timestamps
  were smaller than the play item's start timestamp. The correct behavior is
  to accept all packets as soon as the first one with a timestamp equal to or
  larger than the play item's start timestamp is encountered. This could
  result in PGS subtitle entries located right at the start of the play item
  being garbled/lost as they consist of multiple PES packets for which some
  timestamps are often slightly smaller. Part of the fix of #2824.
* mkvmerge: MPEG TS reader: when reading MPLS playlists mkvmerge will no
  longer read the whole M2TS files they reference, processing only the packets
  lying inside the timestamp range given by the playlists's play item's start
  & end timestamps. Instead mkvmerge will use the index information present in
  corresponding clip information (CLPI) files in order to seek to the nearest
  file position of the play item's start timestamp. Additionally mkvmerge will
  simply stop processing a file once the end timestamp is seen. This change
  greatly speeds up processing files from which only small portions must be
  read. Part of the fix of #2824.
* mkvmerge: WavPack: fixed support for files created by v5 of the
  program. Checksums, DSD audio data and non-standard sampling rates are
  handled correctly. Patch by David Bryant.
* MKVToolNix GUI: multiplexer: fixed the cursor being positioned wrong after
  entering or pasting characters that aren't allowed in file names into the
  "destination file" control. Fixes #2855.

## Build system changes

* libEBML v1.4.0 and libMatroska v1.6.0 are now required.

## Other changes

* The source code repository's main development branch was renamed to `main`.


# Version 47.0.0 "Black Flag" 2020-05-30

## New features and enhancements

* mkvmerge: chapters: mkvmerge can now read chapters from DVDs if the user
  specifies the path to a DVD folder structure via the `--chapters …`
  parameter. By default chapters from the first title will be imported. This
  can be changed by append `:<title number>` to the file/directory name in the
  `--chapters …` argument, e.g. `--chapters /srv/dvds/BigBuckBunny/VIDEO_TS:3`
  This feature requires mkvmerge to have been built with the `libdvdread`
  library. Part of the implementation of #2808.
* mkvmerge: added `--engage append_and_split_flac` that enables mkvmerge to
  append and split FLAC tracks, restoring pre-v45 behavior. The resulting
  tracks will be broken: the official FLAC tools will not be able to decode
  them and seeking will not work as expected.
* MKVToolNix GUI: multiplexer: added support for mkvmerge's new support for
  reading chapters from DVDs if both have been built with the `libdvdread`
  library. Part of the implementation of #2808.
* MKVToolNix GUI: multiplexer: when deriving languages from file names the GUI
  will now look for simplified language names instead of the full ones
  (e.g. instead of looking for "Greek, Modern (1453-)" it would simply look
  for "Greek").
* MKVToolNix GUI: multiplexer: the options in the "additional command-line
  options" dialog are now sorted alphabetically. Additionally the
  `--append-mode` option has been added as one of the only missing global
  options.
* MKVToolNix GUI: chapter editor: the chapter editor can now read chapters
  from DVDs if MKVToolNix has been build with the `libdvdread` library. Part
  of the implementation of #2808.
* MKVToolNix GUI: header editor: added an option in the preferences for
  displaying all date & time values in UTC instead of the local time
  zone. Implements #2814.

## Bug fixes

* all: fixed a crash when using the `MTX_LOGGER=file` syntax for logging debug
  messages without specifying a file name to log to. It will now log to a file
  called `mkvtoolnix-debug.log` in the system's default temporary directory,
  as initially intended.

## Build system changes

* The [`libdvdread`](https://www.videolan.org/developers/libdvdnav.html)
  library will be used if found via `pkg-config`. If it is found, support for
  reading chapters from DVDs will be enabled in `mkvmerge` and the MKVToolNix
  GUI. Part of the implementation of #2808.
* Boost's Date/Time, Lexical Cast, Range, Range Adaptors, Tri-Bool, Variant
  libraries are not used anymore.
* MKVToolNix now requires a C++ compiler & standard library that support the
  following features of the C++17 standard: "`std::variant`", "`std::gcd`".
  For the GNU Compiler Collection (gcc) this means v7 or newer; for clang it
  means v4 or newer — the same versions required by earlier MKVToolNix
  versions.
* MKVToolNix now requires version 6.1.0 of fmtlib or later for the
  `fmt::to_string` function and bugfixes to the formatting of floating point
  numbers. If a system-wide version is installed that's older, the bundled
  copy will be used.
* The bundled version of fmtlib has been updated to release 6.2.1.


# Version 46.0.0 "No Deeper Escape" 2020-05-01

## New features and enhancements

* mkvmerge: when splitting, the placeholder `%c` can be used in the
  destination file name. It'll be replaced by the name of the first chapter in
  the file. Implements #2791.
* mkvmerge: when reading MPLS playlists mkvmerge will include a tag named
  `SOURCE_ID` in the track's statistics tags that conveys the fact that the
  source was a Blu-ray and what the track's ID was in the source
  container. When reading Matroska file existing `SOURCE_ID` tags will be
  kept. The format used is the same format MakeMKV uses. Implements #2774.
* mkvmerge: for audio-only files mkvmerge will now write a cue entry every
  500ms instead of every 2s.
* MKVToolNix GUI: job actions: split up the option "execute when the job
  finishes successfully or with warnings" into two separate options: "…when
  finishes successfully" and "…when exits with warnings". Implements #2798.

## Bug fixes

* mkvmerge: Matroska reader: when regenerating UIDs for chapters mkvmerge will
  now fix referencing tag chapter UID targets to have the same values. Fixes
  #2804.
* mkvmerge: MP4 reader: fixed a crash that could potentially happen while
  trying to identify HEVC/H.265 tracks.
* mkvmerge: MP4 reader: when reading HEVC/H.265 tracks without a frame offset
  table (`ctts` atom) present, mkvmerge did not parse the `hevcC` structure
  correctly in certain cases, causing no video frames to be output at all or
  the output not being playable. This fixes #2782, a bug introduced in v45.
* mkvmerge: MPLS handling/MPEG TS reader: timestamp restrictions as given in
  an MPLS file were only honored for the first play item, not for subsequent
  play items. For those play items the whole referenced file was always
  copied. Part of the fix of #2789.
* mkvmerge: MPLS handling/MPEG TS reader: under certain circumstances mkvmerge
  copied one frame too many before switching to the next play item. Part of
  the fix of #2789.
* mkvmerge: for audio-only files cues will only be created for I frames
  (important for e.g. TrueHD where decoding can only start on a sync
  frame). Fixes #2790.
* MKVToolNix GUI: fixed a crash that happened when closing the preferences
  after having closed at least one multiplexer tab. Fixes #2785.
* MKVToolNix GUI: macOS: changed the default of the "elide tab header labels"
  feature introduced in v45 from "no" to "yes" to mirror how versions before
  v45 behaved on macOS.


# Version 45.0.0 "Heaven in Pennies" 2020-04-04

## New features and enhancements

* mkvmerge: mkvmerge has never supported appending & splitting FLAC audio
  tracks. mkvmerge will now emit error messages when the user attempts either
  instead of continuing and creating invalid FLAC tracks.
* MKVToolNix GUI: added an option in the preferences to turn on eliding text
  on tab headers. If enabled, tab names will be shortened so that all tab
  headers fit into the window's width. Implements #2768.
* MKVToolNix GUI: added an option in the preferences to disable all tooltips.
* MKVToolNix GUI: Windows: debug output sent via Qt's to Windows' debugging
  facility will use a more verbose message format including the application
  name, making it easier to filter for in SysInternal's "Debug View" utility.
* MKVToolNix GUI: multiplexer: if the file identification fails due to a JSON
  parser error, the output generated by `mkvmerge` will be output via Qt's
  debugging facility (viewable with SysInternal's "Debug View" utility on
  Windows; on other systems it's output on `STDERR`) allowing insight into
  what's gone wrong.
* MKVToolNix GUI: multiplexer: if an error occurs during file identification,
  the name of the processed file will be mentioned in the error message.
* MKVToolNix GUI: multiplexer: if an error occurs during identification of
  multiple files, the GUI will ask the user whether to continue or abort the
  identification process. Implements #2778.
* MKVToolNix GUI: job queue: added an option in the preferences for removing
  completed jobs when exiting the program depending on their status.
  Implements #2769.

## Bug fixes

* mkvmerge: HEVC/H.265 packetizer: fixed changing the NALU size length, it was
  using the wrong offset into the `hevcC` structure.
* mkvmerge: MP4 reader: fixed calculating the duration of video tracks that
  only contain a single frame. Fixes #2747.
* mkvmerge: MP4 reader: if there's no frame offset table (`ctts` atom) present
  for HEVC/H.265 video tracks, mkvmerge will determine the timestamp order
  itself instead of relying on the timestamps in the MP4 being in the
  presentation order required by Matroska. Fixes #2777.
* mkvpropedit: Windows: mkvpropedit wasn't caching when reading the file to
  modify, slowing down operations such as adding track statistics tags
  considerably. Fixes #2761.
* MKVToolNix GUI: multiplexer: when using the title as part of the destination
  file name (both automatically as well as using the "copy title to
  destination file name" function) all characters that aren't valid in a file
  name are replaced by hyphens.
* MKVToolNix GUI: multiplexer: the "copy title to destination file name"
  function was broken when the "make file name unique" option in the
  preferences was disabled. In that case the file base name was removed
  regardless of what the title was set to at the time.
* MKVToolNix GUI: multiplexer: when using the "show command line" menu option
  on Windows the path to the `mkvmerge` executable was shown with forward
  slashes instead of backslashes. This is a purely cosmetic fix as Windows
  supports both forward and backward slashes.
* MKVToolNix GUI: multiplexer: when adding Blu-ray playlists the GUI used to
  only look for the English version of the disc library information (title &
  cover images). Now the GUI will present all disc library entries in the
  "select playlist to add" dialog & let the user chose which one to use (if
  any). Fixes #2765.
* MKVToolNix GUI: multiplexer, info tool: fixed the "warn before overwriting"
  check wrt. jobs creating the same file. Fixes #2758.


# Version 44.0.0 "Domino" 2020-03-08

## New features and enhancements

* MKVToolNix GUI: header editor: the attachments can now be reordered via drag
  & drop. Implements #2753.

## Bug fixes

* mkvmerge: Matroska reader: when encountering certain errors in the track
  headers such as the codec ID not being present mkvmerge will simply skip
  those tracks instead of exiting with an error. Fixes #2737.
* MKVToolNix GUI: multiplexer: the "ask before overwriting" functionality did
  not look for the correct file names when splitting was active. Fixes #2741.


# Version 43.0.0 "The Quartermaster" 2020-01-26

## New features and enhancements

* MKVToolNix GUI: using one of the command line options `--info`,
  `--edit-headers` or `--edit-chapters` will make the GUI select the
  corresponding tool on startup even if no further file name is
  given. Implements #2723.
* MKVToolNix GUI: multiplexer: added a setting in the preferences for changing
  the location of the MediaInfo executable for when the user accidentally
  selected the wrong one.

## Bug fixes

* mkvmerge: AVC/H.264 parser: the order of the NALUs before each key frame was
  sometimes wrong: mkvmerge wrote SPS & PPS after SEI NALUs. Now SPS & PPS
  NALUs are always written before the other NALUs. Patch by Torsten
  Hauska. Part of the implementation of #2709 and part of the fix of #2250.
* mkvmerge: AVC/H.264 parser: when additional SPS or PPS NALUs (with IDs that
  haven't been seen so far) are found mid-stream, mkvmerge will prepend all
  following key frames with all current valid SPS & PPS NALUs (just like when
  SPS & PPS NALUs are overwritten mid-stream). Part of the fix of #2250.
* mkvmerge: MPEG TS reader: fixed detection of MPEG-1/2 video tracks
  consisting of very few frames. Fixes #2732.
* mkvmerge: Ogg Opus reader: fixed the handling of Ogg Opus streams that
  contain a just one Ogg page (`mkvmerge` aborted with an exception). Fixes
  #2722.
* MKVToolNix GUI: multiplexer: dragging & dropping XML files with chapters or
  tags to the GUI's window was broken in v42. Instead of adding the file names
  to the appropriate input boxes the GUI was running mkvmerge for file
  identification purposes which then failed. Fixes #2718.


# Version 42.0.0 "Overtime" 2020-01-02

## New features and enhancements

* mkvmerge: added an option for creating byte-identical files:
  `--deterministic <seed>`. Part of the implementation of #2698.
* mkvmerge: Matroska reader: mkvmerge will remove the `icpf` atom headers if
  they're present in frames read from Matroska files. Implements #2692.
* mkvmerge: MP4 reader: ALAC tracks: the number of channels, sampling
  frequency and bit depth are now taken from the bitstream in order to fix
  bogus values on the container level. Implements #2714.
* mkvpropedit: when changing track UIDs the referring elements in existing
  chapters & tags will be updated automatically, too. Part of the
  implementation of #2700.
* mkvinfo: when the option `-p`/`--hex-positions` is used, element positions
  will be output regardless of the verbosity level. Part of the implementation
  of #2713.
* mkvinfo: added the option `-P`/`--positions` for showing the position of
  each element in decimal regardless of the verbosity level used. Part of the
  implementation of #2713.
* mkvinfo: added the option `-o`/`--continue` for continuing processing when
  the first cluster is encountered regardless of the verbosity level
  used. Part of the implementation of #2713.
* mkvinfo: added the option `-a`/`--all` for outputting all sub-elements (even
  cues & seek head entries) and not stopping at the first cluster regardless
  of the verbosity level used. Part of the implementation of #2713.
* MKVToolNix GUI: multiplexer: added an option in the preferences for
  disabling adding cover images from Blu-ray discs. Implements #2693.
* MKVToolNix GUI: multiplexer: added mkvmerge's new `--deterministic` option
  in the "additional command-line options" dialog. Part of the implementation
  of #2698.
* MKVToolNix GUI: header editor:: when changing track UIDs the referring
  elements in existing chapters & tags will be updated automatically,
  too. Part of the implementation of #2700.

## Bug fixes

* mkvmerge: HEVC ES parser: fixed a bug in the slice parser calculating the
  size of a field which in turn could have led to the slice's type being read
  wrong. Patch by Torsten Hauska. Fixes #2710.
* mkvmerge: Matroska reader: fixed a segmentation fault when trying to read a
  file that uses header removal compression but no removed bytes are present
  in the track headers. Fixes #2687.
* mkvmerge: MPEG elementary stream parser: fixed an invalid memory access and
  use of uninitialized memory that could happen under certain
  circumstances. Fixes #2690.
* mkvmerge: RealMedia reader: fixed a division by zero when all audio
  timestamps were zero. Fixes #2689.
* mkvmerge: RealMedia reader: fixed an invalid memory access in the video
  frame assembly code triggered by invalid data in the file. Fixes #2691.

## Build system changes

* `std::optional` (C++17 feature) is now used instead of `boost::optional`.
* `std::regex` is now used instead of `boost::regex`.

## Other changes

* New man page translations into French, Italian, Russian and Chinese
  Traditional have been added.


# Version 41.0.0 "Smarra" 2019-12-06

## New features and enhancements

* mkvmerge: Matroska reader: Vorbis tracks: stream comments (aka Vorbis
  comments) will be converted to Matroska attachments (for cover arts) and
  Matroska track tags (for other comments). Additionally the stream comments
  will be removed from Vorbis headers.
* mkvmerge: MP4 reader: added support for reading Opus audio from MP4
  files. Part of the implementation of #2673.
* mkvmerge: MP4 reader: added support for reading VP9 video from MP4
  files. Part of the implementation of #2673.
* mkvmerge: Ogg reader: Vorbis, Opus & VP8 streams: stream comments (aka
  Vorbis comments) will be converted to Matroska attachments (for cover arts)
  and Matroska track tags (for other comments). Additionally the stream
  comments will be removed from Vorbis headers.
* mkvmerge: WAV reader: added support for reading RF64 files.
* MKVToolNix GUI: multiplexer: the list of predefined track names is now split
  up into three lists, one for each track type (audio, video &
  subtitles). Part of the implementation of #2654.
* MKVToolNix GUI: multiplexer: when trying to add thumbnails for a Blu-ray the
  GUI will determine the thumbnail's pixel size from the thumbnail files if
  the XML file doesn't contain that information. This works for JPEG and PNG
  files. Implements #2674.
* MKVToolNix GUI: general: line edits & combo boxes will now have a "clear
  text" button appear whenever they're not empty. Part of the implementation
  of #2654.
* MKVToolNix GUI: update check: the dialog showing the latest news & version
  information states explicitly where the links take the user (the MKVToolNix
  `NEWS.md` file and YouTube respectively).

## Bug fixes

* mkvmerge: Matroska reader: mkvmerge did not copy the codec's private data
  when reading WavPack from Matroska files. Fixes #2685.
* mkvmerge: MPLS handling: re-added caching when using MPLS playlists as input
  files. Fixes #2666.
* mkvmerge: MPEG TS reader: when reading an MPLS playlist, the calculation of
  the minimum timestamp to use for shifting all output timestamps to zero was
  wrong. It was wrongfully considering timestamps from packets it would not
  copy due to the MPLS's timestamp restrictions. This could lead to the first
  timestamps in the output file being quite large, e.g. more than a couple of
  minutes, causing sync problems when multiplexing together with other
  files. Fixes #2670.
* MKVToolNix GUI: multiplexer: the automatic switch between aspect ratio &
  display width/height wasn't reflected in the configuration generated for
  `mkvmerge`. The user had to change between the two settings manually. Fixes
  #2660.
* MKVToolNix GUI: multiplexer: the progress dialog shown when scanning a
  Blu-ray wasn't closed properly in certain situations. Fixes #2678.
* MKVToolNix GUI: general: the configured font was not applied to a lot of
  controls (e.g. the file & track lists or the menu entries) on application
  startup. Instead the user had to open & close the preferences in order for
  the font to be applied to all controls. Fixes #2671.


# Version 40.0.0 "Old Town Road + Pony" 2019-11-09

## New features and enhancements

* mkvmerge: MP4 reader: added support for BMP covert art images.
* MKVToolNix GUI: multiplexer: added an option to disable deriving the
  destination file name from the file title. Implements #2648.
* MKVToolNix GUI: multiplexer: the content of the "stereoscopy" combo box has
  been simplified making the box's minimum width much smaller, allowing the
  user to resize the GUI's whole window to a much smaller width.
* MKVToolNix GUI: multiplexer: whenever the user changes the "aspect ratio" or
  "display dimensions" controls, the corresponding radio button will be
  activated automatically. Implements #2651.
* MKVToolNix GUI: Windows: added a setting in the preferences to disable the
  GUI's dark color mode even if Windows's app color mode is set to
  dark. Implements #2646.
* MKVToolNix GUI: Windows: replaced the dark mode introduced in v39 with
  another dark mode that's less wasteful with space between widgets.

## Bug fixes

* mkvmerge: MP4 reader: mkvmerge was reading eight bytes too many for cover
  art images. This could cause file identification to fail when the cover art
  was located at the end of the MP4 file. Even if it succeeded, this meant too
  much data present in the attachment. Fixes #2650.
* mkvmerge: MP4 reader: covert art images with unknown image types will be
  skipped instead of treated as JPEG images.

## Build system changes

* Qt 5.9.0 or newer is now required for building MKVToolNix GUI.


# Version 39.0.0 "In The Waiting Line" 2019-11-04

## New features and enhancements

* mkvmerge: Blu-ray: when reading an MPLS playlist mkvmerge will look up and
  use chapter names from the Blu-ray's "track/chapter names" meta data if it
  exists. Part of the implementation of 2486.
* mkvmerge: MP4 reader: if present, cover art images (the
  `udta.meta.list.covr` atom) will be converted into attachments.
* MKVToolNix GUI: multiplexer: when adding a playlist from a Blu-ray disc, the
  disc library meta data will be parsed, and the biggest thumbnail, if
  present, will be added as a new attachment with name `cover.jpg` (extension
  depends on thumbnail's extension). Implements #2644.
* MKVToolNix GUI: multiplexer: when adding a playlist from a Blu-ray disc, the
  title from the disc library meta data will be set as the new file title if
  the disc library meta data contains one & no title has been set yet.
* MKVToolNix GUI: multiplexer: the automatically generated destination file
  name will now be based on the file title if one is set at that point. This
  works in conjunction with the title being said from the Blu-ray disc library
  meta data.
* MKVToolNix GUI: chapter editor: when reading chapters from an MPLS playlist
  the GUI will look up and use chapter names from the Blu-ray's "track/chapter
  names" meta data if it exists. Part of the implementation of 2486.
* MKVToolNix GUI: Windows: added a dark mode that's enabled when Windows 10's
  dark mode is turned on.
* translations: added a Bulgarian translation of the programs & the man pages
  by Симеон Цветков (see `AUTHORS`).

## Bug fixes

* mkvmerge: attachments without a file name won't be ignored anymore. Part of
  the fix of #2642.
* MKVToolNix GUI: header editor: attachments with an empty name element will
  be shown as `<unnamed>` as originally intended. Part of the fix of #2642.
* Linux AppImage: the AppImage will no longer change directories before
  running the desired executable allow the use of relative file names. Fixes
  #2632.

## Build system changes

* MKVToolNix now requires a C++ compiler that supports the following features
  of the C++17 standard: "`[[maybe_unused]]` attribute", "nested namespace
  definition", "structured bindings". For the GNU Compiler Collection (gcc)
  this means v7 or newer; for clang it means v4 or newer.
* Boost 1.60.0 or newer is now required.


# Version 38.0.0 "The Silent Type" 2019-10-06

## New features and enhancements

* mkvextract: chapters, tags & cue sheets will now be written to standard
  output if no file name is given, same as if `-` is given as the file name.
* MKVToolNix GUI: job queue: added a new setting in the preferences' "job
  queue & job status" section that, when enabled, will cause the GUI to remove
  all output files created by jobs that are either aborted by the user or that
  end in an error. Implements #2614.

## Bug fixes

* all programs: macOS: fixed file access if the file name (including all path
  components) contains any Unicode character where NFC (Normalization Form
  Canonical Composed) and NFD (Normalization Form Canonical Decomposed)
  differ, e.g. German Umlauts. Fixes #2620.
* mkvmerge: when splitting by chapters the user can now split by chapters
  coming from one of the appended files, too. Fixes #2625.
* mkvmerge: AAC reader: fixed reading codec parameters (channels, sample rate)
  if a file starts with garbage that includes valid-but-bogus AAC
  headers. Fixes #2622.
* MKVToolNix GUI: Hebrew was added to the list of often-used languages so that
  it can be selected by default again. Fixes #2610.
* MKVToolNix GUI: when updating the GUI's settings from v37.0.0 or older, the
  GUI checks if the list of often-used languages equals the built-in list from
  v36.0.0. If it does, it will be updated to the built-in list changed in
  v37.0.0. Fixes #2611.

## Build system changes

* Boost's Operators header library is now required.


# Version 37.0.0 "Leave It" 2019-08-24

## New features and enhancements

* MKVToolNix GUI: the list of often used languages now contains those from
  Wikipedia's "List of languages by native speakers" by default. Also by
  default only those languages will be shown in the language drop-down boxes.

## Bug fixes

* MKVToolNix GUI: multiplexer: fixed a bug in the "make destination file names
  unique" logic that caused an existing number-in-parenthesis at the end of
  the file base name to be removed in certain situations (e.g. when the first
  added file was named `m (3).mkv` and both `m (3) (1).mkv` and `m (3)
  (2).mkv` existed already, the GUI was suddenly use `m.mkv` instead of `m (3)
  (3).mkv`).
* MKVToolNix GUI: on Windows the GUI is built with a slightly older version of
  the Qt library again (5.12.4). The Qt version used in release v36.0.0,
  v5.13.0, lead to crashes when doing certain things such as selecting
  multiple tracks in the multiplexer. Fixes #2605 and #26008.


# Version 36.0.0 "Is That Jazz?" 2019-08-10

## New features and enhancements

* mkvmerge: mkvmerge now allows appending AV1, VP8, VP9, AVC/H.264 and
  HEVC/H.265 tracks whose pixel dimensions differ. Implements #2582.

## Bug fixes

* source code: fixed building with Boost 1.71.0. Fixes #2599.
* all: fixed the spelling of the H.264 & H.265 codec names.
* mkvmerge: Blu-ray MPLS handling: mkvmerge will now find corresponding M2TS
  files even if the `clip_codec_identifier` playlist item field is not set to
  `M2TS` in the MPLS file. Fixes #2601.
* mkvmerge: fixed handling of text files that use both DOS-style and
  Unix-style line endings resulting in problems such as text subtitle files
  not being parsed correctly. Fixes #2594.


# Version 35.0.0 "All The Love In The World" 2019-06-22

## New features and enhancements

* mkvmerge: JSON identification: the "codec name" track property will be
  output as `codec_name`. The JSON schema has been bumped to v12 for this
  change.
* MKVToolNix GUI: job queue: added a new type of action to execute after job
  completion: deleting source files for of multiplexer jobs. As this is a
  destructive operation, the action is disabled by default. Implements #869
  and #2570.

## Bug fixes

* mkvmerge: the "codec name" track property wasn't copied from Matroska
  files. Fixes #2566.
* MKVToolNix GUI: multiplexer: Windows: clearing the destination file name
  will reset the tab name to "\<No destination file\>" again. Fixes #2571.
* MKVToolNix GUI: multiplexer: the file types were not re-translated if the UI
  language was changed. Fixes #2572.


# Version 34.0.0 "Sight and Seen" 2019-05-18

## Bug fixes

* mkvmerge: all subtitle frames are now treated as key frames in order to fix
  wrong data in source files. Fixes #2541.
* mkvmerge: AV1: fixed frame timestamp calculation when reading bitstreams
  that lack timing information from IVF files. Fixes #2553.
* mkvmerge: Matroska reader: fixed an infinite loop that could happen with
  large video frames and applied timestamp files due to too much data being
  buffered at the wrong time. Fixes #2550.


# Version 33.1.0 "Primrose" 2019-04-15

## Bug fixes

* MKVToolNix GUI: multiplexer: Windows: using UNC paths
  (e.g. `\\server\Videos`) when the option "automatically set the destination
  file name" was set in the preferences, the GUI would create a destination
  file name with forward slashes (e.g. `//server/Videos/outputfile.mkv`), a
  syntax not supported by `mkvmerge`. Fixes #2533 & #2534.
* build system: the programs were accidentally built without stack protection
  (`-fstack-protector-strong`) on recent versions of gcc and clang.


# Version 33.0.0 "A Little Bit of Madness" 2019-04-12

## Bug fixes

* mkvinfo: when using the `--size` option, mkvinfo will now report the
  correctly if an element has an unknown size. Part of the fix of #2530.
* MKVToolNix GUI: info tool: clusters with an unknown size will now be read
  and displayed correctly. Part of the fix of #2530.
* MKVToolNix GUI: multiplexer: Windows: trying to open Blu-ray index or
  playlist files failed when the path to the files contained symbolic links
  (e.g. when mounting a drive in a sub-folder via Windows' disk management
  utility). Fixes #2522.
* MKVToolNix GUI: multiplexer: if a destination file names ends with a number
  in parenthesis (e.g. a year such as "(2017)"), that number will not be
  stripped anymore during the process of ensuring the destination file name is
  unique. Only those suffixes added automatically in prior attempts to make
  the file name unique will be removed. Fixes #2521.
* MKVToolNix GUI: multiplexer: Windows: the GUI will let the user change the
  drive letter part of the destination file name freely again and only verify
  its validity right before starting to mux/adding to the job queue. Before it
  tried to force that into something valid, often resulting in unintentional
  paths (such as "C:\users\…\DC\files\…"). Fixes #2527.


# Version 32.0.0 "Astral Progressions" 2019-03-12

## New features and enhancements

* mkvinfo: when sizes are output the size of the element's data portion is
  output in addition to the element's total size.
* MKVToolNix GUI: info tool: the element's data portion is
  shown as an extra column.
* MKVToolNix GUI: multiplexer: added column "Delay" to the track list
  containing the additional delay to apply during multiplexing. Implements
  #2506.

## Bug fixes

* all: fixed handling of Unicode code points \> U+FFFF. Fixes #2516.
* mkvmerge: Windows: mkvmerge was crashing with an exception when trying to
  identify certain files that can be used on Blu-rays (such as MPEG transport
  streams of MPLS play list files) and when the file name was given as a UNC
  path (e.g. `\\servername\sharename\path\to\file.m2ts`). The GUI emitted
  errors such as "the JSON output could not be parsed" in that case. Fixes
  #2507.
* MKVToolNix GUI: the portable mode wasn't detected correctly when the current
  working directory the GUI was started from wasn't the directory the GUI's
  executable file was located it. Examples for when this is the case are
  Windows' "send to" or "open with" functions. Fixes #2501.
* MKVToolNix GUI: multiplexer: using button to change the current destination
  directory to one of the recently used ones did not update the file name
  according to the "make file name unique" setting. Part of the fix of #2519.
* MKVToolNix GUI: multiplexer: the function "set destination file name from
  selected file's name" will now only change the destination file's name but
  not its path. Part of the fix of #2519.

## Build system changes

* libEBML v1.3.7 and libMatroska 1.5.0 are now required as they fix their
  handling of Unicode code points \> U+FFFF (see #2516).


# Version 31.0.0 "Dolores In A Shoestand" 2019-02-09

## New features and enhancements

* all programs: added a new option `--abort-on-warnings` that will cause the
  program to abort after it has emitted the first warning, similar to how it
  aborts after the first error. Implements #2493.
* mkvmerge, mkvextract: when closing files that were opened for writing,
  cached data will not be flushed to storage automatically anymore. This
  reverts the workaround implemented for #2469. A new option was added to both
  programs (`--flush-on-close`) that re-enables flushing for people who are
  affected by data loss such as described in #2469.

  The reason is that automatic flushing causes long delays in processing
  queues when the output by mkvmerge/mkvextract isn't the final product but
  just an intermediate result to be processed further.

  Implements #2480.
* MKVToolNix GUI: multiplexer: the dialog previewing different character sets
  for text subtitles will now keep the position of the displayed text when
  switching between character sets. Implements #2489.

## Bug fixes

* mkvmerge: AVI reader: using DV type 1 AVIs will now result in an unsupported
  file type being reported (as the underlying AVI library doesn't support
  them) instead of crashing mkvmerge. Fixes #2491.
* mkvmerge: HEVC: the height of interlaced streams will now be set correctly
  to the height of the full frame instead of the height of a single interlaced
  field. Fixes #2446.
* mkvmerge: MP4 reader: edit lists consisting solely of elements that mkvmerge
  doesn't support (such as dwells) are simply ignored. Before no data was read
  for such tracks at all. Fixes #2487.
* mkvmerge: text subtitles: entries with an explicit duration of 0ms will now
  be handled correctly: the 0ms duration will be stored in Matroska instead of
  the difference between the current and the following entry. Fixes #2490.
* MKVToolNix GUI: multiplexer, chapter editor: fixed drag & drop handling with
  Qt 5.12.0 and newer. Fixes #2472.
* MKVToolNix GUI: multiplexer: the GUI did not clean up temporary files
  created when running `mkvmerge`. Fixes #2499.

## Build system changes

* Qt 5.4.0 or newer has required (up from 5.3.0) since version 30.0.0; I just
  forgot to include this entry.


# Version 30.1.0 "Forever And More" 2019-01-05

## Bug fixes

* build system: fixed building on non-UTF-8 locales. Fixes #2474.
* MKVToolNix GUI: multiplexer: implemented a workaround for drag & drop not
  working on macOS with Qt 5.12 due to a bug in Qt 5.12. Fixes #2472.
* MKVToolNix GUI: chapter editor: when opening a Matroska/WebM file that
  doesn't contain chapters and later saving chapters back to them, the editor
  was truncating the file down to a couple of KB in size. This was a
  regression introduced with the implementation of #2439 in v30.0.0 Fixes
  #2476.


# Version 30.0.0 "Interstellar" 2019-01-04

## New features and enhancements

* mkvextract: WAV extractor: mkvextract will now write W64 files instead of
  WAV files if the file name extension is `.w64` or if the final file size is
  bigger than 4 GB, the file size limit for WAV files. Implements #2458.
* MKVToolNix GUI: multiplexer: a new button was added next to the "destination
  file" controls. Clicking it shows a menu with the ten most recently used
  output directories. Selecting one of them will change the destination file
  to the selected directory keeping the file name. Implements #2468.
* MKVToolNix GUI: multiplexer (preferences): the ten most recently used values
  for the "relative output directory" and "fixed output directory" settings
  are now saved. The corresponding settings have been changed into combo boxes
  allowing quick access to those recent values.
* MKVToolNix GUI: multiplexer (preferences): the predefined split sizes and
  durations can now be customized in the preferences.
* MKVToolNix GUI: chapter editor: added an option in the "Chapter editor" menu
  for appending chapters from an existing file to the currently open editor
  tab. Part of the implementation of #2439.
* MKVToolNix GUI: chapter editor: added an action in the context menu for
  copying the selected entry and all of its children to another open editor
  tab. Part of the implementation of #2439.

## Bug fixes

* mkvmerge: all files opened for writing will now be flushed once before
  they're closed. This ensures the operating system actually writes all cached
  data to disk preventing data loss in certain situations such as power
  outages or buggy drivers in combination with suspending the computer. Fixes
  #2469.
* mkvmerge: AAC: under certain conditions 8 channel audio files were taken for
  7 channel ones.
* MKVToolNix GUI: multiplexer: removing a file added as an "additional part"
  will no longer cause a crash. Fixes #2461.
* source code: fixed compilation with Boost 1.69.0 after API-breaking change
  to the `boost::tribool` class. Fixes #2460.


# Version 29.0.0 "Like It Or Not" 2018-12-01

## Important notes

* The string formatting library used was switched from `boost::format` to
  [`fmt`](http://fmtlib.net/). See the section "Build system changes" for
  details.

## New features and enhancements

* MKVToolNix GUI: added an option in the preferences for disabling automatic
  scaling for high DPI displays. Implements #2415.
* MKVToolNix GUI: the GUI will now prevent the system from going to sleep
  while the job queue is running. This feature is implemented for macOS,
  Windows and Linux/Unix systems where the `org.freedesktop.login1.Manager`
  D-Bus interface is available. Implements #2411.

## Bug fixes

* mkvmerge: chapter generation: the start timestamps of chapters generated in
  intervals was wrong for files whose smallest video timestamp was bigger than
  0. Fixes #2432.
* mkvmerge: MP4 reader: fixed handling of atoms whose size exceeds the parent
  atom's size. Fixes #2431.
* mkvmerge, MKVToolNix GUI's chapter editor: the chapter name template will
  now also be used when reading Ogg-style chapter files with empty chapter
  names. Fixes #2441.
* mkvextract: AAC: mkvextract will now write the program config element (PCE)
  before the first AAC raw data packet if the PCE is present in the
  `AudioSpecificConfig` structure in the `Codec Private` Matroska element. The
  PCE carries vital information about the number of channels and is required
  in certain cases. Fixes #2205 and #2433.
* mkvpropedit, MKVToolNix GUI's header editor: in situations when a one-byte
  space must be covered by a new EBML void element the following element must
  be moved up instead. If that moved element is a cluster, the corresponding
  cue entries will now be updated to reflect the cluster's new position. Fixes
  #2408.
* MKVToolNix GUI: Windows: the application manifest is now included properly
  so that Windows actually recognizes it. See #2415.

## Build system changes

* Qt's D-Bus implementation is now required for building on systems other than
  macOS and Windows,
* The `boost::format` library is not used anymore.
* The [`fmt` library](http://fmtlib.net/) is now required. Versions 3 and
  newer are supported. As not all Linux distributions include packages for the
  library, its release 5.2.1 comes bundled with MKVToolNix. The `configure`
  script will check for a system version of the library and use it if present
  and recent enough. Otherwise it will fall back to the bundled version and
  link that statically.


# Version 28.2.0 "The Awakening" 2018-10-25

## Bug fixes

* mkvmerge, mkvinfo, mkvextract, mkvpropedit, MKVToolNix GUI's info tool &
  chapter editor: fixed a case of memory being accessed after it had been
  freed earlier. This can be triggered by specially crafted Matroska files and
  lead to arbitrary code execution. The vulnerability was reported as Cisco
  TALOS 2018-0694 on 2018-10-25.


# Version 28.1.0 "Morning Child" 2018-10-23

## Bug fixes

* mkvmerge: AV1 parser: fixed an error in the sequence header parser if
  neither the `reduced_still_picture_header` nor the
  `frame_id_numbers_present_flag` is set. Part of the fix for #2410.
* mkvmerge: AV1 parser: when creating the `av1C` structure for the Codec
  Private element the sequence header OBU wasn't copied completely: its common
  data (type field & OBU size among others) was missing. Part of the fix for
  #2410.
* mkvmerge: Matroska reader, AV1: mkvmerge will try to re-create the `av1C`
  data stored in Codec Private when reading AV1 from Matroska or WebM files
  created by mkvmerge v28.0.0. Part of the fix for #2410.
* MKVToolNix GUI: info tool: the tool will no longer stop scanning elements
  when an EBML Void element is found after the first Cluster element. Fixes
  #2413.


# Version 28.0.0 "Voice In My Head" 2018-10-20

## New features and enhancements

* mkvmerge: AV1 parser: updated the code for the finalized AV1 bitstream
  specification. Part of the implementation of #2261.
* mkvmerge: AV1 packetizer: updated the code for the finalized AV1-in-Matroska
  & WebM mapping specification. Part of the implementation of #2261.
* mkvmerge: AV1 support: the `--engage enable_av1` option has been removed
  again. Part of the implementation of #2261.
* mkvmerge: MP4 reader: added support for AV1. Part of the implementation of
  #2261.
* mkvmerge: DTS: implemented dialog normalization gain removal for extension
  substreams. Implements #2377.
* mkvmerge, mkvextract: simple text subtitles: added a workaround for simple
  text subtitle tracks that don't contain a duration. Implements #2397.
* mkvextract: added support for extracting AV1 to IVF. Part of the
  implementation of #2261.
* mkvextract: IVF extractor (AV1, VP8, VP9): precise values will be used for
  the frame rate numerator & denominator header fields for certain well-known
  values of the track's default duration.
* mkvmerge: VP9: mkvmerge will now create codec private data according to the
  VP9 codec mapping described in the WebM specifications. Implements #2379.
* MKVToolNix GUI: automatic scaling for high DPI displays is activated if the
  GUI is compiled with Qt ≥ 5.6.0. Fixes #1996 and #2383.
* MKVToolNix GUI: added a menu item ("Help" → "System information") for
  displaying information about the system MKVToolNix is running on in order to
  make debugging easier.
* MKVToolNix GUI: multiplexer, header editor: the user can enter a list of
  predefined track names in the preferences. She can later select from them in
  "track name" combo box. Implements #2230.


## Bug fixes

* mkvmerge: JSON identification: fixed a bug when removing invalid UTF-8 data
  from strings before they're output as JSON. Fixes #2398.
* mkvmerge: MP4/QuickTime reader: fixed handling of PCM audio with FourCC
  `in24`. Fixes #2391.
* mkvmerge: MPEG transport stream reader, teletext subtitles: the decision
  whether or not to keep frames around in order to potentially merge them with
  the following frame is made sooner. That avoids problems if there are large
  gaps between teletext subtitle frames which could lead to frames being
  interleaved too late. Fixes #2393.
* mkvextract: IVF extractor (AV1, VP8, VP8): the frame rate header fields
  weren't clamped to 16 bits properly causing wrong frame rates to be written
  in certain situations.
* mkvpropedit, MKVToolNix GUI's header editor: fixed file corruption when a
  one-byte space must be covered with a new EBML void element but all
  surrounding elements have a "size length" field that's eight bytes long
  already. Fixes #2406.


# Version 27.0.0 "Metropolis" 2018-09-26

## New features and enhancements

* mkvmerge: chapters: the timestamps of chapters read from containers or from
  chapter files can be adjusted (multiplication and addition) with the new
  `--chapter-sync` option or using the special track ID `-2` for the existing
  `--sync` option. Part of the implementation of #2358.
* MKVToolNix GUI: multiplexer: adjusted & added controls for mkvmerge's new
  feature of being able to adjust chapter timestamps. Part of the
  implementation of #2358.
* MKVToolNix GUI: multiplexer: the GUI can now ask for confirmation when the
  user is about to create a file that won't contain audio tracks. It does this
  by default if at least one source file contains an audio track. Implements
  #2380.

## Bug fixes

* mkvmerge: AC-3: dialog normalization gain removal was corrupting E-AC-3
  frames irreversibly by writing checksums in places where they didn't
  belong. Additionally only the first E-AC-3 frame in a Matroska was processed
  but not additional dependent frames in the same block. Fixes #2386.
* MKVToolNix GUI: fixed a leak of Windows font resources leading to a general
  slowdown and subsequent crash. Fixes #2372.


# Version 26.0.0 "In The Game" 2018-08-26

## New features and enhancements

* mkvmerge: chapter generation: if the name template given by
  `--generate-chapters-name-template` is empty, no names (`ChapterDisplay`
  master elements with `ChapterString`/`ChapterLanguage` children) will be
  generated for the chapter atoms. Part of the implementation of #2275.
* mkvmerge: chapters: chapter names generated from MPLS files will now use the
  name template if one is set via `--generate-chapters-name-template`. Part of
  the implementation of #2275.
* mkvmerge: mkvmerge will no longer abort with an error message if no audio,
  video and subtitle tracks should be multiplexed. This allows copying of
  chapters from non-chapter source files (e.g. Matroska or MP4 files).
* MKVToolNix GUI: the font size in the tool selector on the left will scale
  with the font size the user selects in the preferences.
* MKVToolNix GUI: the GUI will no longer automatically resize the columns in
  tree and list views to match the content size. Instead it remembers and
  restores the widths set by the user. Implements #2353.
* MKVToolNix GUI: multiplexer: the chapter name template will now be set
  automatically to the name template in the preferences' "chapter editor"
  section. Additionally the option `--generate-chapters-name-template …` will
  be passed to mkvmerge in situations when mkvmerge will generate chapters
  (either because automatic generation is enabled or if chapters are generated
  for MPLS playlists). Part of the implementation of #2275.
* MKVToolNix GUI: chapter editor: if the chapter name template is empty,
  chapters will be generated without names. Part of the implementation of
  #2275.
* MKVToolNix GUI: chapter editor: added an option to remove all chapter names
  to the "additional modifications" dialog. Part of the implementation of
  #2275.

## Bug fixes

* mkvmerge: Matroska reader: fixed wrong timestamps when appending Matroska
  files where the second Matroska file's first timestamp is bigger
  than 0. Fixes #2345.
* mkvmerge: MP4 reader: fixed division by zero errors during file
  identification if the timescale is 0 in the `MVHD` atom.
* mkvmerge: Windows Television DVR files are now recognized as an unsupported
  file type. This prevents mis-detection as MPEG-2 with an accompanying flood
  of error messages. Fixes #2347.
* MKVToolNix GUI: info tool: under certain circumstances "cues" were shown at
  the wrong level (inside the previous master element instead of on level
  1). Fixes #2361.
* MKVToolNix GUI: job queue: fixed invalid memory handling and consequent
  crashes when using the "edit in corresponding tool & remove from job queue"
  option if one of the files in that job contained attached files. Fixes
  #2368.

## Build system changes

* An AppStream metadata file will be installed in `$prefix/share/metainfo`.


# Version 25.0.0 "Prog Noir" 2018-07-12

## New features and enhancements

* mkvmerge: SRT/ASS/SSA text subtitles: for files for which no encoding has
  been specified, mkvmerge will try UTF-8 first before falling back to the
  system's default encoding. Part of the implementation of #2246.
* mkvmerge: SRT/ASS/SSA/WebVTT text subtitles: a warning is now emitted if
  invalid 8-bit characters are encountered outside valid multi-byte UTF-8
  sequences. Part of the implementation of #2246.
* mkvmerge: Matroska & MPEG transport stream readers: the encoding of text
  subtitles read from Matroska files can now be changed with the
  `--sub-charset` parameter.
* Linux: starting with release 25 an AppImage will be provided which should
  run on any Linux distribution released around the time of CentOS 7/Ubuntu
  14.04 or later.
* macOS: translations: updated the `build.sh` script to build `libiconv` and a
  complete `gettext`. Together with an additional fix to how translation files
  are located, MKVToolNix can now use all interface languages on macOS,
  too. Fixes #2110, #2307, #2323.

## Bug fixes

* mkvmerge: AVC/H.264: fixed file identification failing for certain
  elementary streams due to internal buffers not being cleared properly. Fixes
  #2325.
* mkvmerge: HEVC/H.265: fixed file identification failing for certain
  elementary streams due to internal buffers not being cleared properly. This
  is the HEVC analog to what was fixed for AVC in #2325.
* mkvmerge: MLP code: fixed various issues preventing MLP from being parsed
  correctly. Fixes #2326.
* mkvmerge: TrueHD/MLP packetizer; dialog volume normalization removal isn't
  attempted if the track is an MLP track as the operation is only supported
  for TrueHD, not MLP.
* mkvmerge: MPEG TS reader: when reading MPLS mkvmerge will now compare the
  MPLS's start and end timestamps against the transport stream's PTS instead
  of its DTS. Otherwise the first key frame of a video track might be dropped
  if it isn't the first in presentation order. Fixes #2321.
* mkvmerge: JSON identification: mkvmerge will ensure that all strings passed
  to the JSON output modules are valid UTF-8 encoded strings by replacing
  invalid bytes with placeholder characters. This avoids the JSON library
  throwing an exception and mkvmerge aborting on such data. Fixes #2327.
* mkvmerge: audio packetizers: mkvmerge will now keep discard padding values
  if they're present for packets read from Matroska files. Fixes #2296.
* mkvmerge: Ogg Opus reader: packet timestamps aren't calculated by summing up
  the duration of all packets starting with timestamp 0 anymore. Instead the
  algorithm is based on the Ogg page's granule position and which packet
  number is currently timestamped (special handling for the first and last
  packets in the stream).

  * This fixes the first timestamp if the first Ogg packet's granule position
    is larger than the number of samples in the first packet (= if the first
    sample's timestamp is bigger than 0). mkvmerge will keep those offsets now
    and inserts "discard padding" only where it's actually needed.
  * It also improves handling of invalid files where the first Ogg packet's
    granule position is smaller than the number of samples in the first packet
    (= the first sample's timestamp is smaller than 0). mkvmerge will now
    shift all timestamps up to 0 in such a case instead of inserting "discard
    padding" elements all over the place.
  * mkvmerge will no longer insert "discard padding" elements if the
    difference between a) the calculated number of samples in the packet
    according to the granule position and b) the actual number of samples as
    calculated from the bitstream is one sample or less and if the packet
    isn't the last one in the stream. This circumvents certain rounding
    errors.
  * The timestamp of the first packet after a gap in the middle of the stream
    is now calculated based on the Ogg page the packet belongs to, and not
    based on the timestamps before the gap.

  Fixes #2280.
* mkvmerge: complete rewrite of the progress handling. It's now based upon the
  total size of all source files and the current position within them instead
  of the number of frames/blocks to be processed. This simplifies calculation
  when appending files and fixes rare cases of when progress report was
  obvious wrong (e.g. stuck at 0% right until the end). Fixes #2150 and #2330.
* MKVToolNix GUI: header editor: non-mandatory elements couldn't be removed
  anymore due to a regression while fixing #2320. They can now be removed
  again. Fixes #2322.


# Version 24.0.0 "Beyond The Pale" 2018-06-10

## New features and enhancements

* mkvmerge: MP4 reader: improved the detection of edit lists consisting of two
  identical entries, each spanning the file's duration as given in the movie
  header atom. The second entry is ignored in such cases. See #2306.
* mkvmerge: JSON identification: the "display unit" video track property is
  now reported as `display_unit`. The JSON schema has been bumped to v11 for
  this change.
* mkvmerge, mkvextract: AVC/H.264: empty NALUs will now be removed.
* mkvextract: VobSub extraction: empty SPU packets will now be dropped during
  extraction as other tools such as MP4Box cannot handle them
  correctly. Implements #2293.

## Bug fixes

* mkvmerge: E-AC-3 parser: fixed determining the number of channels for
  streams that contain an AC-3 core with dependent E-AC-3 frames. Fixes #2283.
* mkvmerge: Matroska reader: fixed mkvmerge buffering the whole file if a
  video track is multiplexed that consists of only one or a few frames. Fixes
  #2304.
* mkvmerge: the "display unit" video track property will now be kept if it is
  set in the source file. Fixes #2317.
* MKVToolNix GUI: multiplexer: when scanning playlists, all playlists were
  offered for selection regardless of the value of the "minimum playlist
  duration" setting. Fixes #2299.
* MKVToolNix GUI: multiplexer: deriving track languages from file names: the
  regular sub-expressions for ISO 639-1 codes could match on empty strings,
  too, causing matches in wrong places and hence no language being recognized
  in certain situations. Fixes #2298.
* MKVToolNix GUI: header editor: fixed a crash when saving the file fails
  (e.g. because it isn't writable). Fixes #2319.
* MKVToolNix GUI: header editor: the editor was wrongfully claiming that
  mandatory elements with default values cannot be removed in the "status"
  text. Fixes #2320.
* MKVToolNix GUI: preferences: on macOS & Linux the setting "enable copying
  tracks by their type" wasn't restored on program start. Fixes #2297.

## Other changes

* Niels Lohmann's JSON library: the bundled version has been updated from
  v1.1.0 (git revision 54d3cab) to v3.1.1 (git revision g183390c1).
* pugixml library: the bundled version has been updated from v1.8 to v1.9 (git
  revision e584ea3).


# Version 23.0.0 "The Bride Said No" 2018-05-02

## New features and enhancements

* mkvmerge: input: format detection uses file-extension to improve performance
  and to give preference when several formats match.
* mkvmerge: AV1: added support for reading AV1 video from Open Bitstream Unit
  files.
* mkvmerge: AV1: adjusted the code for the AV1 bitstream format changes made
  up to 2018-05-02 (git revision d14e878).
* mkvmerge: MP4 reader: if a track has an edit list with two identical
  entries, each spanning the file's duration as given in the movie header
  atom, then the second entry will now be ignored. Improves the handling of
  files with bogus data; see #2196 and #2270.
* MKVToolNix GUI: multiplexer: added options to only enable tracks of certain
  types by default. Implements #2271.
* MKVToolNix GUI: multiplexer: added an option to enable dialog normalization
  gain removal by default for all audio tracks for which the operation is
  supported. Implements #2272.
* MKVToolNix GUI: multiplexer: when deriving track languages from the file
  names is active and the file name contains the usual season/episode pattern
  (e.g. "S02E14"), then only the part after the season/episode pattern will be
  used for detecting the language. Part of the improvements for #2267.
* MKVToolNix GUI: multiplexer: the regular expression used for deriving track
  languages from the file names can now be customized in the preferences. Part
  of the improvements for #2267.
* MKVToolNix GUI: multiplexer: the user can now customize the list of track
  languages the GUI recognizes in file names. This list defaults to a handful
  of common languages instead of the full list of supported languages. Part of
  the improvements for #2267.

## Bug fixes

* mkvmerge: MP3 packetizer: removed a memory leak growing linearly with the
  track's size.
* mkvmerge: VobSub packetizer: whenever a VobSub packet doesn't contain a
  duration on the container level, mkvmerge will now set it from the duration
  in the SPU packets. Before it was accidentally setting the SPU-level
  duration to 0 instead. Fixes #2260.
* mkvmerge: track statistics tags: if writing the `Date` element is
  deactivated via `--no-date`, the `_STATISTICS_WRITING_DATE_UTC` isn't
  written either anymore. Fixes #2286.
* mkvmerge, mkvextract, mkvpropedit: removed several small, constant-size
  memory leaks.
* mkvextract: fixed a crash when mkvextract with a non-Matroska file as the
  source file. Fixes #2281.
* MKVToolNix GUI: the central area is now scrollable, allowing the GUI to be
  resized to almost arbitrary sizes. Fixes #2265.
* MKVToolNix GUI: multiplexer: the "copy file title to destination file name"
  functionality will now replace everything in the destination file name up to
  the last period instead of only up to the first period. Fixes #2276.

## Build system changes

* build system: MKVToolNix now requires a compiler that supports the following
  features of the C++14 standard: "user-defined literals for
  `std::string`". For the GNU Compiler Collection (gcc) this means v5.x or
  newer; for clang it means v3.4 or newer.
* Windows: linking against and installing shared version of the libraries with
  MXE is now supported by setting `configure`'s `host` triplet accordingly,
  e.g. `--host=x86_64-w64-mingw32.shared`.

## Other changes

* mkvmerge: AV1: support for AV1 must be activated manually by adding
  `--engage enable_av1` as the AV1 bitstream specification hasn't been
  finalized yet.


# Version 22.0.0 "At The End Of The World" 2018-04-01

## New features and enhancements

* mkvmerge, MKVToolNix GUI multiplexer: AC-3, DTS, TrueHD: added an option for
  removing/minimizing the dialog normalization gain for all supported types of
  the mentioned codecs. Implements #1981.
* mkvmerge: AV1: added support for reading AV1 video from IVF, WebM and
  Matroska files.
* mkvmerge: FLAC: mkvmerge can now ignore ID3 tags in FLAC files which would
  otherwise prevent mkvmerge from detecting the file type. Implements #2243.
* mkvinfo: the size and positions of frames within "SimpleBlock" and
  "BlockGroup" elements are now shown the same way they're shown for other
  elements (by adding the `-v -v` and `-z` options).
* MKVToolNix GUI: multiplexer: added options for deriving the track languages
  from the file name by searching for ISO 639-1/639-2 language codes or
  language names enclosed in non-word, non-space characters (e.g. "…[ger]…"
  for German or "…+en+…" for English). Implements #1808.
* MKVToolNix GUI: info tool: implemented reading all elements in the file
  after the first cluster. Only top-level elements are shown; child elements
  are only loaded on demand. Implements the rest of #2104.
* MKVToolNix GUI: info tool: added a context menu with the option to show a
  hex dump of the element with the bytes making up the EBML ID and the size
  portion highlighted in different colors. In-depth highlighting is done for
  the data in `SimpleBlock` and `Block` elements.
* MKVToolNix GUI: chapter editor: added an option to remove all end timestamps
  to the "additional modifications" dialog. Implements #2231.

## Bug fixes

* mkvmerge: MP4 reader: fixed reading the ESDS audio header atom if it is
  located inside a "wave" atom inside the "stsd" atom.
* mkvmerge: MP4 reader: AAC audio tracks signalling eight channels in the
  track headers but only seven in the codec-specific configuration will be
  treated as having eight channels.
* mkvmerge: MPEG TS reader: fixed wrong handling of the continuity counter for
  TS packets that signal that TS payload is present but where the adaptation
  field spans the whole TS packet.
* mkvmerge: the 'document type version' and 'document type read version'
  header fields are now set depending on which elements are actually written,
  not on which features are active (e.g. if a `SimpleBlock` is never written,
  then the 'read version' won't be set to 2 anymore). Part of the fix for
  #2240.
* mkvmerge: the 'document type version' header field is now set to 4 correctly
  if any of the version 4 Matroska elements is written. Part of the fix for
  #2240.
* mkvinfo: summary mode: the file positions reported for frames in
  `BlockGroup` elements did not take the bytes used for information such as
  timestamp, track number flags or lace sizes into account. They were
  therefore too low.
* mkvpropedit, MKVToolNix GUI header editor: the 'document type version' and
  'document type read version' header fields are now updated if elements
  written by the changes require higher version numbers. Part of the fix for
  #2240.
* mkvpropedit, MKVToolNix GUI header editor: mandatory elements can now be
  deleted if there's a default value for them in the specifications. Fixes
  #2241.
* source code: fixed a compilation error on FreeBSD with clang++ 5.0. Fixes
  #2255.

## Build system changes

* A compilation database (in the form of a file `compile_commands.json`) can
  be built automatically if the variable `BUILD_COMPILATION_DATABASE` is set
  to `yes` (e.g. as `rake BUILD_COMPILATION_DATABASE=yes`).


# Version 21.0.0 "Tardigrades Will Inherit The Earth" 2018-02-24

## New features and enhancements

* mkvmerge: track statistics tags: the `TagDefault` element will not be
  written anymore as it was always set to the default value `1`
  anyway. Implements #2202.
* mkvmerge, MKVToolNix GUI: JSON files can now contain C++-style line comments
  outside of strings (e.g. something like this: `// this is ignored`). Such
  comments, even though not part of the official JSON specifications, are now
  ignored when reading JSON files.
* MKVToolNix GUI: chapter editor: opening a Matroska file without chapters in
  it will now open the file in an empty chapter editor instead of showing an
  error message. Implements #2218.
* MKVToolNix GUI: an "info" tool has been added, replacing the functionality
  of mkvinfo's GUI. The functionality is not on par yet but will be for
  release v22. Implements most of the functionality of #2104.

## Bug fixes

* build system: `configure` was treating `--disable-ubsan` and
  `--disable-addrsan` the same as `--enable-ubsan` and
  `--enable-addrsan`. Fixes #2199.
* build system: an error message is output if a command to execute is not
  found instead of silently failing.
* build system: in addition to looking for the `gettext` C function and
  library, `configure` now also verifies the presence of the `msgfmt` program
  instead of simply relying on it.
* mkvmerge: appending files with additional parts at the same time was broken
  if more than one additional part was appended (e.g. when appending files
  from DVDs with something like `'(' VTS_01_1.VOB VTS_01_2.VOB ')' + '('
  VTS_02_1.VOB VTS_02_2.VOB ')'`). In such a situation the content from files
  `VTS_02_1.VOB` and `VTS_02_2.VOB` where laid out in parallel to the content
  from the earlier files.
* mkvmerge: FLV reader: a single invalid AAC frame was written for AAC audio
  tracks with codec initialization data longer than five bytes.
* mkvmerge: FLV reader: timestamps will be normalized down to 0. Fixes #2220.
* mkvmerge: MP4 reader: if an AAC track doesn't contain an AAC-specific
  decoder configuration in the ESDS portion, then a default decoder
  configuration will be generated based on the track's header data instead of
  skipping the track. Fixes #2221.
* mkvmerge: MP4 reader: fixed reading HEVC/H.265 video tracks if they're
  stored as Annex B byte streams inside MP4. Fixes #2215.
* mkvmerge: Ogg Opus reader: mkvmerge will now emit a warning instead of
  aborting when it encounters an Ogg Opus page with no data in the
  packet. Fixes #2217.
* mkvmerge, mkvextract: Matroska parser: fixed a segmentation fault that
  occurred whenever the first level 1 element after resyncing after an error
  in the file structure isn't a cluster. Fixes #2211.
* mkvmerge, MKVToolNix GUI multiplexer & header editor: fixed a crash during
  file type detection for attachments if MKVToolNix is installed in a path
  with non-ASCII characters (e.g. German Umlauts). Fixes #2212.
* mkvinfo: the `--hex-positions` parameter did nothing in summary mode.
* mkvinfo: Windows: line endings will be written as `\r\n` (carriage return &
  line feed) again instead of just `\n` (line feed).
* mkvpropedit: adding track statistics tags: for tracks with content encoding
  (compression) mkvpropedit is now accounting the uncompressed number of
  bytes, not the encoded (compressed) number of bytes. Fixes #2200.
* MKVToolNix GUI: multiplexer: the subtitle character set can now be set for
  appended subtitle files, too. Fixes #2214.
* MKVToolNix GUI: multiplexer: when appending, all tracks appended to disabled
  tracks will start out disabled, too.

## Build system changes

* mkvinfo: the GUI portion has been removed. mkvinfo is now a pure
  command-line program again.


# Version 20.0.0 "I Am The Sun" 2018-01-15

## Important notes

* Feature removal: several deprecated features have been removed:

  * mkvmerge: the deprecated options `--identify-verbose` (and its counterpart
    `-I`), `--identify-for-gui`, `--identify-for-mmg` and
    `--identification-format verbose-text`
  * all command line tools: support for the deprecated, old, proprietary format
    used for option files
  * all command line tools: support for passing command line options via the
    deprecated environment variables `MKVTOOLNIX_OPTIONS`, `MKVEXTRACT_OPTIONS`,
    `MKVINFO_OPTIONS`, `MKVMERGE_OPTIONS` and `MKVPROPEDIT_OPTIONS`

* mkvinfo: most of its code was re-written in order to lay the groundwork for
  including its functionality in MKVToolNix GUI but with more features than
  the existing mkvinfo GUI. The result is that a lot of its output has been
  changed slightly while keeping the basic layout. Changes include but aren't
  limited to:

  * Several element names are a bit clearer (e.g. `Maximum cache` instead of
    `MaxCache`).
  * All timestamps and durations are now output as nanoseconds in formatted
    form (e.g. `01:23:45.67890123`). All additional formats (e.g. floating
    point numbers output in seconds or milliseconds) were removed.
  * Element names for chapters and tags are now translated if a translation is
    available.
  * Elements located in wrong positions within the Matroska document are
    handled better.

  While mkvinfo's output is mostly kept very stable, it is not designed to be
  parsed by other utilities. Even though I've tried hard to cram all changes
  and cleanups into this version, additional changes may be made in the next
  couple of releases depending on user feedback and bug reports.

## New features and enhancements

* mkvmerge: AVC/H.264 packetizer (framed): access unit delimiter NALUs will
  now be removed. Implements #2173.

## Bug fixes

* mkvmerge: AVC/H.264 parser: when fixing the bitstream timing information
  mkvmerge will now use exact representations of the desired field duration if
  possible. For example, when indicating 50 fields/second `num_units_in_tick`
  is set to 1 and `time_scale` to 50 instead of 5368709 and 268435456. Part of
  the fix for #1673.
* mkvmerge: AVC/H.264 parser: mkvmerge no longer assumes that encountering
  sequence parameter set or picture parameter set NALUs signal the start of a
  new frame. Fixes #2179.
* mkvmerge: AVC/H.264 packetizer (framed): when mkvmerge is told to fix the
  bitstream timing information, it will now update all SPS NALUs, not just the
  ones in the AVCC. Part of the fix for #1673.
* mkvmerge: MPEG TS reader: TS packet payloads will only be treated as PES
  packets if the payload actually starts with a PES start code. The prior
  behavior led to wrong timestamps and potentially broken frame data. Fixes
  #2193.
* mkvmerge: MPEG TS reader: mkvmerge will now drop incomplete PES packets as
  soon as an error is detected in the transport stream instead of passing the
  incomplete frame to the packetizer. An error is assumed either if the
  `transport_error_indicator` flag is set or if the value of the
  `continuity_counter` header field doesn't match the expected value. Fixes
  #2181.
* mkvmerge: Opus: when re-muxing Opus from Matroska mkvmerge will now write
  "block duration" elements for all block groups where a "discard padding" is
  set, too. Fixes #2188.
* mkvmerge: SRT reader: mkvmerge can now handle SRT files with timestamps
  without decimal places (e.g. `00:01:15` instead of `00:01:15.000`).
* mkvmerge: read buffer I/O class: the class could get out of sync regarding
  the file position of the underlying file I/O class causing wrong data to be
  returned on subsequent read operations. One result was that trying to
  identifying MPLS files that refer to very short M2TS files caused mkvmerge
  to segfault.
* mkvmerge: multiplexer core: if there's a gap in audio timestamps, a new
  block group/lace will be started for the first frame after each gap. Before
  the fix the frame after the gap was often stored in the previous block group
  causing the gap to be in the wrong place: at the end of that block
  group. Fixes #1700.
* mkvextract: AVC/H.264: if two consecutive IDR frames with the same
  `idr_pic_id` parameter and no access unit delimiters are found between them,
  mkvextract will insert an access unit delimiter in order to signal the start
  of a new access unit. Fixes #1704.
* MKVToolNix GUI: update check dialog: Markdown links will now be converted to
  clickable links. Fixes #2176.
* build system: fixed a race condition when creating new directories if `rake`
  is run with `-jN` in newer versions of Ruby/`rake`. Fixes #2194.

## Build system changes

* [cmark](https://github.com/commonmark/cmark), the CommonMark parsing and
  rendering library in C, is now required when building the GUIs.


# Version 19.0.0 "Brave Captain" 2017-12-17

## Important notes

* The MKVToolNix project now contains a
  [Code of Conduct](https://mkvtoolnix.download/doc/CODE_OF_CONDUCT.md).
* The MKVToolNix project's source code repository, bug tracker and wiki have
  been moved to [GitLab](https://gitlab.com/mbunkus/mkvtoolnix/).

## New features and enhancements

* mkvmerge: splitting by duration, by timestamps or by timestamp-based parts:
  mkvmerge will now consider the first key frame within 1ms of the requested
  value to be eligible for splitting.
* MKVToolNix GUI: the GUI will now save and restore the widths of columns in
  tree and list views. Implements #2057.
* MKVToolNix GUI: header editor: when closing or reloading a modified file,
  the GUI will now focus the first element that's been modified before asking
  the user for confirmation regarding discarding unsaved changes.

## Bug fixes

* mkvmerge: fixed reading text files encoded in UTF-16 order UTF-32 that have
  different forms of line endings (new lines, carriage returns or a mix of
  both). Fixes #2160.
* mkvmerge: MP4 reader: fixed mkvmerge's interpretation of edit list entries
  with `segment_duration == 0` when there's more than one edit list entry. In
  that case mkvmerge was reading the whole content more than once. Fixes
  #2152.
* mkvmerge, GUI's multiplexer: MIME types: added the `font` top-level media
  types from RFC 8081. This means that the following new MIME types for fonts
  can be used: `font/ttf`, `font/otf`, `font/woff` and `font/woff2`.
* mkvmerge: MPEG transport stream reader: fixed slow speed on Windows due to
  lack of buffering.
* mkvextract: fixed slow track extraction speed on Windows due to lack of
  buffering. Fixes #2166.
* MKVToolNix GUI: multiplexer: changing the "subtitle/chapter character set"
  drop-down was ignored when the selected track was a chapter track. Fixes
  #2165.
* MKVToolNix GUI: multiplexer: once a "subtitle/chapter character set" was set
  for a track it couldn't be changed back to the empty entry (=
  auto-detection) anymore.
* MKVToolNix GUI: header editor: fixed re-translating several displayed
  strings when the GUI language is changed if the language the GUI was started
  with was not English. Fixes #2159.
* MKVToolNix GUI: header editor: whenever a file did not contain a "date"
  element in its segment information section, the GUI would erroneously ask
  the user to confirm discarding unsaved changes when closing or reloading the
  tab. Fixes #2167.
* MKVToolNix GUI: job queue: jobs are now saved when their status changes in
  addition to when the program exits. Fixes #2168.


# Version 18.0.0 "Apricity" 2017-11-18

## New features and enhancements

* build system: when building with clang v3.8.0 or newer, `configure` will no
  longer restrict optimization flags to `-O1` and use `-O3` again (older
  versions of clang suffered from excessive memory usage with higher
  optimization levels).
* build system: when building with mingw 7.2.0 or newer, `configure` will no
  longer restrict optimization flags to `-O2` and use `-O3` again (older
  versions of mingw suffered from bugs such as segmentation faults with higher
  optimization levels).
* build system: stack protection is enabled when building with clang 3.5.0 or
  newer on all platforms.
* mkvmerge: AVC/H.264 & HEVC/H.265 ES parsers: performance improvements by
  copying much less memory around.
* mkvmerge: tags: reintroduced a workaround for non-compliant files with tags
  that do not contain the mandatory `SimpleTag` element. This workaround was
  removed during code refactoring in release v15.0.0.
* GUI: multiplexer: the "AAC is SBR/HE-AAC/AAC+" checkbox in the "audio
  properties" section will be disabled if the functionality is not implemented
  for the selected track's codec & container.
* GUI: multiplexer: the "reduce to core" checkbox in the "audio properties"
  section will be disabled if the functionality is not implemented for the
  selected track's codec. See #2134.

## Bug fixes

* mkvmerge: AAC ADTS parser: fixed interpretation of the
  `channel_configuration` header element for ADTS files that do not contain a
  program configuration element: value 7 means 7.1 channels. Fixes #2151.
* mkvmerge: Matroska identification: the `date_local` and `date_utc`
  attributes will only be output if the identified Matroska file actually
  contains the "date" header field.
* mkvmerge: WebVTT: mkvmerge did not recognize timestamp lines if the hours
  components were absent. Fixes #2139.
* mkvpropedit, GUI's header editor: the `date` header field won't be added
  automatically anymore whenever the segment info section is edited and the
  `date` element is either deleted or not present in the first place. Fixes
  #2143.


# Version 17.0.0 "Be Ur Friend" 2017-10-14

## Important notes

* The word "timecode" has been changed to "timestamp" everywhere it was
  used in MKVToolNix. This affects program output (including mkvinfo's), GUI
  controls, command line parameters (e.g. `mkvmerge --timestamp-scale …`) and
  file formats. All programs remain backwards compatible insofar as they still
  accept "timecode" in all those places (e.g. `mkvmerge --timecode-scale …`).

  The reason for the change is wrong usage. What both the Matroska specification
  and MKVToolNix used "timecode" for is normally called a "timestamp" in audio &
  video domains. A "timecode" on the other hand has a specific meaning. As the
  Matroska specification is moving towards implementing real timecodes, it will
  also move towards correcting the verbiage. MKVToolNix is following this
  change.

* mkvextract's command line interface has been changed to allow extraction of
  multiple items at the same time. The first argument must now be the source
  file's name. All following arguments either set the mode (e.g. `tracks`) or
  specify what to extract in the currently active mode.

  Those items that were written to the standard output (chapters, tags and cue
  sheets) are now always written to files instead. Therefore the respective
  modes require an output file name.

  For example, extracting two tracks, the chapters and the tags can be done
  with the following command:

  `mkvextract input.mkv tracks 0:video.h265 1:audio.aac chapters chapters.xml tags tags.xml`

  The old interface (specifying the mode first and the source file name
  second) remains working and supported. However, it is now deprecated and
  will be removed at the end of 2018.

## New features and enhancements

* mkvmerge: AC-3: during identification regular AC-3 and E-AC-3 tracks will
  now be identified differently for most container formats (exception: AVI,
  Real Media, Ogg/OGM). The codec will be reported as `AC-3` for regular AC-3
  and as `E-AC-3` for E-AC-3 tracks instead of the combined `AC-3/E-AC-3`.
* mkvextract: the command line interface has been changed to allow extraction
  of multiple items at the same time. See section "Important notes" for details.

## Bug fixes

* mkvmerge: AAC ADTS parser: mkvmerge will now parse the
  `program_config_element` if it is located at the start of an AAC frame in
  order to determine the actual number of channels. This overrides invalid
  channel configurations in the ADTS headers, for example. Fixes #2107.
* mkvmerge: fixed AC-3 being misdetected as encrypted MPEG program streams
  under certain conditions.
* mkvmerge: Dirac: under certain conditions (e.g. only muxing a single Dirac
  track without any other tracks) mkvmerge was always setting the pixel width
  & height to 123. The frame rate was wrong, too.
* mkvmerge: E-AC-3 in Matroska: if AC-3 cores and their corresponding E-AC-3
  extension are located in two different Matroska blocks, then mkvmerge will
  now re-assemble them into a single block and only use the first block's
  timestamp.
* mkvmerge: SRT reader: fixed calculating the duration of entries starting
  with at a negative timestamp.
* mkvmerge: VC-1: under certain conditions (e.g. only muxing a single VC-1
  track without any other tracks) mkvmerge was always setting the pixel width
  & height to 123. The frame rate was wrong, too. Fixes #2113.
* mkvmerge: command line options: an error message will be output if the
  single-value-form of the `--sync` option is used and it isn't a number
  (e.g. `--sync 0:asd`). Fixes #2121.
* mkvpropedit, GUI's header editor: both programs will now show proper error
  messages instead of crashing when certain kinds of data corruption is found
  when reading a file. Fixes #2115.


# Version 16.0.0 "Protest" 2017-09-30

## New features and enhancements

* mkvmerge: MP4 reader: added support for Vorbis. Implements #2093.

## Bug fixes

* configure: the checks for libEBML and libMatroska have been fixed to require
  libEBML 1.3.5 and libMatroska 1.4.7 as intended.
* mkvmerge: AAC reader: mkvmerge will now emit an error message for AAC files
  whose header fields imply a sampling frequency or number of channels
  of 0. See #2107.
* mkvmerge: AVC/H.264 ES parser: fixed the calculation of reference
  information for P and B frames. This also fixes some P frames being marked
  as B frames and vice versa.
* mkvmerge: AVC/H.264 ES parser: only non-key frames that have the NALU header
  field `nal_ref_idc` set to 0 will be marked as "discardable" in
  `SimpleBlock` elements. Other half of the fix for #2047.
* mkvmerge: HEVC/H.265: the generation of the HEVCC structure stored in
  `CodecPrivate` was wrong in two places: 1. the position of the number of
  sub-layers was swapped with reserved bits and 2. the VPS/SPS/PPS/SEI lists
  did not start with a reserved 1 bit.
* mkvmerge: output: the `doc type version` will be set at least to 2 if
  certain elements are written (`CodecState`, `CueCodecState`,
  `FlagInterlaced`).
* mkvmerge: output: the track header attributes `MinCache` and `MaxCache` will not be
  written anymore. Fixes #2079.
* mkvmerge: Matroska reader: the "key" and "discardable" flags of SimpleBlock
  elements will be kept as they are. Partial fix for #2047.
* mkvmerge: Matroska reader: if present in the file, the "white color
  coordinate x" track header attribute was written to both "white color
  coordinate x" and "white color coordinate y" in the output file.
* mkvmerge: Opus output: mkvmerge will now put all frames with discard padding
  into their own block group. Fixes #2100.
* MKVToolNix GUI: header editor: removed the check for external modification
  when saving the file. Fixes #2097.
* MKVToolNix GUI: job queue: fixed calculation of total progress when
  automatic removal of completed is enabled. Fixes #2105.

## Build system changes

* libEBML v1.3.5 and libMatroska v1.4.8 are now required. In fact v15.0.0
  already requires libEBML v1.3.5 and libMatroska v1.4.7 but did not include
  proper version checks for them (nor was there a NEWS.md entry for the new
  libMatroska requirement). New is the requirement for libMatroska v1.4.8 due
  to it fixing writing block groups for tracks with the track number 128 (see
  #2103).


# Version 15.0.0 "Duel with the Devil" 2017-08-19

## Important notes

* mkvmerge, mkvpropedit, GUI's header and chapter editors: the programs will
  no longer add most missing Matroska elements that are mandatory but have a
  default value in the Matroska specification (e.g. the `TagLanguage` element
  with a value of `und` if it isn't present in its `SimpleTag` parent). Due to
  this change libEBML v1.3.5 is now required.

## New features and enhancements

* MKVToolNix GUI: multiplex tool: added a new entry to the "source files"
  context menu labeled "Set destination file name from selected file's
  name". It will force the GUI to consider the selected file to be the
  reference for automatically setting the file name, no matter which file was
  originally added as the first file. It will also force setting the
  destination file name once if automatic destination file name generation is
  turned off in the preferences. Implements part of #2058.
* MKVToolNix GUI: multiplex tool: added an option in the preferences on
  "Multiplexer" → "Output" labeled "Only use the first source file that
  contains a video track". If enabled, only source files containing video
  tracks will be used for setting the destination file name. Other files that
  are added are ignore. Implements the rest of #2058.
* MKVToolNix GUI: header editor: added support for editing the video color
  attributes. Implements the second half of #2038.
* MKVToolNix GUI: header editor: added support for the "video projection"
  track header attributes. Part of the implementation of #2064.
* MKVToolNix GUI: job queue: selected jobs can now be move up and down by
  pressing the `Ctrl+Up` and `Ctrl+Down` keys. Additionally, push buttons to
  move them up & down are shown if the corresponding option is enabled in the
  preferences. Implements #2060.
* mkvmerge: added support for the "video projection" track header
  attributes. Part of the implementation of #2064.
* mkvinfo: added support for the "video projection" track header
  attributes. Part of the implementation of #2064.
* mkvpropedit: added support for editing the video color
  attributes. Implements one half of #2038.
* mkvpropedit: added support for the "video projection" track header
  attributes. Part of the implementation of #2064.

## Bug fixes

* all: selecting the program's language (e.g. via the `--ui-language`
  command-line option or via the GUI's preferences) did not work on Linux &
  Unix if the `LANGUAGE` environment variable was set and didn't include the
  desired language. Fixes #2070.
* MKVToolNix GUI: removed the keyboard shortcuts for switching between the
  different tools (e.g. `Ctrl+Alt+1` for the multiplexer). They overlapped
  with basic functionality on keyboards that use an `AltGr` key, e.g. German
  ones, where `AltGr+7` emits `{`. As `AltGr+key` is implemented as
  `Ctrl+Alt+key` under the hood, this means that `AltGr+7` is really
  `Ctrl+Alt+7` which the GUI now took to mean "switch to the job queue"
  instead of "insert `{`". Fixes #2056.
* MKVToolNix GUI: header editor: after saving the file the GUI wasn't updating
  its internal file modification timestamp. That lead to the GUI wrongfully
  claiming that the file had been modified externally when the user wanted to
  save the file once more, requiring a reload of the file losing all
  modifications made since saving the first time.
* mkvmerge: DTS handling: some source files provide timestamps for audio
  tracks only once every `n` audio frames. In such situations mkvmerge was
  buffering too much data resulting in a single gap in the timestamps of one
  frame duration after frame number `n - 1` (the second audio timestamp read
  from the source file was used one output frame too early). Fixes #2071.
* mkvinfo: fixed a null pointer dereference if an `EbmlBinary` element's data
  pointer is a null pointer. Fixes #2072.

## Build system changes

* configure: added option `--disable-update-check`. If given, the code
  checking online for available updates will be disabled. The update check is
  enabled and included in the GUI by default.
* libEBML v1.3.5 is now required.

## Other changes

* mkvmerge: the option `--color-matrix` has been renamed to
  `--color-matrix-coefficients` in order to match the specification more
  closely. The old option name will continue to be recognized as well.


# Version 14.0.0 "Flow" 2017-07-23

## New features and enhancements

* mkvmerge: AAC: implemented support for AAC with 960 samples per
  frame. Implements #2031.
* mkvmerge: identification: if the encoding/character set of a text subtitle
  track is known (e.g. because a byte order mark is present in the file), then
  it will be output during identification as the `encoding`
  property. Implements mkvmerge's part of #2053.
* mkvmerge: WAV reader: added support for Wave64 files. Implements #2042.
* mkvmerge, mkvpropedit, MKVToolNix GUI (chapter editor): added support for
  chapters in WebM files that is spec-compliant by removing all tag elements
  not supported by the WebM spec. Implements #2002.
* mkvpropedit: added support for tags in WebM files that is spec-compliant by
  removing all tag elements not supported by the WebM spec.
* MKVToolNix GUI: multiplexer: if the encoding/character set of a subtitle
  track cannot be changed, the GUI will deactivate the "subtitle character
  set" drop-down box and ignore changes to it when multiple tracks are
  selected. Additionally, if the track's encoding is known and cannot be
  changed (e.g. due to a byte order mark in the file), that encoding will be
  selected in the drop-down box automatically. Both changes signal to the user
  that she doesn't have to take care of the encoding herself. Implements the
  GUI's part of
  #2053.
* MKVToolNix GUI: chapter editor: added a function to the "additional
  modifications" dialog for calculating and setting the end
  timestamps. Implements #1887.
* MKVToolNix GUI: changed the shortcuts for switching between the various
  tools from `Alt+number` (e.g. `Alt+1` for the multiplexer tool) to
  `Ctrl+Alt+number` in order to avoid clashing with Windows' input method for
  arbitrary characters (pressing and holding `Alt` and typing the codepoint on
  the number pad). Implements #2034.
* MKVToolNix GUI: added a "Window" menu and entries with shortcuts for
  selecting the next (`Ctrl+F6`) respectively previous tab (`Ctrl+Shift+F6`)
  in the current tool. Implements #1972, #2032.
* MKVToolNix GUI: on Windows the GUI will now determine the default font to
  use by querying Windows for the default UI/message box font instead of using
  the hardcoded `Segoe UI`. This might fix issues such as #2003 (unverified).
* translations: added a Romanian translation of the programs by Daniel (see
  AUTHORS).


## Bug fixes

* mkvmerge: AVC/H.264 parser: fixed wrong frame order & timestamp calculation
  in certain situations when SPS (sequence parameter sets) or PPS (picture
  parameter sets) change mid-stream. Fixes #2028.
* mkvmerge: HEVC/H.265 parser: fixed wrong frame order & timestamp calculation
  in certain situations when SPS (sequence parameter sets) or PPS (picture
  parameter sets) change mid-stream. This is the HEVC/H.265 equivalent of
  #2028.
* mkvmerge: MPEG-1/-2 video: the "remove stuffing bytes" feature introduced in
  v5.8.0 (feature request #734) was broken. In a lot of situations it did not
  detect the end of a slice correctly and removed 0 bytes that were actually
  part of the slice structure. Often there were no visual problems as decoders
  were able to ignore such errors, but in other cases there are visual
  artifacts upon decoding. As detecting the slice end properly requires
  parsing the whole slice structure, this feature has been removed
  again. Fixes #2045.
* mkvmerge: MPEG PS reader: fixed mkvmerge trying to handle an "end" code the
  same way as a "program stream map" code.
* mkvmerge: MPEG TS reader: mkvmerge won't emit warnings if the system's
  `iconv` library doesn't support the ISO 6937 character set. Fixes #2023.
* mkvmerge: when appending fails the error message details (e.g. "the number
  of channels differs: 1 and 2") were often not output. Fixes #2046.
* MKVToolNix GUI: multiplex tool: implemented a workaround for a crash that
  could occur during drag & drop if at least one of the columns is
  hidden. Fixes #2009.
* MKVToolNix GUI: multiplex tool: appended tracks can no longer be enabled
  (selected for multiplexing) if the track they're going to be appended to is
  not enabled. Fixes #2039.
* MKVToolNix GUI: multiplex tool: if the GUI is set to ensure unique output
  file names, it will now verify that right before starting to
  multiplex/adding the job to the queue, too. Fixes #2052.
* MKVToolNix GUI: fixed the total progress reverting to 0% instead of staying
  at 100% when all jobs have finished. This was introduced by the attempt at
  fixing the computation of the value of total progress bar for multiple jobs
  running. Fixes #2005.
* configure: fixed DocBook detection if `/bin/sh` is `dash`. Patch by Steve
  Dibb. Fixes #2054.

## Build system changes

* Boost: the minimum required version has been bumped to 1.49.0. Earlier
  releases fail to build on my current systems and will therefore not be
  supported anymore.
* configure: when looking for the "nlohnmann JSON" include files configure
  will now try the path "nlohmann/json.hpp" first, "json.hpp" second (only
  "json.hpp" was tried before). If neither is found, the copy included in the
  MKVToolNix sources will be used. Fixes #2048.


# Version 13.0.0 "The Juggler" 2017-06-25

## New features and enhancements

* mkvmerge: MPEG TS reader: information about multiple programs will be output
  as container properties during verbose/JSON identification. See #1990 for
  the use case.
* MKVToolNix GUI: multiplex tool: added a column "program" to the tracks
  list. Certain container types such as MPEG transport streams can contain
  multiple programs. The new column will contain the service name (think TV
  station names such as "arte HD") for such streams. Implements the GUI part
  of #1990.
* MKVToolNix GUI: multiplex tool: the dialog asking the user what to do with
  dropped files (add to current settings, add to new settings etc.) now
  remembers the previous decision and defaults to it the next time it's
  shown. Implements #1997.
* MKVToolNix GUI: tabs can now be closed by pressing the middle mouse
  button. Implements #1998.

## Bug fixes

* mkvmerge: MP4 reader: MPEG-1/2 video read from MP4 files was written with an
  invalid codec ID (e.g. `V_MPEG7`) in certain cases. Fixes #1995.
* mkvmerge: MPEG PS reader: made the file type detection less strict so that
  garbage at the start of the file doesn't prevent detection. Fixes #2008.
* mkvmerge: MPEG PS reader: (E-)AC-3 tracks were not detected if the very
  first packet for that track didn't contain a full (E-)AC-3 frame. Fixes
  #2016.
* mkvmerge: MPEG TS reader: fixed mkvmerge not detecting all tracks in MPEG
  transport streams containing multiple programs. Fixes one part of #1990.
* mkvmerge: MPEG TS reader: fixed track content being broken for some tracks
  read from MPEG transport streams containing multiple programs. Fixes another
  part of #1990.
* mkvmerge: JSON identification: the `stream_id` and `sub_stream_id` track
  properties were output as hexadecimal strings instead of unsigned
  integers. As the `ts_pid` track property was only used for MPEG transport
  streams, its value is now output as `stream_id` instead, and the `ts_pid`
  property has been removed. The JSON schema version has been bumped to 8 due
  to this change.
* mkvmerge: fixed a crash when appending video tracks where one track has a
  CodecPrivate member and the other one doesn't.
* mkvmerge: track statistics tags: the `NUMBER_OF_BYTES` tag is supposed to
  contain the number of bytes in a track before any of the content encoding
  schemes such as lossless compression is applied; however, mkvmerge was
  wrongfully using the number of bytes after the schemes had been
  applied. Fixes #2022.
* mkvmerge: CLPI & MPLS parsers: MPLS and CLPI files with version number
  `0300` as used on Ultra HD Blu-ray Discs are now accepted as well. Fixes
  #2010.
* mkvpropedit: fixed a crash when the selector used for `--tags` is invalid.
* MKVToolNix GUI: fixed computation of value of total progress bar for multiple
  jobs running. Fixes #2005.
* MKVToolNix GUI: multiplexer, adding new attachments: when the GUI checks if
  there's an attachment with the same name it will now disregard disabled
  attached files. Fixes #2001.
* Debian/Ubuntu packaging: during a `dpkg-buildpackage` run the test suite was
  failing when a non-English locale was active and MKVToolNix packages had
  already been installed. Fixes #2011.


# Version 12.0.0 "Trust / Lust" 2017-05-20

## New features and enhancements

* MKVToolNix GUI: the key combination Ctrl+Shift+Space will now toggle the
  selection of the current item in all tree views where multiple selections
  are allowed. Implements #1983.
* MKVToolNix GUI: chapter editor: added the extension `*.cue` (for cue sheet
  files) to the "open chapter file" dialog.
* mkvmerge: cue sheet parser: if the cue sheet contains a non-empty `TITLE`
  entry and if no other segment title has been set yet, then the segment title
  will be set to the cue sheet's `TITLE` value. Implements #1977.
* mkvmerge, MKVToolNix GUI (multiplexer): added an option `--no-date` that
  prevents the "date" field from being written to the segment information
  headers. Implements one half of #1964.
* mkvpropedit, MKVToolNix GUI: header editor: added support for editing the
  "date" segment information field. Implements the other half of #1964.

## Bug fixes

* MKVToolNix GUI: preferences → job actions, type "play audio file": the GUI
  will no longer clear the audio file name input if the user aborts the audio
  file selection dialog.
* MKVToolNix GUI: preferences → job actions, type "play audio file", on
  Windows: the default "play audio" action was pointing to the wrong
  directory. Existing configurations with such a wrong path will be fixed
  automatically upon starting the GUI. Fixes #1956.
* mkvmerge: HEVC/H.265 parser: fixed the superfluous copying of the
  `bitstream_restriction_flag` and its dependent flags in the VUI parameters
  of the sequence parameter sets if the timing information is present,
  too. This fixes #1924 properly, and it also fixes #1958.
* mkvmerge: MPEG TS reader, AAC parser: the MPEG TS reader will now force the
  AAC parser to use the multiplex mode that the MPEG TS reader has detected
  (e.g. LOAS/LATM). This prevents the AAC packetizer from mis-detecting it in
  its own attempt to identify the mode. Fixes #1957.
* mkvmerge: MPEG TS reader: valid MPEG transport streams that start with an
  H.264/H.265 start code (e.g. a file created by cutting at an arbitrary
  position) were not recognized as a supported file type.
* mkvmerge: MPEG TS reader: fixed a potential read access from invalid memory
  addresses in the code parsing the program map table (PMT).
* mkvmerge: MPEG TS reader: if packets are encountered that belong to a PID
  not listed in the program map table (PMT), mkvmerge will attempt to
  determine their type and codec from the content. This supported content
  types are AAC (ADTS only) and AC-3. Fixes #1980.
* mkvmerge: MP4 reader: fixed finding and parsing the `colr` atom if there are
  more than one video extension atoms and the `colr` atom is not the first
  one.
* mkvmerge: MP4 reader: the `nclx` color type of the `colr` atom is now
  recognized, too (as defined by ISO/IEC 14496-12, "ISO base media format").
* configure: fixed configure aborting if a `moc`, `uic`, `rcc` or `qmake`
  binary is found, but the binary's version is too old. Fixes #1979.


# Version 11.0.0 "Alive" 2017-04-22

## New features and enhancements

* mkvmerge: FLAC reader: added support for handling embedded pictures as
  attachments. Implements #1942.
* mkvmerge: MP4 reader: merged pull request #1804 adding support for parsing
  the "COLR" atom and including its values as track headers.
* MKVToolNix GUI: watch jobs: the user can now have the GUI execute an action
  once as soon as the current job or the whole queue finishes. The actions are
  the same ones that can be configured to be run automatically after job or
  queue completion.
* MKVToolNix GUI: implemented several built-in actions that can be executed
  either on special events or once via the "watch jobs" tool. These are:
  playing an audio file (implemented for all operating systems); hibernating,
  sleeping and shutting down the computer (only implemented for Windows and
  for Linux systems using systemd).
* MKVToolNix GUI: multiplex tool: added a new option for what to do after
  starting to multiplex/adding to the job queue: "close current settings" will
  close the current multiplex settings without opening new ones.

## Bug fixes

* mkvmerge: AAC parser: fixed mis-detection of certain data as valid ADTS AAC
  headers resulting in memory allocation failures. Fixes #1941.
* mkvmerge: AVC/H.264 parser: mkvmerge will now ignore bogus timing
  information in the sequence parameter sets (values indicating more than
  100000 progressive frames per second). Fixes #1946.
* mkvmerge: AVC/H.264 & HEVC/H.265 parsers: all trailing zero bytes will now
  be removed from NALUs. Fixes #1952.
* mkvmerge: HEVC/H.265 parser: fixed copying the `bitstream_restriction_flag`
  and all dependent fields in the VUI parameters of the sequence parameter
  sets. Fixes #1924.
* mkvmerge: HEVC/H.265 parser: fixed the calculation of the number of
  parameter set arrays in the HEVCC data structure stored in
  CodecPrivate. Fixes the video-related part of #1938.
* mkvmerge: HEVC/H.265 parser: fixed writing superfluous and uninitialized
  bytes at the end of the HEVCC data structure stored in CodecPrivate. Another
  fix for the video-related part of #1938.
* mkvmerge: HEVC/H.265 parser: fixed the assumption that the HEVCC data
  structure always includes arrays for all parameter set types (VPS, SPS, PPS
  and SEI), and that the order is always VPS → SPS → PPS → SEI. Instead now
  only the arrays actually present are parsed, and they can be in any order.
  This fixes mkvinfo's output for Matroska files created from files such as
  the one from #1938.
* mkvmerge: AVC/H.264 packetizer: when reading a framed track (e.g. from
  Matroska or MP4 files), specifying a default duration as fields (e.g. `50i`)
  would result in double the actual duration for each frame and the track's
  default duration header field. Fixes #1916.
* mkvmerge: Matroska reader: invalid track language elements are now treated as
  if they were set to `und` = "undetermined". See #1929 for context.
* mkvmerge: MPEG TS reader, AAC: mkvmerge will now require five consecutive
  AAC headers with identical parameters before track type determination is
  considered valid. This avoids false positives and consequently wrong track
  parameters. Fixes the audio-related part of #1938.
* mkvmerge: fixed an endless loop in certain circumstances when splitting by
  `parts` or `parts-frames` and the start of the file is discarded. Fixes
  #1944.
* MKVToolNix GUI: multiplexer tool: the "show command line" dialog will no
  longer include the mkvmerge executable's location as the first argument for
  the two "MKVToolNix option files" escape modes. Fixes #1949.
* MKVToolNix GUI, header editor: empty track language elements are now treated
  the same as those set to invalid ISO 639-2 codes: as if they were set to
  `und` = "undetermined". See #1929 for context.

## Build system changes

* bug fix: configure now looks for the `strings` binary by using the
  `AC_CHECK_TOOL()` autoconf macro. That way it will be found in multiarch
  setups, too. Fixes #1923.
* bug fix: the environment variable USER_CXXFLAGS was accidentally removed
  from the compiler flags in release 9.8.0. It's been re-added. Fixes #1925.
* The `.desktop` files have been renamed to
  `org.bunkus.mkvtoolnix-gui.desktop` and `org.bunkus.mkvinfo.desktop`. This
  allows Wayland compositors to associate the correct icons with running
  applications for e.g. task switchers. Fixes #1948.
* Qt's multimedia component is required for compilation of the GUIs since
  version 11.0.0.


# Version 10.0.0 "To Drown In You" 2017-03-25

## New features and enhancements

* mkvmerge: AVC/H.264 parser: mkvmerge will now drop all frames before the
  first key frame as they cannot be decoded properly anyway. See #1908.
* mkvmerge: HEVC/H.265 parser: mkvmerge will now drop all frames before the
  first key frame as they cannot be decoded properly anyway. See #1908.
* mkvmerge: HEVC/H.265 parser: added a workaround for invalid values for the
  "default display window" in the VUI parameters of sequence parameter
  sets. Fixes #1907.

## Bug fixes

* mkvmerge: MP4 reader: fixed track offsets being wrong in certain situations
  regarding the presence or absence of edit lists ('elst' atoms) & composition
  timestamps ('ctts' atoms). Fixes #1889.
* mkvmerge: MP4 reader: offsets in "ctts" are now always treated as signed
  integers, even with version 0 atoms.
* mkvinfo: the timestamps of SimpleBlocks with negative timestamps are now
  shown correctly.
* mkvmerge: Matroska reader: fixed handling BlockGroups and SimpleBlocks with
  negative timestamps.
* mkvmerge: MP3 packetizer: the MP3 packetizer will no longer drop timestamps
  from source containers if they go backwards. This keeps A/V in sync for
  files where the source was in sync even though their timestamps aren't
  monotonic increasing. Fixes #1909.
* mkvmerge: AVC/H.264 parser: mkvmerge will now drop timestamps from the
  source container if no frame is emitted for that timestamp. Fixes #1908.
* mkvmerge: HEVC/H.265 parser: mkvmerge will now drop timestamps from the
  source container if no frame is emitted for that timestamp. Fixes the HEVC
  equivalent of the problem with AVC described in #1908.
* mkvextract: SSA/ASS: fixed extraction when the "Format" line in the
  "[Events]" section contains less fields than the default for SSA/ASS would
  indicate. Fixes #1913.


# Version 9.9.0 "Pick Up" 2017-02-19

## New features and enhancements

* GUI: chapter editor: added a character set selection in the preferences for
  text files. If a character set is selected there, it will be used instead of
  asking the user when opening text chapter files. Implements #1874.
* GUI: multiplexer: added a column "character set" to the "tracks, chapters
  and tags" list view showing the currently selected character set for that
  track. Implements #1873.
* mkvmerge: added an --engage option "all_i_slices_are_key_frames" for
  treating all I slices of an AVC/H.264 stream as key frames in pathological
  streams that lack real key frames. Implements #1876.
* GUI: running programs after jobs: added a new variable
  \<MTX_INSTALLATION_DIRECTORY\> for the directory the MKVToolNix GUI executable
  is located in.
* mkvmerge: DVB subtitle tracks whose CodecPrivate data is only four bytes
  long will now be fixed up to the proper five bytes by adding the subtitling
  type byte.
* mkvmerge: MP4 reader: "ctts" version 1 atoms are now supported.

## Bug fixes

* mkvmerge: AC-3 handling: some source files provide timestamps for audio
  tracks only once every n audio frames. In such situations mkvmerge was
  buffering too much data resulting in a single gap in the timestamps of one
  frame duration after frame number n - 1 (the second audio timestamp read
  from the source file was used one output frame too early). Fixes #1864.
* mkvmerge: MP4 reader: mkvmerge was only reading a small part of MP4 DASH
  files where the first "moov" "mdat" atoms occur before the first "moof"
  atom. This is part of the fix for #1867.
* mkvmerge: MP4 reader: edit list ("edts" atoms) that are part of the "moof"
  atoms used in MP4 DASH files weren't parsed. Instead the edit lists from the
  main track headers inside the "moov" atom were used. This is part of the fix
  for #1867.
* mkvmerge: MP4 reader: when an MP4 DASH file contained both normal chunk
  offset table ("stco"/"co64" atoms) in their regular "moov" atoms, a
  sample-to-chunk table ("stsc" atom) whose last entry had a "samples per
  chunk" count greater than 1 and DASH "trun" atoms, then mkvmerge was
  calculating wrong positions the frame content. This is part of the fix for
  #1867.
* mkvmerge: MP4 reader: mkvmerge couldn't deal with the key frame index table
  having duplicate entries. The result was that only key frames up to and
  including the first duplicate entry were marked as key frames in the output
  file. All other frames weren't, even though some of them were referenced
  from the key frame table after the first duplicate entry. This is part of
  the fix for #1867.
* mkvmerge: MP4 reader: when an MP4 file contained more than one copy of the
  "moov" atom (the track headers etc.), mkvmerge was parsing them all adding
  tracks multiple times. Fix for #1877.
* mkvmerge: MP4 reader: fixed an integer overflow during the timestamp
  calculation leading to files with wrong timestamps. Such files could not be
  played back properly by most players. Fixes #1883.
* mkvmerge: MPEG TS reader: if the PMT lists a DVBSUB track, mkvmerge will now
  recognize it without having to find a packet for it within the probed range.
* mkvmerge: splitting by parts (both the "timestamps" and the "frames"
  variants): fixed the calculation of track statistics tags. When calculating
  the duration the skipped portions weren't taken into account leading to a
  too-high duration. As a consequence the BPS tag (bits per second) was wrong,
  too. Fixes #1885.
* mkvmerge: reading files with DVB/HDMV TextSV subtitle tracks with invalid
  CodecPrivate caused mkvmerge to abort with an error from boost::format about
  the format string not having enough arguments. Fixes #1894.
* mkvmerge: fixed misdetection of certain AC-3 files as MP3 files which led to
  an error message that "the demultiplexer could not be initialized".
* mkvmerge: fixed huge memory consumption when appending big Matroska files
  with sparse tracks (e.g. forced subtitle tracks). The Matroska reader will
  now queue at most 128 MB of data. Fixes #1893.
* mkvmerge: MP4 reader: the timestamps of all multiplexed tracks will now be
  0-based properly.
* mkvmerge: MP4 reader: the DTS-to-PTS offsets given by the "ctts" atoms are
  now applied for all tracks containing a "ctts" atom, not just H.264 & H.265
  tracks.

## Build system changes

* Up to and including release 9.8.0 the man pages and their translations came
  pre-built and bundled with the source code. Those pre-built files have now
  been removed and must be built during the build process. Therefore the tool
  "xsltproc" and the DocBook XSL stylesheets for man pages are now required
  dependencies. Additionally the tool "po4a" must be installed for the
  translated man pages to be built and installed, though this is optional.

  In order to facilitate finding the new requirements new options have been
  added to confiure: "--with-xsltproc=prog", "--with-docbook-xsl-root=dir",
  "--with-po4a=prog" and "--with-po4a-translate=prog.
* pugixml detection will be attempted via "pkg-config" first. If that fails,
  "configure" will fall back to the previous method of trying just to compile
  and link a test program with the standard include and library locations.
  Implements #1891.


# Version 9.8.0 "Kuglblids" 2017-01-22

## Important notes

* build system: the included version of the "drake" build tool has been
  removed. Since Ruby 2.1 rake has supported parallel builds, too. The
  MKVToolNix build system has been adjusted to enable parallel builds by
  default.

## New features and enhancements

* mkvmerge: VobSub in Matroska: mkvmerge will now create and use a default
  index for VobSub tracks read from Matroska files that are missing their
  CodecPrivate element (which normally contains said index). Implements #1854.
* GUI: added checks for several common problems with the installation. These
  checks will be executed when the GUI starts, and any problems will be
  reported to the user.
* mkvmerge: added the ISO 639-2 language codes "qaa" and "qad" (both are
  titled "reserved for local use") as both are used often in France. See #1848
  for more information.
* mkvmerge: the JSON identification result now includes a track's codec delay
  if set (only for Matroska source files). The JSON schema version has been
  bumped to 6.
* mkvmerge: MPEG TS: added a workaround for files where the subtitle packets
  are multiplexed properly, but where their timestamps are way off from the
  audio and video timestamps. Implements #1841.
* mkvmerge: added support for Digital Video Broadcasting (DVB) subtitles
  (CodecID `S_DVBSUB`). They can be read from MPEG transport streams and from
  Matroska files. Implements #1843.

## Bug fixes

* mkvmerge: MP4 reader: when an MP4 file contained fewer entries for
  timestamps than frames (which they never should), mkvmerge would use 0 as
  the timestamp for all the other frames. This resulted in effects such as the
  last frame of an output file having a timestamp of 0 and in split files
  having a much longer duration than they should have. Fixes #1847.
* GUI: the cache cleanup process that's run automatically when the GUI starts
  no longer blocks file identification until it is finished. Additionally the
  process will only be run once per release of MKVToolNix. Fixes #1860.
* GUI: certain failures during file identification that can be traced to
  broken installations (e.g. mkvmerge being too old) won't be stored in the
  cache anymore. Without this fix the GUI would still use the cached failed
  identification result even though the underlying might have already been
  fixed.
* mkvmerge: fixed that the error message "not enough space on disk" was shown
  twice on some operating systems. Fixes #1850.
* mkvmerge, Matroska: if a codec delay is set for a track in the input file,
  it is kept. Fixes #1849.
* GUI: multiplexer: changing default values in the preferences (e.g. the
  default track language to set) did not affect files whose identification
  results had already been cached.
* mkvmerge, MP4: fixed detection of MP3 audio when the object type ID in the
  ESDS signals MP2 and the track headers have invalid values for number of
  channels or sampling frequency. Fixes #1844.

## Build system changes

* nlohman json-cpp: configure now looks for a system-wide installed version of
  the nlohmann json-cpp header-only library. If one is found, it is used;
  otherwise the included version will be used. Implements #1858.
* If MKVToolNix is built with rake v10.0.0 or newer, its "multitask" feature
  will be turned on allowing automatic parallel builds.
* CURL is no longer used by MKVToolNix and is therefore not required
  for building anymore.

## Other changes

* GUI: the update check now uses Qt's networking classes instead of CURL.
* The command line option "--check-for-updates" has been removed, even
  though the deprecation warning in release 9.7.0 stated that it would
  be removed in 2018.


# Version 9.7.1 "Pandemonium" 2016-12-27

## Bug fixes

* MKVToolNix GUI: multiplex tool bug fix: under certain circumstances the GUI was
  creating invalid JSON files when starting to multiplex resulting in an error
  message ("JSON option files must contain a JSON array consisting solely of JSON
  strings").


# Version 9.7.0 "Numbers" 2016-12-27

## Important notes

* Deprecation warning: Several options and features are now deprecated and will be
  removed at the start of 2018. These are: - mkvmerge: the options
  "--identify-verbose", "--identify-for-gui", "--identify-for-mmg" and
  "--identification-format verbose". Please convert existing users of these
  interfaces to use mkvmerge's JSON identification output which can be invoked with
  "--identification-format json --identify …". - all command line tools: the old,
  proprietary format used for option files. Please convert users of this interface to
  the new JSON option file format introduced in this release. - all command line tools:
  the option "--check-for-updates" (the GUI will keep its online check for updates,
  though). There is and will be no equivalent interface in the tools themselves. Users
  of this interface can switch to retrieving the information about available updates
  directly from the MKVToolNix website. The information is available as JSON and XML
  files at the following URLs:
  https://mkvtoolnix.download/latest-release.json.gz
  https://mkvtoolnix.download/latest-release.xml.gz

## New features and enhancements

* mkvmerge: enhancement: added a new track property in JSON/verbose identification
  mode called "multiplexed_tracks". It's an array of track IDs that describe which of
  the tracks mkvmerge reports as separate ones were originally part of the same source
  track (e.g. TrueHD+AC-3 in a single track in MPEG transport streams). Implements
  #1835.
* mkvmerge: added support for skipping APE(v2) tags in TTA files.
* mkvextract: enhancement: added support for reporting progress in --gui-mode the
  same way mkvmerge does.
* all: new feature: all command line tools can now read JSON-formatted option files.
  Such a file's name must have an extension of ".json" (e.g. "mkvmerge
  @options.json"). Its content must be a valid JSON array consisting solely of JSON
  strings.
* MKVToolNix GUI: header editor & job output enhancement: added menu entries for
  saving or closing all open tabs.
* MKVToolNix GUI: chapter editor enhancement: added menu entries for saving or
  closing all open tabs.
* mkvmerge: MPEG TS/MPLS reader improvements: added support for subtitle tracks
  that are referenced from the MPLS file as sub-paths in other M2TS files than the main
  tracks.
* MKVToolNix GUI: multiplexer enhancement: the file identification process has
  been re-written to be properly multi-threaded. This allows the user to continue
  working with the GUI while e.g. playlists from a Blu-ray are identified.
* mkvmerge: enhancement: mkvmerge can now handle Blu-ray playlists from the
  "BACKUP" sub-directory of a Blu-ray disc.
* MKVToolNix GUI: new multiplexer feature: added a menu entry for copying the title to
  the destination file name. It will replace the destination file's base name but keep
  its path & extension.
* MKVToolNix GUI: new multiplexer feature: all positive file identification
  results will now be cached between runs. This speeds up adding the same file a lot,
  especially when scanning the same Blu-ray playlists again. Cached results are
  invalidated automatically with newer MKVToolNix releases or when the source file
  changes.
* MKVToolNix GUI: multiplexer enhancement: when the user tries to add one of the main
  Blu-ray index files (index.bdmv, MovieObject.bdmv) the GUI will automatically
  scan the Blu-ray playlist files and offer them for selection.
* MKVToolNix GUI: multiplexer enhancement: tracks, chapters, tags, attachments
  not selected for multiplexing will be displayed the same way as other disabled
  controls. Implements #1819.

## Bug fixes

* mkvmerge: bug fix: when using --track-order without specifying all tracks, the
  track numbers could end up in a way the user did not expect. Now mkvmerge will always
  assign track numbers for those tracks that are listed in --track-order first. The
  other tracks are assigned numbers afterwards. Fixes the second part of #1832.
* mkvmerge: bug fix: when reading Matroska files the movie title was always taken from
  the first Matroska source file, even if that file didn't have a title set. Fixes one
  part of #1832.
* MKVToolNix GUI: re-worked the startup code not to use lock files when trying to open a
  socket for communicating with an already-running instance. This aims to prevent
  situations with stale lock files not being cleaned up and the GUI not starting
  anymore as a result. This might fix or prevent issues like #1805.
* mkvmerge: teletext subtitle bug fix: fixed the handling of DVB teletext subtitles
  signaled with data unit ID 0x02 and that contain pages from multiple magazines.
* mkvmerge: bug fix: files smaller than 4 bytes were wrongly identified as MPEG
  transport streams.
* mkvmerge: bug fix: the MPEG transport stream reader was using an outdated format for
  the "CodecPrivate" element for HDMV TextST subtitles. This has been updated to the
  current format which only contains the "dialog style element". Existing Matroska
  files using this outdated scheme can be fixed by running them through mkvmerge
  v9.6.0 itself or any later release as the old format is automatically converted to
  the new one when it is read from Matroska files.

## Build system changes

* build system: building the GUI components of MKVToolNix now requires Qt v5.3.0 or
  newer.
* build system: MKVToolNix now requires a compiler that supports the following
  features of the C++14 standard: "std::make_unique()", "digit separators",
  "binary literals" and "generic lambdas". For the GNU Compiler Collection (gcc)
  this means v4.9.x or newer; for clang it means v3.4 or newer.


# Version 9.6.0 "Slave To Your Mind" 2016-11-29

## New features and enhancements

* mkvmerge & mkvextract: added support for HDMV TextST subtitles.
* MKVToolNix GUI: multiplexer enhancement: added a column "source file's
  directory" to the track list. Implements #1809.
* MKVToolNix GUI: multiplexer enhancement: added an option for selecting all tracks
  of the currently selected source files in the source file context menu. Inspired by
  #1809.
* MKVToolNix GUI: new feature: added options in the preferences to only show the list
  of often used languages/country codes/character sets in their respective
  selections instead of both the often used and the full list. Implements #1796.

## Bug fixes

* mkvextract: VobSub bug fix: mkvextract will add a "langidx" line to the .idx file
  upon extraction. Fixes #1810.
* MKVToolNix GUI: job output tool bug fix: the button for acknowledging warnings &
  errors wasn't properly disabled when the user used outside methods of
  acknowledging them (e.g. via the menu or via the job queue). Fixes #1802.
* mkvmerge: MPLS parser bug fix: fixed reading the "in" & "out" timestamps for "play
  items". This bug resulted in mkvmerge not reading the correct range from the
  referenced M2TS file under certain rare circumstances.
* mkvmerge: bug fix: mkvmerge was entering endless loops under certain conditions
  when appending files. This was a regression introduced with the fix to #1774 (using
  very large --sync values causing mkvmerge to abort).


# Version 9.5.0 "Quiet Fire" 2016-10-16

## New features and enhancements

* mkvmerge, mkvpropedit, MKVToolNix GUI: added support for the "field order" video
  track header element.
* mkvinfo: added support for the "field order" video track header element. Patch by
  James Almer (see AUTHORS).
* MKVToolNix GUI: merge tool enhancement: added menu entries that execute the
  "close", "save settings", "start muxing" or "add to job queue" action for all
  currently open tabs.
* MKVToolNix GUI: merge tool enhancement: when dragging & dropping directories the
  GUI will process all files within those directories recursively instead.
* mkvpropedit, MKVToolNix GUI's header editor: added options to modify the "muxing
  application" and "writing application" elements in the "segment information"
  container. Implements #1788.

## Bug fixes

* mkvmerge, mkvextract: VobSub handling bug fix: mkvmerge and mkvextract will now
  update the duration stored in the SPU bitsream with the duration from the container
  level if it differs at least 1ms. Fixes #1771.
* mkvmerge: H.264 elementary stream handling bug fix: if mkvmerge ever encounters
  changing SPS or PPS NALUs (ones where their ID has been encountered before with
  different settings) in the H.264 then it will prepend all following key frames with
  all currently active SPS and PPS NALUs. This enables playback from arbitrary key
  frames even if they require other SPS or PPS settings than the ones stored in the AVCC
  in CodecPrivate. Fixes #1711.
* mkvmerge: MPEG transport stream reader bug fix: fixed the handling of Blu-ray PCM
  audio with an odd number of channels by removing their alignment bytes.
* mkvmerge: MPEG transport stream reader bug fix: fixed mis-detection of certain
  H.264 files as MPEG transport streams.
* mkvmerge: WAV reader bug fix: the track properties (channels, sample rate) for DTS
  and AC-3 in WAV will now be derived from the decoded bitstream headers instead of the
  WAV file header as the latter is often incorrect.
* mkvmerge: WAV reader bug fix: fixed detection and merging of DTS in WAV that uses the
  14-bytes-in-16-bytes packing method.
* mkvmerge: bug fix: The Ogg/OGM reader did not recognize Opus files with comment
  headers anymore. This was broken by the fix to not require Ogg/OGM files to have
  comment headers in v9.4.0.


# Version 9.4.2 "So High" 2016-09-11

## Bug fixes

* mkvmerge: bug fix: AVC & HEVC readers: release v9.4.1 contains a change to both
  readers so that they will refuse to handle files where the detected pixel width or
  height is equal to or less than 0. This check was wrong in certain cases causing
  mkvmerge to reject a file as an unsupported file type. This has been fixed while
  keeping the constraints on width & height having to be positive.


# Version 9.4.1 "Black Rain" 2016-09-11

## Important notes

* Note: most of the bugs fixed on 2016-09-06 and 2016-09-07 for issue #1780 are
  potentially exploitable. The scenario is arbitrary code execution with
  specially-crafted files. Updating is highly recommended.

## Bug fixes

* mkvmerge: bug fix: AVC & HEVC readers: the readers will now refuse to handle files
  where the detected pixel width or height is equal to or less than 0. Before this fix the
  muxing process aborted with an assertion inside libMatroska. Fixes the last test
  case of #1780.
* mkvmerge: bug fix: HEVC parser: fixed another invalid memory access (beyond the end
  of allocated space). Fixes two test cases of #1780.
* mkvmerge: bug fix: HEVC parser: fixed another invalid memory access (beyond the end
  of a fixed-size array). Fixes several test cases of #1780.
* mkvmerge: bug fix: MP4 reader: an error message will be printed instead of an
  uncaught exception when an invalid atom chunk size is encountered during resync.
  Fixes a test case of #1780.
* mkvmerge: bug fix: AAC reader: fixed mkvmerge throwing an uncaught exception due to
  the sample rate being 0. Fixes a test case of #1780.
* mkvmerge: bug fix: MP4 reader: fixed an invalid memory access (beyond the end of
  allocated space). Fixes several test cases of #1780.
* mkvmerge: bug fix: HEVC parser: fixed an invalid memory access (beyond the end of
  allocated space). Fixes several test cases of #1780.
* mkvmerge: bug fix: fixed an invalid memory access (use after free) during global
  destruction phase. Fixes several test cases of #1780.
* mkvmerge: bug fix: using very large --sync values (several minutes) with certain
  container formats was causing mkvmerge to abort muxing. Fixes #1774.


# Version 9.4.0 "Knurl" 2016-08-22

## New features and enhancements

* mkvmerge: new feature: added support for reading Apple ProRes video from MOV/MP4
  files. Patch by Chao Chen (see AUTHORS).
* MKVToolNix GUI: merge tool enhancement: when adding attachments the GUI will check
  if there are attachments or attached files with the same name as the file to add. If so
  the GUI will tell the user and ask for confirmation.
* mkvmerge: enhancement: mkvmerge now accepts file names in square brackets for
  appending files, e.g. "mvkmerge -o out.mkv [ in1.avi in2.avi in3.avi ]" instead of
  "mkvmerge -o out.mkv in1.avi + in2.avi + in3.avi".
* MKVToolNix GUI: merge tool enhancement: the "select a play list to add" dialog does
  now contain a column with the number of chapters for each play list found.
* MKVToolNix GUI: job queue enhancement: dragging & dropping a valid .mtxcfg file
  (either a full job file or one containing only merge settings without the job
  properties) onto the job queue window will import the dropped .mtxcfg job into the
  job queue. Rest of the implementation of #1714.
* MKVToolNix GUI: merge tool enhancement: dragging & dropping a job queue .mtxcfg
  file onto the merge tool or using one as a command line parameter to the
  mkvtoolnix-gui executable will import the .mtxcfg job into the job queue. Part of
  the implementation of #1714.
* MKVToolNix GUI: merge tool enhancement: toggling the WebM mode check box will
  update the output file name's extension automatically.

## Bug fixes

* mkvpropedit: bug fix: mkvpropedit will no longer say that it's writing the changes
  if only attachment changes are specified and none of the specified attachments can
  be found.
* MKVToolNix GUI: chapter editor bug fix: overly long chapter names don't cause the
  GUI's window to become overly wide anymore. Fixes #1760.
* mkvmerge: DTS bug fix: if present mkvmerge will use an XLL extension's sample rate
  information as the sample rate to put into the track headers. Fixes #1762.
* mkvmerge: bug fix: when appending files mkvmerge wasn't starting clusters on video
  key frame anymore for the first and all following appended files. Fixes #1757.
* mkvmerge: bug fix: VP8 in Ogg: fixed dropping the first frame and the timestamp
  calculation. Fixes #1754.
* mkvmerge: bug fix: mkvmerge does no longer emit a warning if no comment header packet
  is found when reading tracks from Ogg/OGM files. See #1754.
* MKVToolNix GUI: merge tool bug fix: the automatic adjustments to the output file
  name based on the track types selected for muxing and the mechanism for keeping
  output file names unique had been broken since release v9.3.0. Fixes #1743.


# Version 9.3.1 "Mask Machine" 2016-07-14

## Bug fixes

* MKVToolNix GUI: merge tool bug fix: the GUI v9.3.0 was often creating an invalid
  syntax for the --probe-range-percentage parameter for mkvmerge due to
  uninitialized memory. Fixes #1741.


# Version 9.3.0 "Second Sight" 2016-07-13

## Important notes

* mkvmerge, mkvextract, MKVToolNix GUI: bug fix: several fixes to the handling of
  country codes. The list has been updated to reflect the currently valid top level
  domain country codes. Deprecated codes such as "gb" for "Great Britain" are now
  mapped to their updated values ("uk" for "United Kingdom" in this case). Fixes
  #1731.

## New features and enhancements

* mkvmerge, MKVToolNix GUI: new chapter generation feature: two new placeholders
  have been introduced when generating chapters for appended files, \<FILE_NAME\> and
  \<FILE_NAME_WITH_EXT\>. The former will be replaced by the appended file's name
  without its extension; the latter with its extension. Implements #1737.
* MKVToolNix GUI: merge tool enhancement: when opening a saved configuration (via
  the menu as well as via drag & drop) the current tab will be replaced if it is empty ( = in
  the same state it is in right after creating new mux settings). Implements #1738.
* mkvmerge, MKVToolNix GUI: added an option for specifying how much of a MPEG PS or TS
  file is probed for tracks (--probe-range-percentage). Implements #1734.
* mkvmerge, mkvinfo: new feature: added flags to support the Color elements in the
  video tracks of Matroska containers. Users can use those flags to specify the color
  space, transfer function, chromaticity coordinates etc. These properties are
  useful for correct color reproduction of high dynamic range / wide color gamut
  videos.
* MKVToolNix GUI: merge tool enhancement: the default track languages to set can now
  also be set whenever the language in the source file is 'undefined' ('und'). This is
  now the default and can be changed back to the old behavior (only set if the source file
  doesn't contain a language attribute) in the preferences. Implements #1697.
* MKVToolNix GUI: merge tool enhancement: menus have been added to both the "start
  muxing" and the "add to job queue" buttons. The menus let the user override the
  preferences regarding clearing merge settings after starting to mux and after
  adding a job to the queue respectively. Implements #1696.
* mkvmerge: the warning about not being able to determine whether a raw AAC file
  contains HE-AAC/AAC+/SBR has been removed. Implements #1701.
* MKVToolNix GUI: enhancement: all file names are now displayed with their native
  path separators (e.g. "C:\some\where\output.mkv" on Windows). Implements
  #1298, #1456.

## Bug fixes

* mkvmerge: bug fix: fixed overly long file type detection in some cases when text
  subtitle type probing read a lot of data due to there being no carriage returns near
  the start of the file.
* mkvmerge: WavPack4 bug fix: relaxed the stream detection criteria to only require
  the major version to be 4 and not to check the minor version. Fixes #1720.
* configure: fixed the Qt detection with Qt 5.7.0 which now requires the compiler to be
  in C++11 mode.
* mkvmerge: MP4 bug fix wrt. DTS handling: mkvmerge will re-derive parameters such as
  number of channels and sampling frequency from the DTS bitstream circumventing
  invalid values in the track headers (e.g. a channel count of 0). Fixes #1727/1728.
* mkvmerge: TrueHD bug fix: fixed detection of 96 kHz sampling frequency.
* mkvinfo's GUI: fix a crash due to wrong usage of referenced temporary objects. Fixes
  #1725.
* MKVToolNix GUI: merge tool bug fix: the GUI now takes into account whether splitting
  is activated when looking for and warning due to existing destination files. Fixes
  #1694.
* mkvmerge: bug fix: the parser for the --default-duration argument was wrongfully
  handling arguments of the form "123/456i" (only this specific syntax and only with
  "i" as the unit; other formats and units were fine). This is part of #1673.
  Additionally the parser doesn't use the "double" data type internally anymore
  fixing loss of precision and failing test cases on certain 32bit platforms. This
  fixes #1705.

## Build system changes

* build system: libEBML v1.3.4 and libMatroska v1.4.5 are now required due to several
  new elements having been specified for Matroska, and mkvmerge uses those elements.
* build system: libEBML v1.3.4 and libMatroska v1.4.5 are now required due to the
  usage of new elements introduced in libMatroska v1.4.5. The copies included in the
  MKVToolNix source code have been updated to those releases as well.

## Other changes

* mkvmerge: MPEG TS: considerable parts of the module have been rewritten. Due to its
  convoluted structure didn't buffer PES packets properly before trying to parse the
  PES header leading to invalid memory accesses in certain cases.


# Version 9.2.0 "Photograph" 2016-05-28

## New features and enhancements

* MKVToolNix GUI: merge tool enhancement: the action "select all attached files" in
  the popup menu actions for the attached files view has been split up into "enable all
  attached files" and "disable all attached files". Implements #1698.
* mkvinfo GUI: enhancement: the window title now includes the file name. Implements
  #1679.
* mkvmerge: enhancement: the "bit depth" track header field will be set for DTS tracks
  from the first DTS core header. Implements #1680.

## Bug fixes

* MKVToolNix GUI: bug fix on Windows: removing the drive letter does not cause the
  colon to be removed automatically anymore. Fixes #1692.
* MKVToolNix GUI: merge tool bug fix: it's no longer possible to select "1" as the
  maximum number of files to split into as mkvmerge doesn't accept that value. Fixes
  #1695.
* mkvmerge: bug fix: the "interval" chapter generation mode was always creating one
  chapter too many.
* mkvmerge: bug fix: if a certain number of chapters had been generated with
  --generate-chapters then mkvmerge wasn't replacing the void placerholder with
  the actual chapters. Fixes #1693.
* MKVToolNix GUI: merge tool bug fix: the track column "default track in output"
  wasn't taking into account if the track had its "default track" flag set to "no" in the
  source file. This would result in the column showing "yes" in certain situations
  even though mkvmerge would assign "no".
* mkvmerge: bug fix: fixed detection of (E-)AC-3 in MPEG TS files with unusual stream
  types (e.g. 0x87) but with (E-)AC-3 PMT descriptors. Fixes #1684.
* mkvmerge, mkvextract: bug fix: fixed handling of Big Endian PCM with a bit depth
  other than 16, 32 or 64 bits/sample. Other formats were using the Little Endian codec
  ID, but their content was actually not byte-swapped to match it. Now those other bit
  depths are byte-swapped to Little Endian, too. Fixes #1683.
* mkvmerge: bug fix: the time zone portion of the "date_local" member of the JSON and
  verbose identification formats contained the time zone's name instead of its
  offset on Windows due to the Visual C++ runtime's std::strftime not being C++11
  compliant. Additionally this resulted in errors about invalid UTF-8 strings for
  locales where the time zone's name contained non-ASCII characters.

## Other changes

* mkvinfo: the change to start the GUI by default on Windows and macOS has been
  reverted. Instead a separate executable (mkvinfo-gui) will be included for those
  platforms which starts the GUI by default. The newly introduced option "--no-gui"
  will remain valid but won't have any effect when used with mkvinfo.


# Version 9.1.0 "Little Earthquakes" 2016-04-23

## New features and enhancements

* mkvmerge: MPEG TS/teletext enhancement: included the teletext page number in the
  JSON/verbose identification output as track property "teletext_page".
* mkvmerge: MPEG TS/teletext enhancement: if a teletext track contains multiple
  teletext pages then mkvmerge will now recognize all of those pages as separate
  tracks to merge instead of only merging the first page. See #1662.
* mkvmerge: MPEG TS/teletext enhancement: mkvmerge will now ignore obviously bogus
  PTS values for teletext tracks and use PTS from earlier audio or video packets
  instead. See #1662.
* mkvmerge: MPEG TS reader enhancement: teletext tracks of type 5 (hearing impaired)
  are recognized as subtitles, too. Implements #1662.
* MKVToolNix GUI: merge tool enhancement: characters that aren't valid in path names
  are automatically removed from the output file name. Implements #1647.
* mkvextract: new feature: added support for extracting WebVTT subtitles.
  Implements the extraction part of #1592.
* mkvmerge: new feature: added support for reading WebVTT subtitles from WebVTT and
  Matroska files. Implements the merge part of #1592.
* mkvmerge: enhancement: when reading Matroska files not created by mkvmerge that
  contain chapters the existing edition UIDs and chapter UIDs are removed and random
  ones created. This is necessary as not only HandBrake but other tools assign
  sequential numbers starting at 1 for each file. Therefore there are two chapter
  entries with the UID 1, two with the UID 2 etc. and those should, strictly speaking, be
  treated as if they were a single chapter whereas the user expects those entries to
  stay separate entries.
* MKVToolNix GUI: new feature: added an option in the preferences ("Merge" →
  "Output") for controlling whether or not the GUI clears the "output file name" input
  upon removal of the last file.
* MKVToolNix GUI: new feature: added an option in the preferences ("Merge" → "Default
  values") for controlling whether or not the GUI clears the "file title" input upon
  removal of the last file.
* mkvmerge: enhancement: added the muxing date in both local time zone and UTC to
  verbose/JSON identification outputs (keys "date_local" and "date_utc",
  formatted after ISO 8601) when identifying Matroska files.
* mkvmerge: enhancement: added the minimum timestamp for each track in verbose/JSON
  identification outputs (key "minimum_timestamp") when identifying Matroska
  files. At most the first ten seconds are probed; if no block is found for a track within
  that range then the key is not output for the track. Also added "muxing_application"
  and "writing_application" to the "container" section of the output. Currently
  those are only set for Matroska files.

## Bug fixes

* mkvmerge: MPEG TS bug fix: the "text_subtitles" property of the JSON/verbose
  identification modes was always set to true for all subtitle tracks, even for those
  that aren't text subtitles (VobSub, PG).
* mkvmerge: MPEG TS/teletext bug fix: the language code signaled in the MPEG TS PMT is
  taken into account when selecting the character encoding to use during decoding of
  the teletext subtitles, not just the "national character set" stored in the
  teletext page headers. For example, a German teletext page may signal "national
  character set" 0 (English) whereas it's actually 4 (German). See #1662.
* mkvmerge: teletext decoding bug fix: fixed dropping of certain non-ASCII
  characters in rare circumstances due to wrong filtering of already UTF-8 encoded
  strings.
* MKVToolNix GUI: bug fix (Windows only): the GUI didn't start if the USERNAME
  environment variable contained characters that aren't allowed in file names (e.g.
  : or ?).
* mkvmerge: AVI reader bug fix: fixed reading files where the file ends in the middle of
  an audio chunk. Fixes #1657.
* mkvmerge: bug fix: mkvmerge will no longer abort reading a Matroska file with a
  structural error right before the first cluster. Fixes #1654.
* MKVToolNix: merge tool bug fix: when adding playlists the GUI won't ask the user
  whether or not to scan if there's only a single playlist in that directory.
* mkvmerge: bug fix: AVC/H.264: fixed handling of interlaced frames with bottom
  field first.
* MKVToolNix GUI: bug fix: fixed huge memory consumption (e.g. allocation of 2 GB for a
  JSON file of 650 KB) in the JSON library by updating said JSON library. Fixes #1631.

## Other changes

* MKVToolNix GUI: merge tool change: attachments from source files have been moved
  from the "Tracks, chapters, tags and attachments" list on the "sources" tab to a new
  list on the "attachments" tab. That way all existing attachments and all the ones to
  newly add will be shown in a single tab. This makes it easier to decide which
  attachments will have to be added and which can be removed.


# Version 9.0.1 "Obstacles" 2016-03-28

## Bug fixes

* mkvmerge: bug fix: regression in v9.0.0: the text subtitle packetizer was
  wrongfully assuming an encoding of UTF-8 if none was given instead of assuming the
  system's encoding. Fixes #1639.
* mkvmerge: bug fix: if too many chapters had been generated with
  --generate-chapters then mkvmerge created a bogus entry in the meta seek element
  and did not actually write the chapters to the file.
* mkvmerge: bug fix: the DTS packetizer was setting the number of channels wrong
  sometimes when reducing to the DTS core. It was using the number of channels
  including the extensions instead of the channels of the core only.


# Version 9.0.0 "Power to progress" 2016-03-26

## New features and enhancements

* all: new feature: added a new translation of both the programs and the man pages to
  Korean by Potato (see AUTHORS).
* MKVToolNix GUI: chapter editor enhancement: added a button next to the 'segment
  UID' controls that enable the user to select a Matroska file. The GUI reads that
  file's segment UID and enters its value into the input field.
* mkvinfo: change: on Windows and macOS mkvinfo will now launch the GUI by default
  unless the option »--no-gui« (or »-G«) has been given. This is due to the fact that on
  both OS users often use portable versions respectively disk images and launch the
  executable directly and not via start menu entries. In those situations adding
  command line options for launching the GUI is unnecessarily difficult.
* MKVToolNix GUI: merge tool (playlist selection dialog) enhancement: the playlist
  items are sorted by their position within the playlist by default.
* MKVToolNix GUI: merge tool (playlist selection dialog) enhancement:
  double-clicking on a playlist will select and add that playlist.
* mkvmerge: enhancement: added the number of bits per sample to the verbose/JSON
  identification output for FLAC files.
* mkvextract: new feature: implemented the extraction of Big Endian PCM (codec ID
  A_PCM/INT/BIG) to WAV files. The content will be byte-swapped into Little Endian
  PCM in the process.
* mkvmerge: enhancement: Big Endian PCM tracks will now be byte-swapped into Little
  Endian PCM, and the codec ID A_PCM/INT/LIT will be used. This was done due to a lot of
  players not supporting Big Endian PCM inside Matroska.
* MKVToolNix GUI: job queue enhancement: completed jobs will now be removed from the
  queue automatically on exit if the job has been added more than 14 days ago in order not
  to let the queue grow arbitrarily large. This feature can be turned off and the number
  of days can be adjusted in the preferences.
* mkvextract: enhancement: when extracting chapters in the simple format the user
  can use the new option »--simple-language …« for selecting the chapter names that
  are output. Normally the first chapter name found in each atom is used. With this
  option mkvextract looks for a chapter name whose language matches the specified
  one. Implements the feature enhancement part of #1610.
* MKVToolNix GUI: new chapter editor feature: added an option to multiply all chapter
  timecodes by a factor to the "additional modifications" dialog. Implements #1609.

## Bug fixes

* Installer: fixed support for silent installation and uninstallation.
* mkvmerge: bug fix: fixed two more issues in the conversion of teletext subtitles to
  SRT subtitles: 1. Packets belonging to pages that don't contain subtitles were used
  as valid end points for subtitles causing entries to become very short (e.g. 40ms).
  2. Sometimes the timestamps of wrong packets were used as entry's start and end
  points causing start timestamps and durations that were slightly off. Second part
  of the fix for #1623.
* mkvmerge: bug fix: MP4/QuickTime reader: audio tracks can contain two instances of
  certain header fields (channel count, bits/sample & channel, sample rate) in the
  STSD atom: one instance in the version 0 header and one in the version 2 header parts.
  So far mkvmerge has used those from the version 0 header only and ignored the ones from
  the version 2 header. This has been changed to match the behavior of other players and
  MP4 readers like ffmpeg. If the STSD atom contains a version 2 structure then the
  fields from it will be used. Otherwise the fields from the version 0 part will be used.
  Fixes #1633.
* mkvmerge: bug fix: fixed two issues in the conversion of teletext subtitles to SRT
  subtitles: 1. Consecutive teletext packets with the same content are now merged
  into a single entry instead of resulting in multiple entries. 2. The calculation of a
  packet's duration was wrong in certain situations. Part of the fix for #1623.
* mkvextract: bug fix: fixed the duplication of VPS, SPS, PPS and SEI NALUs when
  extracting HEVC/H.265 tracks. See #1076 and #1621.
* mkvmerge: bug fix: reverted the patch by Vladimír Pilný that made the HEVC/H.265 not
  store SEI NALUs with the frames during muxing. It was supposed to prevent having the
  SEI NALUs present twice when extracting HEVC due to some SEI information also being
  stored in the codec private data, but it dropped a lot of other SEI NALUs irrevocably.
  Fixes #1621.
* mkvmerge: bug fix: the --sub-charset option is now ignored for text subtitle files
  that start with a byte-order mark (BOM) bringing the behavior in line with the
  documentation. Fixes #1620.
* mkvmerge, MKVToolNix GUI: new feature: added switches (»--generate-chapters«
  and »--generate-chapter-name-template«) and their corresponding UI items for
  generating chapters while muxing. Two modes are currently supported:
  »when-appending« which creates one chapter at the beginning and an additional one
  each time a file is appended and »interval:…« which generates chapters in fixed
  intervals. Implements mkvmerge's and the GUI's part of #1586.
* mkvpropedit, MKVToolNix GUI's header editor: bug fix: fixed the handling of files
  where the last level 1 element has an unknown size. The programs will now either fix
  this element to have a known size or abort the process with an appropriate error
  message but without modifying the file. Fixes #1601.
* mkvextract: several issues regarding the extraction of chapters in the simple
  format have been fixed: if multiple names with different languages were present
  then an entry had been written for each name; the total number of entries written was
  wrong; the wrong entries were written. The new code only writes the first name found
  from the top-most chapter atoms of all editions. Chapters flagged as hidden or as not
  enabled are not extracted at all. Fixes the bug part of #1610.

## Build system changes

* build system: implemented support for explicit pre-compiled headers for Linux and
  macOS.
* build system: added an option to configure »--without-qt-pkg-config«. Normally
  configure uses pkg-config for detecting Qt and setting QT_CFLAGS and QT_LIBS. With
  this option configure won't use pkg-config and rely on the user having set both
  variables before running configure. This enables using Qt on systems where no
  pkg-config files are generated (e.g. Qt 5.6.0 on MacOS with frameworks enabled).

## Other changes

* mkvmerge: MP4/QuickTime reader: audio tracks with the FourCC 'lpcm' are muxed as
  A_PCM/INT/LIT instead of A_QUICKTIME.


# Version 8.9.0 "Father Daughter" 2016-02-21

## New features and enhancements

* MKVToolNix GUI: header editor enhancement: when the user drags & drops files on an
  open header editor tab the GUI will ask the user what to do with them: either open the
  files as new header editor tabs or add the files as new attachments to the current tab.
  The action can also be set as the default. Implements #1585.
* MKVToolNix GUI: chapter & header editor enhancement: Matroska files are initially
  opened in read-only mode and only later re-opened in read/write mode in order to
  enable reading from write-protected files. Part of the implementation of #1594.
* MKVToolNix GUI: chapter & header enhancement: the error messages shown when a
  Matroska file could not be parsed have been improved to include the most likely
  reasons. Part of the implementation of #1594.
* MKVToolNix GUI: chapter editor enhancement: added a menu entry for removing
  chapters from an existing Matroska file. Inspired by #1593.
* MKVToolNix GUI: chapter editor enhancement: it is now possible to save chapters to
  Matroska files after having removed all entries (editions and chapter atoms). This
  effectively removes the chapters from the file. Implements #1593.
* MKVToolNix GUI: job queue enhancement: added keyboard shortcuts for removing all
  completed jobs and for removing successfully completed jobs. Implements #1599.
* MKVToolNix GUI: merge tool enhancement: added icons to the context menu actions in
  the "attachments" sub-tab. Implements #1596.
* MKVToolNix GUI: merge tool enhancement: made the context menu entries in the
  "attachments" sub-tab clearer. Implements #1597.
* docs: added a Polish translation of the man pages by Daniel Kluz (see AUTHORS).
* MKVToolNix GUI: "run program after XYZ" enhancement: configurations can now be
  deactivated without having to change them. Implements #1581.
* mkvmerge: enhancement: when reading Matroska files created by HandBrake that
  contain chapters the existing edition UIDs and chapter UIDs are removed and random
  ones created. This is necessary as HandBrake assigns sequential numbers starting
  at 1 for each file. Therefore there are two chapter entries with the UID 1, two with the
  UID 2 etc. and those should, strictly speaking, be treated as if they were a single
  chapter whereas the user expects those entries to stay separate entries.
  Implements an improvement for issues such as #1561.
* MKVToolNix GUI: enhancement: the "escape for Windows' cmd.exe" mechanism will
  only escape arguments that actually need escaping in order to produce easier to read
  command lines.

## Bug fixes

* MKVToolNix GUI: bug fix: ampersands (&) in file names were shown as keyboard
  shortcuts in tab titles in various tools (merge tool, chapter and header editors,
  job output tool). Fixes #1603.
* mkvmerge: bug fix: fixed the handling of AVIs with a negative video height (which
  signals that the rows are arranged top-to-bottom).
* MKVToolNix GUI: job queue bug fix: fixed an invalid memory access in the "edit in
  corresponding tool and remove from queue" functionality.
* MKVToolNix GUI: re-write, merge tool bug fix: the file identification is now based
  on mkvmerge's JSON output instead of its verbose output. This also fixes the merge
  tool not showing names of attachments inside Matroska files properly if those names
  contain spaces (#1583).
* MKVToolNix GUI: merge tool bug fix: the "mux this" combo box was disabled if a single
  attachment was selected.
* mkvmerge: bug fix: removed spurious output generated during file identification
  in the HEVC detection code (e.g. "Error No Error").
* mkvmerge: bug fix: fixed the output of the "playlist_file" and "other_file"
  properties of the "container" entity in the JSON identification format from a
  single string to an array of strings. The format version has been bumped to 3 due to
  this change.
* mkvmerge: bug fix: fixed parsing of AAC in MP4 with a program config element with an
  empty comment field at the end of the GA specific config. Fixes #1578.
* MKVToolNix GUI: merge tool bug fix: the GUI no longer requires at least one source
  file to be present before muxing can start in order to allow creation of track-less
  files. Fixes #1576.
* mkvmerge: QuickTime/MP4 reader: fix a division by zero in the index generation for
  certain old audio codecs that have certain header fields (bytes_per_frame,
  samples_per_packet) set to 0.
* mkvinfo: bug fix: global elements (EBML void and CRC-32 elements) are now handled
  correctly if they're located inside the segment info or the chapter translate
  parents.

## Other changes

* MKVToolNix GUI: the default font size adjustment has been deactivated for the time
  being as it causes problems on high DPI displays. See #1602.


# Version 8.8.0 "Wind at my back" 2016-01-10

## New features and enhancements

* MKVToolNix GUI: "run program after XYZ" enhancement: added a button for executing
  the program right now as a test run. See #1570.
* MKVToolNix GUI: "run program after XYZ" enhancement: an error message is shown if
  the program couldn't be executed. See #1570.
* MKVToolNix GUI: "run program after XYZ" enhancement: any leading spaces in the
  executable path are removed in order to make copying & pasting less error-prone.
* mkvpropedit: enhancement: mkvpropedit will accept terminology variants of ISO
  639-2 language codes and convert them to the bibliographic variants
  automatically. Implements #1565.
* MKVToolNix GUI: enhancement: the GUI's default font's size is now scaled with the
  screen's DPI and is at least 9 points high (up from 8). Additionally on Windows "Segoe
  UI", which is Windows' default user interface font, is used instead of the default
  provided by Qt, "MS Shell Dlg 2".
* MKVToolNix GUI: enhancement: the user can select the font family and size for the GUI
  in the preferences.
* MKVToolNix GUI: merge tool enhancement: added a column to the "attachments" tab
  containing the file size.
* MKVToolNix GUI: enhancement: pressing the insert key when the focus is on the merge
  tool's source files or attachments list, on the chapter editor's chapter list or on
  the header editor's list will invoke the corresponding action for adding elements
  to that list.
* MKVToolNix GUI: new feature: implemented adding, changing and removing
  attachments in existing Matroska files as part of the header editor. Implements
  #1533.

## Bug fixes

* MKVToolNix GUI: "run program after XYZ" bug fix: the paths used in the variables and
  the executable are converted to the platforms native path separators. This fixes
  compatibility with Windows applications that don't support the use of forward
  slashes in path names like e.g. VLC. See #1570.
* mkvmerge: bug fix: fixed TrueHD detection both as raw streams as well as inside other
  contains if the stream does not start with a TrueHD sync frame.
* MKVToolNix GUI: new merge tool feature: added a layout for the track properties
  where they're on the right of the files/tracks lists in two fixed columns.
  Implements #1526.
* mkvmerge: bug fix: fixed a mis-detection of an MPEG-2 video elementary stream as a
  TrueHD file which then caused a segmentation fault. Fixes #1559.
* mkvmerge: bug fix: Matroska attachments with the same name, size and MIME type were
  not output during file identification.
* MKVToolNix GUI: merge tool bug fix: when using one of the "select all tracks (of
  type…)" actions the "properties" column didn't show the selection.


# Version 8.7.0 "All of the above" 2015-12-31

## New features and enhancements

* mkvmerge: enhancement: the MP4 reader will keep the display dimensions from the
  track header atom ("tkhd") and use them as the display width & height. See also #1547.
* MKVToolNix GUI: merge tool enhancement: the "add source files" button now has
  optional popup menu containing actions for adding/appending files and adding
  files as additional parts for easier discovery of those actions. This popup is only
  shown if the user clicks on the arrow shown on the right of the button.
* mkvmerge: new feature: TrueHD tracks that contain Dolby Atmos will be identified as
  "TrueHD Atmos". Implements #1519.
* MKVToolNix GUI: new merge tool feature: added menu options in the "Merge" menu for
  copying either the first source file's name or the current output file's name into
  the "file title" control.
* mkvpropedit: new feature: added an option for calculating statistics for all
  tracks and adding new/updating existing statistics tags in a file. Second half of
  the implementation of #1507.
* mkvpropedit: new feature: added an option for removing all existing track
  statistics tags from a file. Part of the implementation of #1507.
* mkvmerge: enhancement: added the container's internal track ID as the "number"
  attribute in verbose & JSON identification modes for several container types
  (QuickTime/MP4: the track ID from the 'tkhd' atom; MPEG program stream: the
  sub-stream ID in the upper 32 bits and the stream ID in the lower 32 bits; MPEG
  transport stream: the program ID; Ogg/OGM: the stream's serial number field;
  RealMedia: the track ID). Implements #1541.
* mkvmerge: enhancement: if JSON identification mode is active then warnings and
  errors will be output as JSON as well. They're output as arrays of strings as the keys
  "warnings" and "errors" of the main JSON object. Implements #1537.
* mkvpropedit: enhancement: when using --add-attachment, --replace-attachment
  or --update-attachment the UID can be changed with --attachment-uid. See #1532.
* mkvpropedit: new feature: added an option "--update-attachment" for updating the
  properties of existing attachments without replacing their content. Implements
  #1532.
* MKVToolNix GUI: new feature: added options for running arbitrary programs after a
  job has finished or after the queue has finished. Implements #1406.
* MKVToolNix GUI: merge tool enhancement: if files are dragged & dropped from an
  external application with the right mouse button being pressed then the GUI will
  always ask the user what to do with the files even if the user has configured the GUI not
  to ask. Implements #1508.

## Bug fixes

* mkvmerge: bug fix: fixed the handling of a PES size of 0 ( = unknown). Tracks whose PES
  packets had such a size were sometimes not detected at all, and even if they were their
  content was incomplete. Fixes #1553.
* mkvmerge: bug fix: made the MPEG 1/2 video elementary stream file type recognition
  more resilient and more flexible dropping the requirement for a file to start with an
  MPEG start code (0x00 00 01). Fixes #1462.
* mkvpropedit: bug fix: when changing the track language it is now verified to be a
  valid ISO 639-2 language code before writing it to the file. Fixes #1550.
* mkvmerge: bug fix: the Matroska reader now uses TrueHD-specific code when reading
  Matroska files. This can fix things like wrong frame type flags.
* mkvmerge: bug fix: MP4 edit lists of certain types (two entries, first entry's
  media_time is -1, second entry's segment_duration is != 0) weren't handled
  properly resulting in key frame flags being assigned to the wrong frames. Fixes
  #1547.
* mkvmerge: bug fix: the HEVC/H.265 code was writing SEI NALUs twice. This had already
  been mentioned in #1076 but never fixed. Patch by Vladimír Pilný.
* mkvmerge: bug fix: the HEVC/H.265 code wasn't converting slice NALUs to RBSP form
  before parsing it resulting in wrongly timestamped frames under certain
  conditions. This is a similar fix to the issues reported in #918 and #1548.
* mkvmerge: bug fix: the AVC/H.264 code wasn't converting slice NALUs to RBSP form
  before parsing it resulting in wrongly timestamped frames under certain
  conditions. Fixes #918 and #1548.
* mkvmerge: bug fix: the MP4 reader can now understand the 'random access point'
  sample grouping information for marking open GOP random access points as key
  frames. Fixes #1543.
* mkvmerge: bug fix: fixed the decisions whether or not to write the last frame of a
  track as a BlockGroup or a SimpleBlock and whether or not to write a block duration for
  that frame. Fixes #1545.
* mkvmerge: bug fix: the progress calculation was sometimes outputting negative
  numbers when appending Matroska files whose timestamps don't start at 0 (e.g. if
  they were created by splitting with linking enabled). In the the GUI this resulted in
  lines like "#GUI#progress -2%" in the job's output.
* mkvmerge: bug fix: AAC with low sampling frequencies was sometimes mis-detected
  with the wrong profile preventing appending it to other AAC tracks. Fixes #1540.
* mkvmerge: bug fix: chapters were output as both "chapters" and "track_tags" in JSON
  identification mode. Fixes #1538.
* MKVToolNix GUI: bug fix: the "split mode" drop-down box got reset to "do not split"
  each time the preferences dialog was closed with the "OK" button. Fixes #1539.
* MKVToolNix GUI: enhancement: when starting the GUI with a saved settings file then
  the GUI won't contain an empty tab in the merge tool anymore. Fixes #1504.
* mkvmerge: bug fix: fixed the key frame detection for VP9 video tracks.
* MKVToolNix GUI: bug fix: relative file names given on the command line were
  interpreted as being relative to the user's home directory. Fixes #1534.

## Other changes

* all: reversion of a change: several ISO 639-2 codes of languages that are very old and
  not spoken anymore have been re-added (e.g. "English, Middle (1100-1500)") due to
  feedback from users who did have a use for such codes.
* all: reversion of a change: all of the tools will write a byte-order mark (BOM) to text
  files encoded any of the UTF-* schemes again. This reverts the change in release
  8.6.0 due to user feedback preferring the old way.
* MKVToolNix GUI: the preferences dialog has been reworked heavily in order to
  provide a better overview and to be less overwhelming.


# Version 8.6.1 "Flying" 2015-11-29

## Bug fixes

* mkvpropedit, GUI's chapter & header editors bug fix: in certain situations the
  modified file would not contain a seek head before the first cluster anymore
  resulting in most players not finding elements such as attachments or the index
  located at the end of the file anymore. Fixes #1513.
* mkvmerge: bug fix: the change to do a deeper file analysis if no seek head was found was
  causing huge increases in file type detection time as popular tools like x264 don't
  write seek heads. The way elements at the end are searched has been changed to only
  scan the last 5 MB of the file instead of iterating over every level 1 element from the
  beginning of the file.


# Version 8.6.0 "A Place In Your World" 2015-11-28

## New features and enhancements

* mkvmerge: enhancement: if no seek head is found before the first cluster when
  reading Matroska files then mkvmerge will attempt a deeper scan of all elements in
  the file in order to find track headers, attachments, chapters and tags located at
  the end of the file. See #1513 for the rationale.
* mkvmerge: enhancement: added JSON as an output format for file type
  identification. It can be activated with "--identification-format json
  --identify yourfile.ext" (or their short counterparts "-F json -i
  yourfile.ext").

## Bug fixes

* mkvmerge: Matroska reader bug fix: the info about which packetizer is used was
  output twice for each HEVC track. Fixes #1522.
* MKVToolNix GUI: bug fix: implemented a workaround for a bug in Qt which caused the GUI
  not to start anymore due to failing to detect a stale lock file if the GUI had crashed
  before on a computer with a host name that included non-ASCII characters. See
  https://bugreports.qt.io/browse/QTBUG-49640
* mkvmerge: bug fix: a track's number of bits per audio sample wasn't output in verbose
  identification mode even if it was present in the file.
* MKVToolNix GUI: header editor bug fix: the "status" description wasn't adjusting
  its height properly resulting in its text being cut off. Fixes #1517.
* MKVToolNix GUI: bug fix: the program changes its working directory to the user's
  profile/home directory on startup allowing the removal of its installation folder
  even if a program started by the GUI (e.g. a web browser) is still running. Fixes
  #1518.
* ebml_validator: bug fix: elements with an unknown size weren't handled correctly.
* build system: fixed building and linking against libEBML and libMatroska if
  they're installed in a non-standard location.
* mkvpropedit, MKVToolNix GUI's chapter and header editors: the tools were unable to
  update elements in files without a seek head present. Fixes #1516.
* mkvmerge: bug fix: fixed two issues causing mkvmerge to write invalid data when
  updating track headers caused by the fix for "Re-rendering track headers:
  data_size != 0 not implemented yet". Fixes #1498.
* MKVToolNix GUI: bug fix: the options for linking to the next/previous segment UID
  were wrong. Fixes #1511.
* mkvmerge: bug fix: the VC-1 handlig code was duplicating the first sequence headers
  with each mux. Fixes #1503.
* build system: bug fix: configure was checking for and using libintl if
  --without-gettext was used. Fixes #1501.

## Other changes

* all: change: none of the tools will write a byte-order mark (BOM) to text files
  encoded any of the UTF-* schemes anymore.
* all: MKVToolNix now requires gcc 4.8.0 or later or clang 3.4 or later for
  compilation.


# Version 8.5.2 "Crosses" 2015-11-04

## New features and enhancements

* mkvpropedit, MKVToolNix GUI header editor: enhancement: added the "codec delay"
  track header field as an editable property.

## Bug fixes

* MKVToolNix GUI: bug fix: the file/track columns aren't resized to fit their content
  when expanding/collapsing tree nodes anymore. Such expansion also happened when
  moving entries with the "move up/down" buttons. Fixes #1492.
* mkvmerge: bug fix: fixed the values of the "previous/next segment UID" elements
  when splitting by parts with segment linking enabled. Fixes #1497.
* mkvmerge: bug fix: mkvmerge no longer creates a "next segment UID" field in the last
  file when splitting and segment linking is active.
* mkvmerge: bug fix: fixed an endless loop when updating track headers caused by the
  fix for "Re-rendering track headers: data_size != 0 not implemented yet". Fixes
  #1485.


# Version 8.5.1 "Where you lead I will follow" 2015-10-21

## New features and enhancements

* MKVToolNix GUI: header editor enhancement: several track properties like name or
  language are shown as columns in the tree for easier distinction between tracks.
  They're also shown on the overview page on the right when that track's entry is
  selected in the tree. The text in the labels on this overview page can be selected with
  the mouse for copying & pasting elsewhere.

## Bug fixes

* build system: libEBML v1.3.3 and libMatroska v1.4.4 are now required due to
  important fixes for invalid memory accesses in those two releases. The copies
  included in the MKVToolNix source code have been updated to those releases as well.
* MKVToolNix GUI: bug fix: the "save file" dialogs did not have the currently entered
  file name pre-selected anymore. Fixes #1480.
* MKVToolNix GUI: bug fix: fixed a crash when loading corrupted job settings.
* MKVToolNix GUI: header editor bug fix: the tree items weren't re-translated when
  the GUI language was changed.
* mkvmerge: bug fix: updating the track headers wasn't working in some rare cases
  (corresponding error message "Re-rendering track headers: data_size != 0 not
  implemented yet").
* MKVToolNix GUI: bug fix (Linux): the function "open folder" was inserting a
  superfluous leading slash in the directory name. This causes some file managers (in
  this particular case Dolphin on Linux) to interpret a directory name like
  "//home/mosu/…" as a share called "mosu" on a Samba/Windows server called "home"
  and to prepend the whole name with the "smb://" protocol. Fixes #1479.


# Version 8.5.0 "Vanishing Act" 2015-10-17

## New features and enhancements

* MKVToolNix GUI: merge tool enhancement: when dropping files onto the GUI the last
  file's directory is remembered as the last directory a file was opened from causing
  the next open file dialog to start in that directory. Implements #1477.
* all: new feature: added a Catalan translation of the man pages by Antoni Bella Pérez
  (see AUTHORS).
* MKVToolNix GUI: chapter editor enhancement: the start and end timestamps in the
  tree are displayed with nanosecond precision. Implements #1474.
* MKVToolNix GUI: merge tool enhancement: added a column to the track list containing
  the state of the "forced track" flag. Implements #1472.
* MKVToolNix GUI: merge tool enhancement: pressing the delete key in the attachments
  list removes the selected entries. Implements #1473.
* MKVToolNix GUI: enhancement: the context menu for the status bar job status
  counters is now shown when the user clicks with any mouse button, not just the right
  one. This should make the feature easier to discover. Implements #1396.
* MKVToolNix GUI: new job queue feature: added an option in the preferences for
  resetting the warning and error counters of all jobs and the global counters in the
  status bar to 0 when exiting the program. Implements #1437.
* MKVToolNix GUI: current job output enhancement: the separator lines for warnings
  and errors ("--- Warnings emitted by Job … started on … ---") are only shown when
  warnings/errors actually occur and not for each job that's run.
* mkvmerge: enhancement: improved identification output for DTS 96/24. Implements
  #1431.
* MKVToolNix GUI: merge tool enhancement: added buttons for previewing the
  character sets for text subtitles read from SRT and SSA/ASS files as well as for
  chapter files. They're located next to the drop down boxes for the character sets on
  the input and output tabs.
* MKVToolNix GUI: merge tool enhancement: added buttons next to the 'segment UID',
  'previous segment UID' and 'next segment UID' controls that enable the user to
  select a Matroska file. The GUI reads that file's segment UID and enters its value
  into the corresponding control. Part of the implementation of #1363.
* MKVToolNix GUI: chapter editor enhancement: Added another variable to the chapter
  name templates called \<START\> which is replaced by the chapter's start timestamp.
  An optional format can be specified, e.g. \<START:%H:%M:%S.%3n\> resulting in
  something like 01:35:27.734. This can be used in the 'generate sub-chapters' or the
  'renumber sub-chapters' functionality. Implements #1445.
* MKVToolNix GUI: merge tool enhancement: implemented the optional warning before
  overwriting existing files when starting to mux or adding a job to the queue. The
  pending jobs in the queue are checked for the same destination file name as well.
  Implements #1390.
* MKVToolNix GUI: enhancement: pressing the delete key in the chapter editor and the
  job queue removes the selected entries. Implements #1454.
* MKVToolNix GUI: merge tool enhancement: dropping chapter, tag and segment info
  files from external applications will cause those file names to be added to the
  appropriate controls on the 'output' tab. Implements #1332 and 1345.
* MKVToolNix GUI: merge tool enhancement: the feature "default track language" has
  been split into track languages by type. There are now three separate settings for
  audio, video and subtitle tracks. Implements #1338.
* mkvmerge: enhancement: the verbose identification for MP4 files will now derive
  basic audio parameters of MP3 and AC3 tracks from the bitstream instead of relying on
  the values in the track headers.
* MKVToolNix GUI: new merge tool feature: implemented an optional vertical layout
  mode for the "input" tab in which the track properties are shown below the track list.
  Implements #1304.
* MKVToolNix GUI: merge tool enhancement: when browsing for chapter files on the
  "output" tab the initial directory is the first input file's directory instead of
  the directory accessed last.
* MKVToolNix GUI: enhancement: on Windows the drop down boxes were elliding overlong
  text. This has been changed to making the open combo boxes' scroll areas wide enough
  to contain the whole entries. This matches the behavior of Qt on other operating
  systems.
* MKVToolNix GUI: new merge tool feature: added context menu entries for opening the
  selected files/the source files of selected tracks in MediaInfo. Implements
  #1423.

## Bug fixes

* mkvmerge: bug fix: the cropping parameters contained the "cropping:" prefix twice
  in the verbose identification output.
* MKVToolNix GUI: enhancement: if the last directory opened doesn't exist anymore
  then default to one that does in order to prevent an error message from older Windows
  versions about a location not being available. Fixes #1438.
* MKVToolNix GUI: bug fix: the menus that are currently not shown are disabled
  properly so that they don't react to keyboard shortcuts anymore. This affected e.g.
  Alt+J with the English localization as there were three shortcuts active: the "add
  to job queue" button (if the merge tool is active), the "job queue" menu and the "job
  output" menu.
* MKVToolNix GUI: bug fix (Windows): changed some options for Qt's file dialogs in
  order to speed up access to network shares in certain situations. Fixes #1459.
* mkvmerge: bug fix: PCM tracks: if the number of samples per packet varies then no
  default duration will be written. Fixes #1426.
* mkvmerge: new feature: The three options that use segment UIDs (--segment-uid,
  --link-to-previous and --link-to-next) can now read the segment UID of an existing
  Matroska file. For this the file's name must be given as an argument prefixed with =
  (e.g. '--segment-uid =some_file.mkv'). Implements #1363.
* MKVToolNix GUI: merge tool bug fix: If there's currently no source file present when
  the user drags & drops files onto the merge tool then the GUI will no longer leave an
  empty, superfluous tab for certain drop modes. Fixes #1446.
* MKVToolNix GUI: merge tool bug fix: the "default track flag in output" column wasn't
  updated properly directly after loading settings.
* MKVToolNix GUI: merge tool bug fix: the cropping parameters were not converted into
  parameters for mkvmerge at all.
* all: fixed the spelling of the AC-3, E-AC-3 and VC-1 codec names.
* MKVToolNix GUI: bug fix: the interface language selection has been improved not to
  select wrong entries resulting in error messages from mkvmerge about unknown
  translations. Fixes #1434.
* MKVToolNix GUI: bug fix: if the Windows version of the GUI was started from a
  symbolically linked folder then it would crash when the user added a file. Fixes
  #1315.

## Other changes

* all: several ISO 639-2 codes of languages that are very old and not spoken anymore
  have been removed (e.g. "English, Middle (1100-1500)").


# Version 8.4.0 "A better way to fly" 2015-09-19

## New features and enhancements

* MKVToolNix GUI: new merge tool feature: when dragging & dropping files onto merge
  settings already containing a file the user can set more options to be always done
  instead of asking (before: only adding files to the current merge settings could be
  thus marked; now: adding to current, adding to new settings and adding each file to
  new settings can be set to perform without asking). Implements #1388.
* MKVToolNix GUI: merge tool enhancement: when dragging & dropping files onto merge
  settings already containing a file the dialog asking the user what to do has received
  a new option for creating one new merge tab for each of the dropped files. Implements
  #1380.
* MKVToolNix GUI: new merge tool feature: the "tracks" tree view contains a new column
  titled "properties" which contains basic track properties: the pixel dimensions
  for a video track and sampling frequency, number of channels and bits per sample for
  an audio track. Implements #1295.
* mkvmerge: enhancement: the verbose identification result for all audio tracks has
  been extended to include the number of channels, the sample rate and the bits per
  sample where applicable. Part of the implementation of #1295.
* mkvmerge: enhancement: the pixel width/height will be reported in verbose
  identification mode for all video tracks.
* MKVToolNix GUI: new merge tool feature: added a column in the track list showing the
  effective state of the "default track" flag. It shows the state of the flag as it will
  be in the output file. Implements #1353.
* mkvmerge: enhancement: when mkvmerge encounters garbage data in the middle of AC-3
  or MP3 tracks it will now output the timecode where the garbage occurred in order to
  make checking for audio/video sync issues easier. Implements #1420.
* MKVToolNix GUI: chapter editor enhancement: added a column in the tree with the
  edition's/chapter's flags.
* MKVToolNix GUI: new feature: the state of all columns in all list/tree views can be
  reset (both the shown/hidden state as well as their order) from the column's context
  menu. See #1268.
* MKVToolNix GUI: new feature: the column headers of all list/tree views can be
  re-ordered via drag & drop and the GUI will remember their position upon restart.
  Additionally the columns can be hidden/shown via a context menu by right-clicking
  on the column headers. Implements #1268.
* MKVToolNix GUI: new chapter editor feature: added an option for skipping chapters
  marked as "hidden" in the re-numbering dialog. Implements #1414.
* all: new feature: added a new translation to Serbian (Cyrillic) by Jay Alexander
  Fleming (see AUTHORS).
* MKVToolNix GUI: enhancement: the header editor will convert ISO 639-2 terminology
  codes used in language elements to their corresponding bibliographic variants.
  Implements #1418.
* MKVToolNix GUI: enhancement: the titles and button texts of dialogs asking
  questions have been improved to be easier understandable. For example, instead of
  using "yes/no" as the answers to the question "Do you want to close the unmodified
  file?" the choices are now "Close file/Cancel". Implements #1417.
* MKVToolNix GUI: chapter editor enhancement: when loading simple/ OGM style
  chapter files that contain non-ASCII characters and which do not start with a byte
  order mark (BOM) the GUI will let the user chose the character set to use. A preview is
  shown for the selected character set and updated when the user changes the character
  set.
* MKVToolNix GUI: merge tool enhancement: added "remove all" and "select all"
  entries to the attachments context menu. Implements #1386.
* MKVToolNix GUI: job output enhancement: the output, warnings and error text views
  are now separated by two splitters enabling the user to change their respective
  sizes. These changes are remembered over restarts. Implements #1394.
* MKVToolNix GUI: chapter editor enhancement: pressing shift+return will cause the
  next appropriate chapter control to be selected depending on where the focus
  currently is: from a chapter input (start/end time, flags, UIDs) to the next chapter
  entry's start time, from a chapter name to the next chapter name and from the last
  chapter name to the next chapter entry's first chapter name. Implements #1398 and
  complements #1358.
* MKVToolNix GUI: chapter editor enhancement: pressing return on the very last
  chapter entry will wrap and focus the first one in the tree again. Enhances #1358.
* MKVToolNix GUI: enhancement: scrolling over input elements like combo boxes,
  check boxes and radio buttons located within a scroll area will now scroll the scroll
  area instead of the element the cursor is over (e.g. a combo box). Implements #1400.

## Bug fixes

* MKVToolNix GUI: chapter editor bug fix: whenever the additional modification of
  "expanding start/end timecodes to include the minimum/maximum timecodes of their
  children" was run on an edition entry then ChapterTimeStart and sometimes
  ChapterTimeEnd nodes were inserted as direct children of the EditionEntry node
  when saving. This resulted in invalid chapters.
* mkvmerge: bug fix: the pixel dimensions reported for VC-1 in MPEG transport streams
  in verbose identification mode was 0x0.
* mkvmerge: bug fix: the number of channels and the sample rate reported for DTS in MPEG
  transport streams and MPEG program streams in verbose identification mode was 0.
* all: bug fix: parsing of strings containing negative values or timecodes was broken
  on 32bit architectures. Fixes #1425.
* MKVToolNix GUI: merge tool bug fix: if the output file name policy "last output
  directory" was used then manual changes to the output file name weren't recognized
  as changes to the last output directory. Fixes #1411.
* MKVToolNix GUI: merge tool bug fix: the "default subtitle charset" is not applied to
  text subtitles from Matroska files as those are always encoded in UTF-8. Fixes
  #1416.
* MKVToolNix GUI: chapter editor bug fix: the "shift timecodes" action in the mass
  modification dialog wasn't working at all, and selecting multiple actions in the
  dialog would result in wrong actions being executed.
* MKVToolNix GUI: bug fix: fixed the total job queue progress with respect to removing
  completed jobs (either automatically or manually). Fixes #1405.
* MKVToolNix GUI: bug fix: mkvmerge is now run in with the same interface language set
  for the GUI.
* mkvmerge: bug fix: The formula used for calculating the audio delay for garbage data
  at the start of tracks in AVI files has been fixed again. It now uses the values
  dwStart, dwScale and dwSampleSize from the AVI stream header structure instead of
  values derived from the audio packet headers. Fixes #1382 and still works correctly
  for #1137.
* all: the environment variable \<TOOLNAME\>_OPTIONS is now parsed for options for
  TOOL (e.g. MKVMERGE_OPTIONS for mkvmerge). MKVTOOLNIX_OPTIONS is still used for
  all programs. Fixes #1403.
* MKVToolNix GUI: bug fix: fixed the escaping of the command line for cmd.exe
  regarding the command name itself (the very first argument). Fixes #1401.
* build system: bug fix: fixed Qt platform plugin detection on MacOS.

## Build system changes

* build system: removal: the switch "--without-mkvtoolnix-gui" has been removed.
  There are only two GUIs left in the package: the Qt-enabled mkvinfo and MKVToolNix
  GUI. Both are enabled by default and can be disabled with the option "--disable-qt".
  In that case only the text-mode version of mkvinfo is built, and the MKVToolNix GUI is
  not built at all.

## Other changes

* mkvmerge: container and track properties in verbose identification mode are now
  output sorted.
* mkvmerge: the verbose identification result for the MPEG program stream, MPEG
  transport stream and WAV readers has been changed for audio tracks in order to match
  the Matroska reader's result. The old keys "channels", "sample_rate" and
  "bits_per_sample" have been replaced by "audio_channels",
  "audio_sampling_frequency" and "audio_bits_per_sample".
* Removal: all support for wxWidgets has been removed. This means that the mkvmerge
  GUI (mmg) has been removed and that mkvinfo now only supports a text-mode and a
  Qt-based interface.


# Version 8.3.0 "Over the Horizon" 2015-08-15

## New features and enhancements

* MKVToolNix GUI: chapter editor enhancement: pressing return will cause the next
  appropriate chapter control to be selected depending on where the focus currently
  is: from a chapter input to the first chapter name, from a chapter name to the next
  chapter name and from the last chapter name to the next chapter entry's start time.
  Implements #1358.
* MKVToolNix GUI: enhancement: the number of running jobs is shown in the status bar.
  Implements #1381.
* MKVToolNix GUI: new job queue feature: added a context menu for force-starting
  selected jobs. This allows for running more than one job at the same time. Implements
  #1395.
* MKVToolNix GUI: new merge tool feature: added an option for automatically setting
  the "default track" flag to "no" for all subtitle tracks when they're added.
  Implements #1339.
* MKVToolNix GUI: new merge tool feature: dragging & dropping files onto line edit
  controls that expect file names (e.g. the "chapter file" control) will set that line
  edit's text to the dropped file name. Implements #1344.
* MKVToolNix GUI: new feature: jobs in the queue can now be edited again. For that
  they're re-opened in the corresponding tool and removed from the queue. Implements
  #1296.
* MKVToolNix GUI: enhancement: the format of the setting and queue files has been
  changed from INI style to JSON documents. Reading older setting files in INI style
  remains supported, but saving will convert them to JSON. Together with the other
  three changes mentioned below this results in a noticeable reduction in the time
  needed for writing the queue files, e.g. when pressing "start muxing" or when
  quitting the application.
* MKVToolNix GUI: enhancement: the way the job queue is stored has been changed.
  Earlier all jobs were stored in the same file (or registry on Windows) as the
  preferences. Now they're stored in a sub directory called "jobQueue" with one file
  per queue entry.
* MKVToolNix GUI: enhancement: on Windows the preferences are not stored in the
  registry anymore, not even if the application has been installed. Instead they're
  stored in an INI file in the user's AppData\Local directory tree.
* MKVToolNix GUI: enhancement: the number of times the queue files are saved has been
  reduced. The queue files are also loaded only once on startup, not twice.
* MKVToolNix GUI: enhancement: if an instance is already running when the
  application is started a second time then the GUI requests that the already-running
  instance will be activated. Implements #1379.
* MKVToolNix GUI: new feature: added an option in the preferences for automatically
  switching to the job output tool whenever the user starts a job (e.g. by pressing
  "start muxing"). Implements #1376.
* MKVToolNix GUI: new job output and job queue feature: added a function for opening
  the output folder. Implements #1342.
* MKVToolNix GUI: new job output tool feature: added a way to clear the output,
  warnings and errors views. Implements #1356.
* MKVToolNix GUI: merge tool enhancement: added "Simple OGM-style chapter files
  (*.txt)" to the file selection dialog when selecting a chapter file. Implements
  #1269.

## Bug fixes

* mkvmerge: bug fix: track statistics tags can be kept with the option "--engage
  keep_track_statistics_tags". This allows outputting them in verbose
  identification mode for easier parsing. Fixes #1351.
* MKVToolNix GUI: bug fix: fixed various crashes when dragging & dropping in all of the
  tree views (merge tool: files view, tracks view, attachments view; chapter editor:
  edition/chapter tree, chapter name list; job queue). Fixes #1365.
* MKVToolNix GUI: merge tool bug fix: attachments: sometimes changing values didn't
  apply the changes to all selected attachments depending on how they were selected.
  Fixes #1373.
* MKVToolNix GUI: merge tool bug fix: the automatically suggested description for
  new jobs contained the file name twice, even in the directory portion. Fixes #1378.
* MKVToolNix GUI: merge tool bug fix: if "set output file name automatically" is
  enabled then file names ending with a number in parenthesis (e.g. "Berlin
  (1962).mkv") will keep their number in the generated output file name. Fixes #1375.
* MKVToolNix GUI: merge tool bug fix: the GUI will keep manual changes to the output
  file name even if "set output file name automatically" is enabled. Fixes #1372.
* MKVToolNix GUI: bug fix: fixed the stereoscopy drop down box not being
  re-translated when the GUI language is changed. Fixes #1224.
* MKVToolNix GUI: chapter editor bug fix: it was possible to drop chapter entries on
  the top-level reserved for editions. Fixes #1369.
* MKVToolNix GUI: bug fix: fixed compilation when building without curl support.
  Fixes #1359.

## Build system changes

* build system: stack protection is enabled when building with gcc on all platforms.
  For Windows DEP and ASLR is enabled. Implements #1370.
* build system: the Boost detection macros were updated from www.gnu.org resulting
  in better compatibility with bare-bones shells like dash.

## Other changes

* MKVToolNix GUI: Windows: if the application has been installed then its settings
  will no longer be saved in the registry but in an INI file in the user's data
  application folder (e.g.
  C:\Users\mbunkus\AppData\Local\bunkus.org\mkvtoolnix-gui).


# Version 8.2.0 "World of Adventure" 2015-07-18

## New features and enhancements

* MKVToolNix GUI: chapter editor enhancement: the template for chapter names can now
  contain a number of places for the chapter number, e.g. '\<NUM:3\>'. The number will be
  zero-padded if there are less places than specified.
* MKVToolNix GUI: new chapter editor feature: implemented a function for
  renumbering chapters. This allows the user to automatically assign new chapter
  names to one level of sub-chapters with ascending numbers. Implements #1355.
* MKVToolNix GUI: new feature: the position of the tab headers of all tab widgets can be
  changed in the preferences. Implements #1334.
* MKVToolNix GUI: new feature: added an option for hiding the tool selector.
* MKVToolNix GUI: new job queue feature: added menu options for stopping the queue
  either immediately or after the current job has finished. Implements #1303.
* MKVToolNix GUI: new job queue feature: added a context menu option for setting jobs
  to status "pending manual start".
* MKVToolNix GUI: new merge tool feature: added context menu options for selecting
  all tracks of a specific type (e.g. all audio tracks). Implements #1197.
* MKVToolNix GUI: merge tool enhancement: the dialog shown after dragging & dropping
  files from external applications asking if those files should be added or appended
  now has an option to always add and never to show that dialog again. For new MKVToolNix
  installations the default is now to show this dialog again until the user
  deactivates it either in the dialog or in the preferences.
* MKVToolNix GUI: new feature: added additional ways to move selected files, tracks
  and attachments around: keyboard shortcuts (Ctrl+Up and Ctrl+Down) and optional
  buttons (those have to be enabled in the preferences). Using drag & drop remains
  possible. Implements #1279.
* MKVToolNix GUI: new merge tool feature: dragging files from external applications
  now allows you to create new mux settings and add the dropped files to those if the
  "always add dropped files" option is off. Implements #1297.
* MKVToolNix GUI: new feature: added support for displaying the queue progress on the
  task bar button. Implements #1335.
* MKVToolNix GUI: new merge tool feature: implemented support for re-ordering new
  attachments via drag & drop. Implements #1276.
* docs: added a Spanish translation of the man pages by Israel Lucas Torrijos (see
  AUTHORS).
* MKVToolNix GUI: enhancement: several drop down boxes have had their options
  renamed slightly to be more consistent overall and easier to select via the
  keyboard. Implements #1309.
* MKVToolNix GUI: enhancement: position and size of the several additional windows
  are saved and restored. These include: the preferences window, the dialog for
  additional command line options, the dialog showing the command line and the dialog
  for selecting the playlist to add. Implements #1317.
* MKVToolNix GUI: enhancement: the relative sizes of all splitters are saved and
  restored. Implements #1306.

## Bug fixes

* mkvmerge, MKVToolNix GUI: bug fix: fixed the container type not being recognized
  properly by the GUI. Now the numerical container type ID is output in verbose
  identification mode by mkvmerge.
* MKVToolNix GUI: chapter editor bug fix: the file is not kept open so that you can open
  it in other applications at the same time.
* MKVToolNix GUI: bug fix: if a GUI language other than English was selected then the
  warning/error messages output by mkvmerge were not recognized properly and output
  in the wrong text views.
* MKVToolNix GUI: merge tool bug fix: fixed loading saved settings in which an
  appended file contains chapters/tags/attachments.
* mkvmerge: bug fix: fixed handling of MPEG transport streams where all PATs and PMTs
  have CRC errors. Fixes #1336.
* MKVToolNix GUI: bug fix: fixed the command line option used when the "fix bitstream
  timing info" check box is checked. Fixes #1337.
* MKVToolNix GUI: fix compilation with the upcoming Qt 5.5.0. Fixes #1328.
* MKVToolNix GUI: job queue bug fix: when re-starting a job the "date finished" field
  wasn't reset. Fixes #1323.
* MKVToolNix GUI: merge tool bug fix: the option "set output file name relative to
  first input file" caused the relative path to be applied each time a file was added
  resulting in the wrong directory. Fixes #1321.
* MKVToolNix GUI: merge tool bug fix: when adding a Blu-ray playlist and aborting the
  "select playlist to add" dialog the originally opened playlist was added even so.
* mkvmerge: bug fix: the MPEG-1/2 video code was causing an illegal memory access
  under certain conditions. Fixes #1217 and #1278.
* MKVToolNix GUI: bug fix: the "default subtitle character set" combo box required a
  selection without an option for using the system's default. An entry "– no selection
  by default –" has been added at the top.
* MKVToolNix GUI: bug fix: fixed parsing command line arguments to an
  already-running instance on Windows. Fixes #1322.
* MKVToolNix GUI: bug fix: fixed the combo boxes with languages, countries and
  character sets not being re-initialized after changes to the list of common
  languages/countries/character sets in the preferences. Fixes #1224.
* MKVToolNix GUI: chapter editor bug fix: fixed the menu entries "save to XML file" and
  "save to Matroska file" not being available after loading chapters until the tool or
  tab was changed. Fixes #1312.
* MKVToolNix GUI: bug fix: fixed labels and therefore the window becoming
  excessively wide with long file names. Fixes #1314.
* MKVToolNix GUI: merge tool bug fix: fixed the focus marker around combo boxes inside
  scroll areas not being drawn. Fixes #1310.
* MKVToolNix GUI: merge tool bug fix: fixed the stereoscopy mode being off by one.
  Fixes #1311.
* MKVToolNix GUI: merge tool bug fix: fixed the --append-to calculation if more than
  one file has been appended. Fixes #1313.


# Version 8.1.0 "Psychedelic Postcard" 2015-06-27

## Important notes

* mmg: bug fix: the deprecation warning will only be shown once. Fixes #1252.

## New features and enhancements

* MKVToolNix GUI: merge tool enhancement: moved the "output file name" controls
  below the three tabs so they're always visible. Also added an option in the
  preferences to move them back inside the "output" tab. Implements #1266.
* MKVToolNix GUI: new chapter editor feature: added a function for generating a
  certain number of evenly spaced sub-chapter. Implements #1291.
* MKVToolNix GUI: new chapter editor feature: implemented loading chapter entries
  from Blu-ray playlists.
* MKVToolNix GUI: job queue enhancement: added menu entries for acknowledging both
  warnings and errors at the same time.
* MKVToolNix GUI: new watch jobs tool feature: the first tab showing the output of the
  current job has been changed to show the output of all jobs that have been run since the
  GUI's been started. This can be turned off in the preferences so that only the output
  of the currently running job is shown again. Implements #1263.
* MKVToolNix GUI: new merge tool feature: added an option to set a directory relative
  to the first input file as the default output directory. Implements #1261.
* MKVToolNix GUI: new feature: added a check box to the
  track/chapters/tags/attachments list. This offers an additional way of toggling
  the "mux this" state of entries, same as the drop down box on the right and as
  double-clicking on the item already did. Implements #1277.
* MKVToolNix GUI: new feature: added an option for always using the suggested
  description and not asking the user when adding a job to the queue. Implements #1288.
* MKVToolNix GUI: job queue enhancement: added the shortcut Ctrl+R for the menu entry
  "start all pending jobs". Implements #1287.
* MKVToolNix GUI: new feature: added an option to always treat files dragged & dropped
  external applications as being added circumventing the question what to do with
  them (add, append or add as additional parts). This option is enabled by default
  changing the default behavior from release 8.0.0. Implements #1259.
* MKVToolNix GUI: new feature: added an optional action after starting a job or adding
  one to the queue. This can be either to create whole new settings or to only remove all
  input files. Implements #1254.
* Installer for Windows: enhancement: associated the .mtxcfg files with MKVToolNix
  GUI. Implements #1258.
* MIME and desktop files: enhancement: added file associations for .mtxcfg with
  MKVToolNix GUI. Implements #1258.
* MKVToolNix GUI: new feature: implemented command line handling. You can open
  configuration files, add files to merge jobs, open files in the chapter or header
  editors. Implements #1209.

## Bug fixes

* mmg: bug fix: fixed handling of the characters [ and ] in container and track
  properties.
* MKVToolNix GUI: merge tool bug fix: fixed various menu entries not working
  correctly after closing a tab or switching to another one. Fixes #1301.
* MKVToolNix GUI: merge tool bug fix: if "automatically set the file title" is enabled
  then the title field will be cleared after all source files have been removed.
* MKVToolNix GUI: merge tool bug fix: fixed a crash when enabling/disabling chapters
  coming from an appended file. Fixes #1293.
* MKVToolNix GUI: merge tool bug fix: it was possible to set the "default track flag" to
  "yes" for multiple tracks of the same type. Fixes #1289.
* MKVToolNix GUI: enhancement: the "open file" dialogs for the chapter and header
  editor tools will use the same directory that was last used in the merge tool. Fixes
  #1290.
* MKVToolNix GUI: bug fix: fixed reading the "default track" flag of tracks from added
  Matroska files. Fixes #1281.
* MKVToolNix GUI: merge tool bug fix: when appending files with multiple tracks of a
  type (e.g. multiple audio tracks) then all tracks of that kind would get assigned to
  the first track of that kind of the file they're appended to. Now the second audio
  track from the appended file is appended to the second audio track of the existing
  file, the third to the third etc. Fixes #1257.
* MKVToolNix GUI: merge tool bug fix: fixed automatic output file name re-generation
  when the mux status of tracks changes. Fixes #1253.
* mkvmerge: bug fix: fixed recognition of (E)AC-3 audio tracks using a FourCC of
  "ec-3". Fixes #1272.
* MKVToolNix GUI: merge tool bug fix: fixed attachments not being merged into the file
  in certain situations. Fixes #1260.
* MKVToolNix GUI: merge tool bug fix: fixed showing existing attachments present in
  source files in the "tracks, chapters, tags and attachments" list. Fixes #1256.
* MKVToolNix GUI: merge tool bug fix: the jobs created when appending files were
  incorrect resulting in an error message from mkvmerge. Fixes #1271.
* mkvpropedit: bug fix: fixed a warning about "edit specifications resolving to the
  same track" when changing the track properties and setting tags for the same track
  simultaneously. Fixes #1247.
* MKVToolNix GUI: merge tool bug fix: the output/destination file name is cleared
  when all files are removed. Fixes #1265.
* MKVToolNix GUI: merge tool bug fix: fixed command line escaping for empty
  arguments. Fixes #1270.
* MKVToolNix GUI: merge tool bug fix: fixed creating files without a title if one of the
  input files contains a file title. Fixes #1264.
* MKVToolNix GUI: bug fix: if the job removal policy is set to "remove even if there were
  warnings" then jobs that were muxed without warnings weren't removed. Fixes #1262.
* Build system: fixed inclusion of desktop files for the two GUIs for Debian/Ubuntu
  packages. Fixes #1255.


# Version 8.0.0 "Til The Day That I Die" 2015-06-19

## New features and enhancements

* MKVToolNix GUI: merge tool enhancement: drag & drop of files works even if no mux
  settings are currently open. Implements #1245.
* MKVToolNix GUI: job output enhancement: when clicking the "abort" button the GUI
  asks for confirmation before aborting. Both this check and the one when quitting the
  application can be turned off via an option in the preferences. Implements #1238.
* MKVToolNix GUI: new merge tool, header & chapter editor features: the GUI will ask
  for confirmation before closing or reloading tabs that have been modified and
  before quitting if there are modified tabs. This check can be disabled in the
  preferences. Implements #1211.
* MKVToolNix GUI: new merge tool feature: implemented an option that allows the user
  to set up a list of languages. When adding files only those tracks whose language is
  included in that list are set to be muxed by default. Implements #1227.
* MKVToolNix GUI: new feature: added an option in the preferences for disabling
  additional lossless compression for all track types. Implements #1174.
* mkvmerge, MKVToolNix GUI: new feature: added an option ("--engage
  keep_last_chapter_in_mpls") that will cause mkvmerge not to remove the last
  chapter entry from a Blu-ray play list file which mkvmerge normally does if that
  entry's timecode is within five seconds of the movie's end. Implements #1226.
* MKVToolNix GUI: new watch jobs tool feature: implemented estimating the remaining
  time for both the current job and the whole queue.
* MKVToolNix GUI: enhancement: the following dialogs can now be maximized: the
  "preferences" dialog; the "additional command line options" dialog; the dialog
  showing the command line; the dialog where the user selects the play list to add.
  Implements #1231.
* MKVToolNix GUI: merge tool enhancement: pressing delete when the source files view
  is focused will cause the selected source files to be removed. Implements #1225.
* MKVToolNix GUI: merge tool enhancement: implemented toggling of "mux this" for all
  selected tracks by either double-clicking on the tracks or pressing enter/return
  when the tracks view is currently focused. Implements #1225.
* MKVToolNix GUI: job queue enhancement: added a menu entry for starting all jobs
  pending manual start. Implements #1228.
* MKVToolNix GUI: enhancement: the text in all message box dialogs can now be selected
  & copied, even on Windows. Implements #1230.
* all: the detection whether or not the applications are installed on Windows is done
  by checking for the presence of a special file in the program folder instead of
  checking for an entry in the registry written by the installer. This enables users to
  try new portable versions without having to uninstall an installed version first as
  their settings will be kept separate now. A side effect is that compatibility with
  Windows XP should be restored. Implements #1229.
* mkvmerge: enhancement: if running in GUI mode (parameter "--gui-mode") then the
  progress will be output as the untranslated "#GUI#progress …%" in order to
  facilitate parsing of progress by GUIs.
* MKVToolNix GUI: new feature: added a "help" menu with links to several parts of the
  MKVToolNix documentation. Implements #1195.
* MKVToolNix GUI: job output tool: added a button for acknowleding the
  warnings/errors produced for the job shown. Implements #1210 and is the last part of
  the implementation of #1196.
* MKVToolNix GUI: enhancement: header editor: made the meaning of the "Reset" button
  clearer with a better label and an additional tool tip. Implements #1212.
* MKVToolNix GUI: enhancement: the tabs for the tools that haven't been implemented
  yet (extraction, info and the tag editor) are not shown anymore.
* MKVToolNix GUI: enhancement: the update check dialog showing the change log can now
  be maximized. Implements #1204.
* MKVToolNix GUI: new feature: implemented viewing the output of any job in the job
  queue.
* MKVToolNix GUI: new feature: implemented saving the job output to a file.
* MKVToolNix GUI: enhancement: language and country drop-down boxes will contain
  the common languages/countries both at the top as well as in the full list. Part of the
  implementation of #1200.
* MKVToolNix GUI: enhancement: the entry "Undefined (und)" is always shown at the top
  of the language drop-down boxes. Part of the implementation of #1200.
* MKVToolNix GUI: enhancement: the number of new warnings and errors are shown in the
  status bar. Both counters can be acknowledged via context menus on the status bar and
  in the job queue view. Part of the implementation of #1199.
* MKVToolNix GUI: enhancement: the number of jobs pending automatic/manual
  execution is listed in the status bar. Part of the implementation of #1199.
* MKVToolNix GUI: enhancement: the progress widget in the stats bar is not reset to 0
  once all the jobs have been processed in order to signal the user that the jobs have
  actually been processed. Part of the implementation of #1198.
* MKVToolNix GUI: merge tool enhancement: a short animation of a moving icon is shown
  when a job is started or added to the job queue as a clue to the user what's happening and
  where to look for output. This animation can be disabled in the preferences.
  Implements #1198.
* MKVToolNix GUI: chapter editor enhancements: when selecting a chapter the the
  chapter name closest to the previously selected chapter name (or the first if there
  wasn't a previously selected one) is selected automatically.
* MKVToolNix GUI: chapter editor enhancements: when starting a new file a single
  edition and a single chapter are added automatically.
* MKVToolNix GUI: merge tool enhancement: the "add files" button has been re-labeled
  "add source files" in order to make it clearer that it cannot be used for adding
  attachments, even if the attachments tab is the currently selected tab.
* MKVToolNix GUI: merge tool & job queue tool enhancement: short tool tips will be
  shown for the files, tracks, attachments and jobs views telling the user to
  right-click for adding files and similar actions.
* MKVToolNix GUI: new feature for the merge tool, the header and chapter editors: if no
  file is open then "new" and "open file" buttons are shown.

## Bug fixes

* MKVToolNix GUI: improved locating the mkvmerge executable on non-Windows
  systems. Fixes #1246.
* MKVToolNix GUI: chapter editor bug fix: dragging & dropping a file onto the chapter
  editor that cannot be parsed as chapters was causing a confusing warning about
  changed chapters not being saved.
* MKVToolNix GUI: merge tool bug fix: fixed several controls not changing their
  language correctly when the interface language is changed.
* mkvmerge: bug fix: fixed codec identification for MP2 audio read from MPEG
  program/transport streams. Fixes #1242.
* MKVToolNix GUI: job output bug fix: fixed displaying the estimated remaining time
  in tabs that have been opened for specific jobs. Fixes #1244.
* MKVToolNix GUI: header editor bug fix: fixed the editor assuming values were
  changed if a track is present whose language element is not present in the file. Fixes
  #1240.
* MKVToolNix GUI: bug fix: fixed the translation of the tool tip for the "close tab"
  buttons after changing the interface language. Fixes #1237.
* MKVToolNix GUI: bug fix: appended tracks will be disabled automatically when
  starting to mux if the track they're appended to has been disabled by the user.
* MKVToolNix GUI: fixed updating the number of pending jobs info in the status bar when
  manually starting jobs. Fixes #1236.
* MKVToolNix GUI: merge tool bug fix: fixed a crash when removing source files. Fixes
  #1235.
* MKVToolNix GUI: merge tool bug fix: the default settings for the "output directory
  policy" was changed to "same directory as the first input file". Fixes #1234.
* MKVToolNix GUI: bug fix: on Windows the job queue was accidentally always saved to
  and loaded from the registry even if the portable version was used.
* MKVToolNix GUI: job queue bug fix: fixed accidental duplication of lines when using
  drag & drop in certain ways. Fixes #1221.
* MKVToolNix GUI: bug fix: if a job is running when the user wants to quit requires
  confirmation from the user that the running job should be aborted. Fixes #1219.
* MKVToolNix GUI: bug fix: fixed the initial status display when viewing a job's
  output from the queue.
* MKVToolNix GUI: bug fix: running jobs cannot be removed from the job queue anymore.
  Fixes #1220.
* MKVToolNix GUI: bug fix: when starting the GUI old jobs from the queue were silently
  discarded if they included additional parts (e.g. VOBs).
* MKVToolNix GUI: bug fix: job queue: when saving the job queue jobs removed in the GUI
  were not removed from the stored settings.
* MKVToolNix GUI: bug fix: when viewing the job output of a job that hasn't been run yet
  the "save output" button was enabled.
* mkvmerge, mkvpropedit: bug fix: fixed an invalid memory access leading to a crash in
  the Base 64 decoder. Fixes #1222.
* MKVToolNix GUI: bug fix: fixed progress parsing for interface languages other than
  English.
* mkvmerge: bug fix: fixed key frame designation for video tracks in MP4 DASH files.
* mkvmerge: bug fix: the track statistics tags of Matroska source files are always
  discarded, no matter whether or not they're to be created for the output file. That
  way they won't be reported as track tags by mkvmerge's identification mode. This
  makes it easier for the user to create output files without track statistics tags as
  (s)he only has to use the option "--disable-track-statistics-tags" and not
  disable all the track tags as well anymore. Fixes #1186.
* mkvmerge, mkvinfo, mkvextract: bug fix: fixed a crash with certain types of invalid
  Matroska files. Fix for #1183.
* all: bug fix: removed some unused code thereby fixing compilation on OpenBSD
  (#1215).
* MKVToolNix GUI: bug fix: fix alignment of the tool contents with the tool selector at
  the bottom. Fixes #1194.
* MKVToolNix GUI: bug fix: header editor: fixed the track language shown if the
  element is not present in the file.
* MKVToolNix GUI: bug fix: when browsing the output file name the currently entered
  file name is pre-selected in the dialog. Fixes #1207.
* MKVToolNix GUI: job output bug fix: fixed superfluous empty lines in job
  output/warning/error output.
* MKVToolNix GUI: merge tool bug fix: when adding a VOB from a DVD the tree items for the
  additional parts (the other VOBs processed automatically) weren't shown.
* MKVToolNix GUI: merge tool: fixed the scroll bar not disappearing in the input tab if
  the window is high enough. Fixes #1193.
* build system: desktop files and icons were only installed if wxWidgets was enabled.
  Fixes #1188.
* man pages: clarify functionality of --default-duration. Fixes #1191.
* build system: bug fix: fixed running rake if no locale or one with an encoding other
  than UTF-8 is set. Fixes #1189.

## Other changes

* MKVToolNix GUI: merge tool: the "save" button has been removed in favor of the
  "save…" menu entries. This also improves consistency with the other tools.


# Version 7.9.0 "Birds" 2015-05-10

## New features and enhancements

* MKVToolNix GUI: new feature: added context menu entries for tracks: "select all",
  "enable all" and "disable all".
* MKVToolNix GUI: new feature: implemented aborting the currently running job.
* MKVToolNix GUI: new feature: implemented the "additional command line options"
  dialog.
* MKVToolNix GUI: new feature in the chapter editor: added features "set the
  language/country of the selected chapter and its sub-chapters".
* MKVToolNix GUI: new feature in the chapter editor: added features "clamping time
  stamps of sub-chapters to their parent's time stamps", "expanding time stamps of
  chapters to encompass their sub-chapters' time stamps" and "shifting start and end
  time stamps by an offset".
* MKVToolNix GUI: new feature: the main window's size, position and state
  (maximized/minimized) is saved on exit and restored on startup.
* MKVToolNix GUI: new feature: the GUI is now fully translatable. The German
  translation has been completed for the GUI, too.
* MKVToolNix GUI: new feature: implemented changing the interface language.
* MKVToolNix GUI: enhancement: implemented often used subtitle character sets.
* MKVToolNix GUI: enhancement: implemented setting a user configurable subtitle
  character set by default.
* MKVToolNix GUI: enhancement: implemented the automatic removal of jobs
  configurable by the user.
* mkvmerge: enhancement for MPEG program stream handling: mkvmerge will only look
